-- create index on virtualdisk that we can reference
create unique index virtualdisk_id_idx on tnt_config.virtualdisk (id);
drop table if exists tnt_config.virtualdisk_datastore;
create table tnt_config.virtualdisk_datastore (
        virtualdisk_id int not null references tnt_config.virtualdisk (id) on delete cascade on update cascade,
        datastore_id int not null references tnt_config.datastore (id) on delete cascade on update cascade,
        creation_time timestamp not null default current_timestamp,
        delete_time timestamp
) Without Oids;
create unique index virtualdisk_datastore_virtualdisk_id_idx on tnt_config.virtualdisk_datastore (virtualdisk_id) where (delete_time is null);
alter table tnt_config.virtualdisk_datastore owner to impadmin;
grant select on table tnt_config.virtualdisk_datastore to reports;
insert into tnt_config.virtualdisk_datastore (
        select id, datastoreid from tnt_config.virtualdisk where datastoreid is not null
);
-- rollback creation_time so any historical queries at least match current entry
update tnt_config.virtualdisk_datastore set creation_time = '1970-01-01 00:00:00'::timestamp;
-- cleanup old constraints
-- to be done later
alter table tnt_config.virtualdisk drop constraint virtualdisk_pkey;
alter table tnt_config.virtualdisk ALTER COLUMN datastoreid DROP NOT NULL;
--drop index tnt_config.virtualdisk_datasourceid_idx;
--alter table tnt_config.virtualdisk drop column datastoreid;
