INSERT INTO tnt_config.rollup_rules VALUES ('app_launch_delay_1ms', 'double precision', 'average of app launch delay where delay >= 1ms', 'GROOVY', 'def sum = 0; def count = 0; if (summaryReport.getApplicationStatistics() != null) { for (appStat in summaryReport.getApplicationStatistics()) { if (appStat.isFirstRecord() && appStat.getLaunchDelayMs() >= 1) { sum += appStat.getLaunchDelayMs(); count++; } } }; return (count > 0) ? sum / count : null;', 'def count = 0; if (summaryReport.getApplicationStatistics() != null) { for (appStat in summaryReport.getApplicationStatistics()) { if (appStat.isFirstRecord() && appStat.getLaunchDelayMs() >= 1000) { count++; } } }; return count > 0 ? count : null;', 'tnt_audit.summaryreports', true, 'NEW_DATA_ONLY', null, null);
INSERT INTO tnt_config.rollup_rules VALUES ('app_launch_delay_1ms', 'double precision', 'average of app launch delay where delay >= 1ms', 'SQL', '
update

tnt_audit.summaryreports sumrpt

set app_launch_delay_ms = iq.avg_app_launch_delay_ms
from (
	select
	sumrpt.node_id,
	sumrpt.start_date,
	sumrpt.end_date,
	avg(pr_stats.launch_delay_ms) as avg_app_launch_delay_ms 

	from tnt_audit.summaryreports sumrpt

	join tnt_audit.summaryreport_process_stats pr_stats on (
		sumrpt.node_id = pr_stats.node_id and
		sumrpt.start_date = pr_stats.start_date and
		sumrpt.end_date = pr_stats.end_date
		and pr_stats.first_record = true 
		and pr_stats.launch_delay_ms >= 1
	)

	group by sumrpt.node_id, sumrpt.start_date, sumrpt.end_date
) as iq

where sumrpt.app_launch_delay_ms is null and (sumrpt.node_id = iq.node_id and sumrpt.start_date = iq.start_date and sumrpt.end_date = iq.end_date)
', '
update

tnt_audit.summaryreports sumrpt

set app_launch_delay_ms_count = iq.count
from (
        select
        sumrpt.node_id,
        sumrpt.start_date,
        sumrpt.end_date,
        count(pr_stats.*) as count 

        from tnt_audit.summaryreports sumrpt

        join tnt_audit.summaryreport_process_stats pr_stats on (
                sumrpt.node_id = pr_stats.node_id and
                sumrpt.start_date = pr_stats.start_date and
                sumrpt.end_date = pr_stats.end_date
		and pr_stats.first_record = true
		and pr_stats.launch_delay_ms >= 1
        )

        group by sumrpt.node_id, sumrpt.start_date, sumrpt.end_date
) as iq

where sumrpt.app_launch_delay_ms is not null and (sumrpt.node_id = iq.node_id and sumrpt.start_date = iq.start_date and sumrpt.end_date = iq.end_date)
', 'tnt_audit.summaryreports', true, 'OLD_DATA_ONLY', null, null);
