create or replace function tnt_config.create_vcops_user() 
returns integer as
'
declare
        tableCount int;
        sName text;
        tName text;
begin
        create role vcops login password ''lwl_vcops'';
        tableCount := 0;
        for sName in select unnest(ARRAY[''tnt_config'',''tnt_audit'']) loop
                execute ''grant usage on schema '' || sName || '' to vcops'';
                --raise warning ''Added vcops user to tables in schema %'', sName;
                for tName in select tablename from pg_tables where schemaname = sName loop
                        --raise warning ''Added vcops user to table: %'', tName;
                        execute ''grant select on '' || sName || ''.'' || tName || '' to vcops'';
                        tableCount = tableCount + 1;
                end loop;
        end loop;

        return tableCount;
end
'
Language 'plpgsql'
 Volatile
 Called On Null Input
 Security invoker;

select tnt_config.create_vcops_user();
drop function tnt_config.create_vcops_user();
