CREATE TABLE tnt_audit.summaryreport_disk_stats (
    name text NOT NULL,
    device text NOT NULL,
    read_total double precision NOT NULL,
    read_avg double precision NOT NULL,
    read_peak double precision NOT NULL,
    write_total double precision NOT NULL,
    write_avg double precision NOT NULL,
    write_peak double precision NOT NULL,
    read_io_avg double precision NOT NULL,
    read_io_peak double precision NOT NULL,
    write_io_avg double precision NOT NULL,
    write_io_peak double precision NOT NULL,
    size double precision NOT NULL,
    avg_used double precision,
    peak_used double precision,
    disk_id integer NOT NULL,
    node_id integer NOT NULL,
    start_date timestamp without time zone NOT NULL,
    end_date timestamp without time zone NOT NULL,
    vdisk_id integer,
    vdisk_datastoreid integer,
    vdisk_node_id integer,
    queue_min double precision NOT NULL,
    queue_peak double precision NOT NULL,
    queue_avg double precision NOT NULL,
    read_min double precision NOT NULL,
    write_min double precision NOT NULL,
    queue_trend_ary smallint[],
    read_io_trend_ary smallint[],
    write_io_trend_ary smallint[],
    type text
) partition by range (end_date);

ALTER TABLE tnt_audit.summaryreport_disk_stats OWNER TO impadmin;

--
-- Name: COLUMN tnt_audit.summaryreport_disk_stats.read_total; Type: COMMENT; Schema: tnt_audit; Owner: impadmin
--

COMMENT ON COLUMN tnt_audit.summaryreport_disk_stats.read_total IS 'read total';


--
-- Name: COLUMN tnt_audit.summaryreport_disk_stats.read_avg; Type: COMMENT; Schema: tnt_audit; Owner: impadmin
--

COMMENT ON COLUMN tnt_audit.summaryreport_disk_stats.read_avg IS 'average read count';


--
-- Name: COLUMN tnt_audit.summaryreport_disk_stats.read_peak; Type: COMMENT; Schema: tnt_audit; Owner: impadmin
--

COMMENT ON COLUMN tnt_audit.summaryreport_disk_stats.read_peak IS 'peak read count';


--
-- Name: COLUMN tnt_audit.summaryreport_disk_stats.write_total; Type: COMMENT; Schema: tnt_audit; Owner: impadmin
--

COMMENT ON COLUMN tnt_audit.summaryreport_disk_stats.write_total IS 'write total';


--
-- Name: COLUMN tnt_audit.summaryreport_disk_stats.write_avg; Type: COMMENT; Schema: tnt_audit; Owner: impadmin
--

COMMENT ON COLUMN tnt_audit.summaryreport_disk_stats.write_avg IS 'average write count';


--
-- Name: COLUMN tnt_audit.summaryreport_disk_stats.write_peak; Type: COMMENT; Schema: tnt_audit; Owner: impadmin
--

COMMENT ON COLUMN tnt_audit.summaryreport_disk_stats.write_peak IS 'peak write count';


--
-- Name: COLUMN tnt_audit.summaryreport_disk_stats.read_io_avg; Type: COMMENT; Schema: tnt_audit; Owner: impadmin
--

COMMENT ON COLUMN tnt_audit.summaryreport_disk_stats.read_io_avg IS 'average read io';


--
-- Name: COLUMN tnt_audit.summaryreport_disk_stats.read_io_peak; Type: COMMENT; Schema: tnt_audit; Owner: impadmin
--

COMMENT ON COLUMN tnt_audit.summaryreport_disk_stats.read_io_peak IS 'peak read io';


--
-- Name: COLUMN tnt_audit.summaryreport_disk_stats.write_io_avg; Type: COMMENT; Schema: tnt_audit; Owner: impadmin
--

COMMENT ON COLUMN tnt_audit.summaryreport_disk_stats.write_io_avg IS 'average write io';


--
-- Name: COLUMN tnt_audit.summaryreport_disk_stats.write_io_peak; Type: COMMENT; Schema: tnt_audit; Owner: impadmin
--

COMMENT ON COLUMN tnt_audit.summaryreport_disk_stats.write_io_peak IS 'peak write io';




--
-- Name: COLUMN tnt_audit.summaryreport_disk_stats.size; Type: COMMENT; Schema: tnt_audit; Owner: impadmin
--

COMMENT ON COLUMN tnt_audit.summaryreport_disk_stats.size IS 'partition size';


--
-- Name: COLUMN tnt_audit.summaryreport_disk_stats.avg_used; Type: COMMENT; Schema: tnt_audit; Owner: impadmin
--

COMMENT ON COLUMN tnt_audit.summaryreport_disk_stats.avg_used IS 'average size used (kb)';


--
-- Name: COLUMN tnt_audit.summaryreport_disk_stats.peak_used; Type: COMMENT; Schema: tnt_audit; Owner: impadmin
--

COMMENT ON COLUMN tnt_audit.summaryreport_disk_stats.peak_used IS 'peak size used (kb)';


--
-- Name: COLUMN tnt_audit.summaryreport_disk_stats.disk_id; Type: COMMENT; Schema: tnt_audit; Owner: impadmin
--

COMMENT ON COLUMN tnt_audit.summaryreport_disk_stats.disk_id IS 'disk id - maintained separately from virtual disk as the stats might be associated with a node that doesn''t have any virtual disks';


--
-- Name: tnt_audit.summaryreport_disk_stats; Type: ACL; Schema: tnt_audit; Owner: impadmin
--

REVOKE ALL ON TABLE tnt_audit.summaryreport_disk_stats FROM PUBLIC;
REVOKE ALL ON TABLE tnt_audit.summaryreport_disk_stats FROM impadmin;
GRANT ALL ON TABLE tnt_audit.summaryreport_disk_stats TO impadmin;
GRANT SELECT ON TABLE tnt_audit.summaryreport_disk_stats TO reports;
GRANT SELECT ON TABLE tnt_audit.summaryreport_disk_stats TO vcops;
