create or replace function "tnt_audit".create_raw_trend_array(baseTable text, columnName text)
returns integer as
'
declare
	partitionCount int;
	rowCount int;
	tmpColumnName text;
	partitionInfo record;
begin
	partitionCount := 0;
	tmpColumnName := columnName || ''_raw'';
	raise debug ''Creating raw trend for column % in table %.  New temp column name: % '', columnName, baseTable, tmpColumnName;
	-- create new column
	execute format(''alter table tnt_audit.%I add %I real[]'', baseTable, tmpColumnName);

	return partitionCount;
end;	
'
Language 'plpgsql'
 Volatile
 Called On Null Input
 Security invoker;

create or replace function "tnt_audit".create_raw_trend_arrays(baseTable text)
returns integer as
'
declare
	columnCount int;
	columnInfo record;
begin
	columnCount := 0;
	raise debug ''Creating raw trend arrays on table %'', baseTable;
	for columnInfo in select column_name from information_schema.columns where table_schema = ''tnt_audit'' and table_name = baseTable and data_type = ''ARRAY'' and column_name ~ ''.*trend.*'' LOOP
		raise debug ''Processing column: %'', columnInfo.column_name;
		columnCount := columnCount + 1;
		perform tnt_audit.create_raw_trend_array(baseTable, columnInfo.column_name);
	end loop;

	return columnCount;
end;
'
Language 'plpgsql'
 Volatile
 Called On Null Input
 Security invoker;

select tnt_audit.create_raw_trend_arrays('summaryreports');
select tnt_audit.create_raw_trend_arrays('summaryreport_partition_stats');
select tnt_audit.create_raw_trend_arrays('summaryreport_disk_stats');
select tnt_audit.create_raw_trend_arrays('summaryreport_login_stats');
select tnt_audit.create_raw_trend_arrays('summaryreport_process_stats');
select tnt_audit.create_raw_trend_arrays('summaryreport_datastore_stats');
select tnt_audit.create_raw_trend_arrays('summaryreport_nic_stats');
select tnt_audit.create_raw_trend_arrays('summaryreport_folder_stats');
select tnt_audit.create_raw_trend_arrays('summaryreport_folder_ext_stats');
select tnt_audit.create_raw_trend_arrays('summaryreport_ping_stats');
select tnt_audit.create_raw_trend_arrays('summaryreport_gpu_stats');
select tnt_audit.create_raw_trend_arrays('summaryreport_display_proto_stats');

drop function tnt_audit.create_raw_trend_arrays(text);
drop function tnt_audit.create_raw_trend_array(text, text);
