drop table if exists tnt_audit.raw_host_stats;
create table tnt_audit.raw_host_stats (
	stattime timestamp not null,
	vmhost_id int not null,
	details hstore not null
);
GRANT SELECT ON TABLE tnt_audit.raw_host_stats TO impadmin;
GRANT SELECT ON TABLE tnt_audit.raw_host_stats TO reports;

drop table if exists tnt_audit.raw_node_stats;
create table tnt_audit.raw_node_stats (
	stattime timestamp not null,
	node_id int not null,
	details hstore not null
);
GRANT SELECT ON TABLE tnt_audit.raw_node_stats TO impadmin;
GRANT SELECT ON TABLE tnt_audit.raw_node_stats TO reports;

drop table if exists tnt_audit.raw_datastore_stats;
create table tnt_audit.raw_datastore_stats (
	stattime timestamp not null,
	datastore_id int not null,
	details hstore not null
);
GRANT SELECT ON TABLE tnt_audit.raw_datastore_stats TO impadmin;
GRANT SELECT ON TABLE tnt_audit.raw_datastore_stats TO reports;

-- remove duplicate index on datastore, id is the primary key
drop index if exists tnt_config.datastore_id_idx ;
-- set version default
alter table tnt_config.datastore alter COLUMN version set default 0;
