create or replace view tnt_config.desktop_app_instance_details_view as
SELECT da.id,
    da.parent_app_id,
    da.creation_time,
    da.name,
    da.publisher,
    da.process_names,
    da.app_version,
    da.description,
    da.version,
    da.type,
    da.status,
    da.last_seen,
    count(DISTINCT na.node_id) AS node_count,
    avg(na.size) AS avg_size,
    avg(na.svc_provided) AS avg_svc_provided,
    avg(na.svc_required) AS avg_svc_required,
    avg(na.drv_provided) AS avg_drv_provided,
    min(na.install_date) AS min_install_date,
    max(na.install_date) AS max_install_date,
    min(na.minor_version_details) AS minor_version_details,
    (da.status & 1) = 1 AS is_patch,
    (da.status & 2) = 2 AS system_app,
    (da.status & 4) = 4 AS installs_shell_extensions,
    (da.status & 8) = 8 AS uses_dcom,
    (da.status & 16) = 16 AS include_for_virtualization
   FROM tnt_config.desktop_app da
   JOIN tnt_config.node_application na ON da.id = na.desktop_app_id
   JOIN tnt_config.policynode pn on (na.node_id = pn.id and pn.delete_time is null)
  GROUP BY da.id, da.creation_time, da.name, da.publisher, da.process_names, da.app_version, da.description, da.version, da.type, da.parent_app_id, da.status, da.last_seen;
