drop table if exists tnt_audit.summaryreport_browser_stats cascade;
CREATE TABLE tnt_audit.summaryreport_browser_stats (
    node_id integer NOT NULL,
    start_date timestamp without time zone NOT NULL,
    end_date timestamp without time zone NOT NULL,
    type text not null
) partition by range (end_date);

ALTER TABLE tnt_audit.summaryreport_browser_stats OWNER TO impadmin;
REVOKE ALL ON TABLE tnt_audit.summaryreport_browser_stats FROM PUBLIC;
REVOKE ALL ON TABLE tnt_audit.summaryreport_browser_stats FROM impadmin;
GRANT ALL ON TABLE tnt_audit.summaryreport_browser_stats TO impadmin;
GRANT SELECT ON TABLE tnt_audit.summaryreport_browser_stats TO reports;
GRANT SELECT ON TABLE tnt_audit.summaryreport_browser_stats TO vcops;

drop table if exists tnt_audit.summaryreport_browser_extension_stats cascade;
CREATE TABLE tnt_audit.summaryreport_browser_extension_stats (
    node_id integer NOT NULL,
    start_date timestamp without time zone NOT NULL,
    end_date timestamp without time zone NOT NULL,
    type text not null,
    name text not null,
    details hstore not null
) partition by range (end_date);

ALTER TABLE tnt_audit.summaryreport_browser_extension_stats OWNER TO impadmin;
REVOKE ALL ON TABLE tnt_audit.summaryreport_browser_extension_stats FROM PUBLIC;
REVOKE ALL ON TABLE tnt_audit.summaryreport_browser_extension_stats FROM impadmin;
GRANT ALL ON TABLE tnt_audit.summaryreport_browser_extension_stats TO impadmin;
GRANT SELECT ON TABLE tnt_audit.summaryreport_browser_extension_stats TO reports;
GRANT SELECT ON TABLE tnt_audit.summaryreport_browser_extension_stats TO vcops;

drop table if exists tnt_audit.summaryreport_browser_tab_stats cascade;
CREATE TABLE tnt_audit.summaryreport_browser_tab_stats (
    node_id integer NOT NULL,
    start_date timestamp without time zone NOT NULL,
    end_date timestamp without time zone NOT NULL,
    type text not null,
    id integer not null,
    details hstore not null
) partition by range (end_date);

ALTER TABLE tnt_audit.summaryreport_browser_tab_stats OWNER TO impadmin;
REVOKE ALL ON TABLE tnt_audit.summaryreport_browser_tab_stats FROM PUBLIC;
REVOKE ALL ON TABLE tnt_audit.summaryreport_browser_tab_stats FROM impadmin;
GRANT ALL ON TABLE tnt_audit.summaryreport_browser_tab_stats TO impadmin;
GRANT SELECT ON TABLE tnt_audit.summaryreport_browser_tab_stats TO reports;
GRANT SELECT ON TABLE tnt_audit.summaryreport_browser_tab_stats TO vcops;

drop table if exists tnt_audit.summaryreport_browser_process_stats;
CREATE TABLE tnt_audit.summaryreport_browser_process_stats (
    node_id integer NOT NULL,
    start_date timestamp without time zone NOT NULL,
    end_date timestamp without time zone NOT NULL,
    type text not null,
    pid integer not null,
    details hstore not null
) partition by range (end_date);

ALTER TABLE tnt_audit.summaryreport_browser_process_stats OWNER TO impadmin;
REVOKE ALL ON TABLE tnt_audit.summaryreport_browser_process_stats FROM PUBLIC;
REVOKE ALL ON TABLE tnt_audit.summaryreport_browser_process_stats FROM impadmin;
GRANT ALL ON TABLE tnt_audit.summaryreport_browser_process_stats TO impadmin;
GRANT SELECT ON TABLE tnt_audit.summaryreport_browser_process_stats TO reports;
GRANT SELECT ON TABLE tnt_audit.summaryreport_browser_process_stats TO vcops;
