-- remove primary key on tab stats tables
create or replace function "tnt_audit".remove_tab_stats_pk()
returns integer as
'
declare
        partitionCount int;
        partitionName text;
        partitionInfo record;
begin
        partitionCount := 0;
        for partitionName in select tablename from pg_tables where schemaname = ''tnt_audit'' and tablename like ''summaryreport_browser_tab_stats_%'' loop
                --raise warning ''Processing table %'', partitionName;
                execute ''alter table tnt_audit.'' || partitionName || '' drop constraint '' || partitionName || ''_pkey'';
        end loop;

        return partitionCount;
end;
'
Language 'plpgsql'
 Volatile
 Called On Null Input
 Security invoker;

select tnt_audit.remove_tab_stats_pk();
drop function tnt_audit.remove_tab_stats_pk();

alter table tnt_audit.summaryreport_browser_tab_stats alter COLUMN id drop not null ;
