drop table if exists tnt_audit.urls;
create table tnt_audit.urls (
	id bigserial primary key,
	url text not null,
	details hstore not null,
	creation_time timestamp not null default current_timestamp,
	times_seen bigint not null default 0, 
	last_seen timestamp not null default current_timestamp
);
create unique index url_idx on tnt_audit.urls(url);
create index url_details_idx on tnt_audit.urls using gin (details);

alter table tnt_audit.urls OWNER TO impadmin;

Grant select on "tnt_audit"."urls" to "impadmin";
Grant update on "tnt_audit"."urls" to "impadmin";
Grant delete on "tnt_audit"."urls" to "impadmin";
Grant insert on "tnt_audit"."urls" to "impadmin";
Grant references on "tnt_audit"."urls" to "impadmin";
Grant select on "tnt_audit"."urls" to "reports";

-- add id columns.. we'll migrate data async and remove the old columns
alter table tnt_audit.summaryreport_browser_tab_stats add url_id bigint;
alter table tnt_audit.connecturl add url_id bigint;

-- drop not nulls here.. we'll migrate then remove these columns
alter table tnt_audit.connecturl alter host drop not null ;
alter table tnt_audit.connecturl alter url drop not null ;
