update tnt_config.globaloptions set default_driver_options = default_driver_options || 'stat_options=>1983'::hstore;
update tnt_config.node set driver_options = driver_options || 'stat_options=>1983'::hstore where delete_time is null;

-- move driver options up to policynode
alter table tnt_config.policynode add hwmatchpercentage int default 51;
alter table tnt_config.policynode add numautodeletedays int not null default 0; 
alter table tnt_config.policynode add driver_options hstore not null default ''::hstore;
alter table tnt_config.policynode add net_test_servers text; 
alter table tnt_config.policynode add user_doc_dirs text; 
alter table tnt_config.policynode add user_doc_exts text; 
alter table tnt_config.policynode add statscollectioninterval smallint not null default 0;
alter table tnt_config.policynode add statsprocesscount smallint not null default 20;
alter table tnt_config.policynode add ignoreglobaldriverchanges boolean not null default false;
update tnt_config.policynode set 
id = nde.id, 
hwmatchpercentage = nde.hwmatchpercentage,
numautodeletedays = nde.numautodeletedays,
driver_options = nde.driver_options,
net_test_servers = nde.net_test_servers,
user_doc_dirs = nde.user_doc_dirs,
user_doc_exts = nde.user_doc_exts,
statscollectioninterval = nde.statscollectioninterval,
statsprocesscount = nde.statsprocesscount,
ignoreglobaldriverchanges = nde.ignoreglobaldriverchanges
from (select 
	id, hwmatchpercentage, numautodeletedays, driver_options, net_test_servers, 
	user_doc_dirs, user_doc_exts, statscollectioninterval, statsprocesscount, ignoreglobaldriverchanges
	from tnt_config.node) as nde 
where tnt_config.policynode.id = nde.id;
alter table tnt_config.node drop hwmatchpercentage;
alter table tnt_config.node drop numautodeletedays; 
alter table tnt_config.node drop driver_options; 
alter table tnt_config.node drop net_test_servers; 
alter table tnt_config.node drop user_doc_dirs; 
alter table tnt_config.node drop user_doc_exts;
alter table tnt_config.node drop statscollectioninterval;
alter table tnt_config.node drop statsprocesscount;
alter table tnt_config.node drop ignoreglobaldriverchanges;
-- default nodegroups to system defaults
update tnt_config.policynode set 
hwmatchpercentage = glb.defaulthwmatchpercentage,
numautodeletedays = glb.defaultnumautodeletedays,
driver_options = glb.default_driver_options,
net_test_servers = glb.default_net_test_servers,
user_doc_dirs = glb.default_user_doc_dirs,
user_doc_exts = glb.default_user_doc_exts,
statscollectioninterval = glb.defaultstatscollectioninterval,
statsprocesscount = glb.defaultstatsprocesscount
from (select 
	defaulthwmatchpercentage, defaultnumautodeletedays, default_driver_options, default_net_test_servers, 
	default_user_doc_dirs, default_user_doc_exts, defaultstatscollectioninterval, defaultstatsprocesscount
	from tnt_config.globaloptions) as glb where type = 5;

-- move values to hstore 
update tnt_config.policynode set driver_options = driver_options || ('hwmatchpercentage=>' || hwmatchpercentage)::hstore || ('numautodeletedays=>' || numautodeletedays)::hstore;
alter table tnt_config.policynode drop hwmatchpercentage;
alter table tnt_config.policynode drop numautodeletedays;
update tnt_config.policynode set driver_options = driver_options || ('net_test_servers=>' || E'net_test_servers')::hstore where net_test_servers is not null;
alter table tnt_config.policynode drop net_test_servers;

-- id/activation code index
create index id_ac_idx on tnt_config.node (id, activationcode);
