-- insert apps not found in tnt_config.application
INSERT INTO tnt_config.application (name, defaultportmin, defaultportmax, defaultprotocol) VALUES ('VMware Horizon View 7 Blast',22443,22443,6) ON CONFLICT DO NOTHING;
INSERT INTO tnt_config.application (name, defaultportmin, defaultportmax, defaultprotocol) VALUES ('Connector ID Key Communication SSL/TLS',443,443,6) ON CONFLICT DO NOTHING;
INSERT INTO tnt_config.application (name, defaultportmin, defaultportmax, defaultprotocol) VALUES ('Network Collector Communication SSL/TLS',443,443,6) ON CONFLICT DO NOTHING;

Create or Replace function "tnt_config"."imp_add_default_logging_policy"("int4")
Returns "int4" As
'
DECLARE
   TNid alias for $1;

   hubId integer;
   anId integer;
   allUserId integer;
   allNetworkId integer;
   allTcpId integer;
   networkStatus integer;
   instanceId integer;
   maxRuleOrder integer;
BEGIN
  -- init some variables
  select into hubId id from tnt_config.policynode where type = 3 and system_object =true;
	-- see portal_init.sql for definition of system users and applications
	SELECT into allUserId identity.id from tnt_config.Identity, tnt_config.policyidentity where identity.id = policyidentity.id and UID = -1 and name = ''Any'' and system_object = true;
	SELECT into allNetworkId PolicyNode.id from tnt_config.Network, tnt_config.PolicyNode where Network.id = PolicyNode.id and name = ''Any'' and system_object = true;
	SELECT INTO allTcpId id FROM tnt_config.Application where defaultportmin = 0 and defaultportmax = 65535 and system_object = true and defaultprotocol = 6;

  -- Terminal Services
	SELECT INTO anId id FROM tnt_config.Application where name = ''Terminal Services'' and defaultprotocol = 6;
	SELECT INTO maxRuleOrder coalesce(max(ruleorder), 0) FROM tnt_config.Policy where trustednetworkid = TNid and direction = 0;
	INSERT INTO tnt_config.Policy (Identified, IdentityID, sourceapplicationid, SourceHostID, HostID, ApplicationID, Direction, TrustedNetworkId, RuleOrder, Log) values (2, allUserId, allTcpId, allNetworkId, allNetworkId, anId, 0, TNid, maxRuleOrder + 1, 7);
	SELECT INTO instanceId id from tnt_config.Host_Application where NodeId = allNetworkId and ApplicationId = anId;
	IF instanceId IS NULL THEN
		INSERT INTO tnt_config.Host_Application (NodeId, ApplicationId) values (allNetworkId, anId);
	END IF;

  -- Citrix ICA Session
	SELECT INTO anId id FROM tnt_config.Application where name = ''Citrix ICA Session'' and defaultprotocol = 6;
	SELECT INTO maxRuleOrder coalesce(max(ruleorder), 0) FROM tnt_config.Policy where trustednetworkid = TNid and direction = 0;
	INSERT INTO tnt_config.Policy (Identified, IdentityID, sourceapplicationid, SourceHostID, HostID, ApplicationID, Direction, TrustedNetworkId, RuleOrder, Log) values (2, allUserId, allTcpId, allNetworkId, allNetworkId, anId, 0, TNid, maxRuleOrder + 1, 7);
	SELECT INTO instanceId id from tnt_config.Host_Application where NodeId = allNetworkId and ApplicationId = anId;
	IF instanceId IS NULL THEN
		INSERT INTO tnt_config.Host_Application (NodeId, ApplicationId) values (allNetworkId, anId);
	END IF;

  -- Citrix ICA Session Reliability
	SELECT INTO anId id FROM tnt_config.Application where name = ''Citrix ICA Session Reliability'' and defaultprotocol = 6;
	SELECT INTO maxRuleOrder coalesce(max(ruleorder), 0) FROM tnt_config.Policy where trustednetworkid = TNid and direction = 0;
	INSERT INTO tnt_config.Policy (Identified, IdentityID, sourceapplicationid, SourceHostID, HostID, ApplicationID, Direction, TrustedNetworkId, RuleOrder, Log) values (2, allUserId, allTcpId, allNetworkId, allNetworkId, anId, 0, TNid, maxRuleOrder + 1, 7);
	SELECT INTO instanceId id from tnt_config.Host_Application where NodeId = allNetworkId and ApplicationId = anId;
	IF instanceId IS NULL THEN
		INSERT INTO tnt_config.Host_Application (NodeId, ApplicationId) values (allNetworkId, anId);
	END IF;

	-- VMware View 5 PCoIP TCP 4172
	SELECT INTO anId id FROM tnt_config.Application where name = ''VMware View 5 PCoIP'' and defaultprotocol = 6;
	SELECT INTO maxRuleOrder coalesce(max(ruleorder), 0) FROM tnt_config.Policy where trustednetworkid = TNid and direction = 0;
	INSERT INTO tnt_config.Policy (Identified, IdentityID, sourceapplicationid, SourceHostID, HostID, ApplicationID, Direction, TrustedNetworkId, RuleOrder, Log) values (2, allUserId, allTcpId, allNetworkId, allNetworkId, anId, 0, TNid, maxRuleOrder + 1, 7);
	SELECT INTO instanceId id from tnt_config.Host_Application where NodeId = allNetworkId and ApplicationId = anId;
	IF instanceId IS NULL THEN
		INSERT INTO tnt_config.Host_Application (NodeId, ApplicationId) values (allNetworkId, anId);
	END IF;

	-- VMware View 5 PCoIP UDP 4172
	SELECT INTO anId id FROM tnt_config.Application where name = ''VMware View 5 PCoIP'' and defaultprotocol = 17;
	SELECT INTO maxRuleOrder coalesce(max(ruleorder), 0) FROM tnt_config.Policy where trustednetworkid = TNid and direction = 0;
	INSERT INTO tnt_config.Policy (Identified, IdentityID, sourceapplicationid, SourceHostID, HostID, ApplicationID, Direction, TrustedNetworkId, RuleOrder, Log) values (2, allUserId, allTcpId, allNetworkId, allNetworkId, anId, 0, TNid, maxRuleOrder + 1, 7);
	SELECT INTO instanceId id from tnt_config.Host_Application where NodeId = allNetworkId and ApplicationId = anId;
	IF instanceId IS NULL THEN
		INSERT INTO tnt_config.Host_Application (NodeId, ApplicationId) values (allNetworkId, anId);
	END IF;

	-- VMware Horizon View 7 Blast
	SELECT INTO anId id FROM tnt_config.Application where name = ''VMware Horizon View 7 Blast'' and defaultprotocol = 6;
	SELECT INTO maxRuleOrder coalesce(max(ruleorder), 0) FROM tnt_config.Policy where trustednetworkid = TNid and direction = 0;
	INSERT INTO tnt_config.Policy (Identified, IdentityID, sourceapplicationid, SourceHostID, HostID, ApplicationID, Direction, TrustedNetworkId, RuleOrder, Log) values (2, allUserId, allTcpId, allNetworkId, allNetworkId, anId, 0, TNid, maxRuleOrder + 1, 7);
	SELECT INTO instanceId id from tnt_config.Host_Application where NodeId = allNetworkId and ApplicationId = anId;
	IF instanceId IS NULL THEN
		INSERT INTO tnt_config.Host_Application (NodeId, ApplicationId) values (allNetworkId, anId);
	END IF;

  -- HTTP over TLS/SSL
  SELECT INTO anId id FROM tnt_config.Application where name = ''HTTP over TLS/SSL'' and defaultprotocol = 6;
	SELECT INTO maxRuleOrder coalesce(max(ruleorder), 0) FROM tnt_config.Policy where trustednetworkid = TNid and direction = 0;
	INSERT INTO tnt_config.Policy (Identified, IdentityID, sourceapplicationid, SourceHostID, HostID, ApplicationID, Direction, TrustedNetworkId, RuleOrder, Log) values (2, allUserId, allTcpId, allNetworkId, hubId, anId, 0, TNid, maxRuleOrder + 1, 2);
	SELECT INTO instanceId id from tnt_config.Host_Application where NodeId = allNetworkId and ApplicationId = anId;
	IF instanceId IS NULL THEN
		INSERT INTO tnt_config.Host_Application (NodeId, ApplicationId) values (allNetworkId, anId);
	END IF;

  -- HTTP TCP/80
  SELECT INTO anId id FROM tnt_config.Application where name = ''World Wide Web - HTTP'' and defaultprotocol = 6;
	SELECT INTO maxRuleOrder coalesce(max(ruleorder), 0) FROM tnt_config.Policy where trustednetworkid = TNid and direction = 0;
	INSERT INTO tnt_config.Policy (Identified, IdentityID, sourceapplicationid, SourceHostID, HostID, ApplicationID, Direction, TrustedNetworkId, RuleOrder, Log) values (2, allUserId, allTcpId, allNetworkId, allNetworkId, anId, 0, TNid, maxRuleOrder + 1, 11);
	SELECT INTO instanceId id from tnt_config.Host_Application where NodeId = allNetworkId and ApplicationId = anId;
	IF instanceId IS NULL THEN
		INSERT INTO tnt_config.Host_Application (NodeId, ApplicationId) values (allNetworkId, anId);
	END IF;

  -- Connector ID Key Communication
  SELECT INTO anId id FROM tnt_config.Application where name = ''Connector ID Key Communication'' and defaultprotocol = 6;
	SELECT INTO maxRuleOrder coalesce(max(ruleorder), 0) FROM tnt_config.Policy where trustednetworkid = TNid and direction = 0;
	INSERT INTO tnt_config.Policy (Identified, IdentityID, sourceapplicationid, SourceHostID, HostID, ApplicationID, Direction, TrustedNetworkId, RuleOrder, Log) values (2, allUserId, allTcpId, allNetworkId, hubId, anId, 0, TNid, maxRuleOrder + 1, 2);
  SELECT INTO instanceId id from tnt_config.Host_Application where NodeId = allNetworkId and ApplicationId = anId;
	IF instanceId IS NULL THEN
		INSERT INTO tnt_config.Host_Application (NodeId, ApplicationId) values (allNetworkId, anId);
	END IF;

  -- Connector ID Key Communication SSL/TLS
  SELECT INTO anId id FROM tnt_config.Application where name = ''Connector ID Key Communication SSL/TLS'' and defaultprotocol = 6;
	SELECT INTO maxRuleOrder coalesce(max(ruleorder), 0) FROM tnt_config.Policy where trustednetworkid = TNid and direction = 0;
	INSERT INTO tnt_config.Policy (Identified, IdentityID, sourceapplicationid, SourceHostID, HostID, ApplicationID, Direction, TrustedNetworkId, RuleOrder, Log) values (2, allUserId, allTcpId, allNetworkId, hubId, anId, 0, TNid, maxRuleOrder + 1, 2);
  SELECT INTO instanceId id from tnt_config.Host_Application where NodeId = allNetworkId and ApplicationId = anId;
	IF instanceId IS NULL THEN
		INSERT INTO tnt_config.Host_Application (NodeId, ApplicationId) values (allNetworkId, anId);
	END IF;

  -- Legacy Collector Communication
  SELECT INTO anId id FROM tnt_config.Application where name = ''Legacy Collector Communication'' and defaultprotocol = 6;
	SELECT INTO maxRuleOrder coalesce(max(ruleorder), 0) FROM tnt_config.Policy where trustednetworkid = TNid and direction = 0;
	INSERT INTO tnt_config.Policy (Identified, IdentityID, sourceapplicationid, SourceHostID, HostID, ApplicationID, Direction, TrustedNetworkId, RuleOrder, Log) values (2, allUserId, allTcpId, allNetworkId, hubId, anId, 0, TNid, maxRuleOrder + 1, 2);
  SELECT INTO instanceId id from tnt_config.Host_Application where NodeId = allNetworkId and ApplicationId = anId;
	IF instanceId IS NULL THEN
		INSERT INTO tnt_config.Host_Application (NodeId, ApplicationId) values (allNetworkId, anId);
	END IF;

  -- Network Collector Communication SSL/TLS
  SELECT INTO anId id FROM tnt_config.Application where name = ''Network Collector Communication SSL/TLS'' and defaultprotocol = 6;
	SELECT INTO maxRuleOrder coalesce(max(ruleorder), 0) FROM tnt_config.Policy where trustednetworkid = TNid and direction = 0;
	INSERT INTO tnt_config.Policy (Identified, IdentityID, sourceapplicationid, SourceHostID, HostID, ApplicationID, Direction, TrustedNetworkId, RuleOrder, Log) values (2, allUserId, allTcpId, allNetworkId, hubId, anId, 0, TNid, maxRuleOrder + 1, 2);
  SELECT INTO instanceId id from tnt_config.Host_Application where NodeId = allNetworkId and ApplicationId = anId;
	IF instanceId IS NULL THEN
		INSERT INTO tnt_config.Host_Application (NodeId, ApplicationId) values (allNetworkId, anId);
	END IF;

	return 0;
END
'
  Language 'plpgsql'
  Volatile
  Called On Null Input
  Security invoker;