alter table tnt_audit.summaryreport_login_session_stats add summarized boolean default false;
--
-- Name: tnt_audit.summaryreport_login_session_summary; Type: TABLE; Schema: tnt_audit; Owner: impadmin
--

CREATE TABLE tnt_audit.summaryreport_login_session_summary (
    node_id integer NOT NULL,
    start_date timestamp without time zone NOT NULL,
    end_date timestamp without time zone NOT NULL,
    login_time timestamp without time zone NOT NULL,
    name text NOT NULL,
    session_id integer NOT NULL,
    session_type text NOT NULL,
    session_data public.hstore,
    client_info public.hstore,
    network_info public.hstore,
    branch_repeater_info public.hstore,
    media_stream_info public.hstore,
    flash_info public.hstore,
    graphic_info public.hstore,
    d3d_info public.hstore,
    thinwire_info public.hstore,
    usb_info public.hstore[],
    printer_info public.hstore[],
    smartcard_info public.hstore[],
    scanner_info public.hstore[],
    cdm_info public.hstore[],
    audioxa_info public.hstore[],
    display_proto_start_time timestamp without time zone,
    graphic_mode text,
    active_time bigint,
    inactive_time bigint,
    session_time bigint,
    events text[],
    event_times timestamp[],
    event_counts hstore,
    primary key (node_id, start_date, end_date, login_time, name, session_id, session_type)
);


ALTER TABLE tnt_audit.summaryreport_login_session_summary OWNER TO impadmin;

--
-- Name: tnt_audit.summaryreport_login_session_summary; Type: ACL; Schema: tnt_audit; Owner: impadmin
--

REVOKE ALL ON TABLE tnt_audit.summaryreport_login_session_summary FROM PUBLIC;
REVOKE ALL ON TABLE tnt_audit.summaryreport_login_session_summary FROM impadmin;
GRANT ALL ON TABLE tnt_audit.summaryreport_login_session_summary TO impadmin;
GRANT SELECT ON TABLE tnt_audit.summaryreport_login_session_summary TO reports;

create index login_session_summary_node_time_idx on tnt_audit.summaryreport_login_session_summary (node_id, start_date, end_date);
create unique index login_session_summary_node_time_session_idx on tnt_audit.summaryreport_login_session_summary (node_id, login_time, name, session_id, session_type);
