create table tnt_audit.login_violations (
	node_id int not null,
	user_name text not null,
	user_id int,
	login_time timestamp not null,
	recorded_at timestamp not null default current_timestamp,
	acked bool not null default false,
	acked_by int,
	acked_at timestamp,
	login_count int,
	primary key (node_id, user_name, login_time)
);
ALTER TABLE tnt_audit.login_violations ADD CONSTRAINT nodefk FOREIGN KEY (node_id) REFERENCES tnt_config.policynode (id) on update cascade;
ALTER TABLE tnt_audit.login_violations ADD CONSTRAINT userfk FOREIGN KEY (user_id) REFERENCES tnt_config.policyidentity (id) on update cascade;
ALTER TABLE tnt_audit.login_violations ADD CONSTRAINT ackedbyfk FOREIGN KEY (acked_by) REFERENCES tnt_config.policyidentity (id) on update cascade;
create index login_violations_time_idx on tnt_audit.login_violations (login_time);
create index login_violations_acked_idx on tnt_audit.login_violations (acked);
alter table tnt_audit.login_violations owner to impadmin;
grant select on tnt_audit.login_violations to reports; 
update tnt_config.globaloptions set options = options || hstore('concurrentLicenseViolationStage', '0') ||  hstore('concurrentLicenseGracePercent', '1') ||
	hstore('concurrentLicenseValidDays', '0') || hstore('concurrentLicenseViolationDays', '0') || hstore('awsLastMeteringTimeMs', '0');
