CREATE TABLE tnt_audit.summaryreport_process_stats_network_details (
    node_id integer NOT NULL,
    start_date timestamp without time zone NOT NULL,
    end_date timestamp without time zone NOT NULL,
	pid int not null,
	name text not null,
	inaddr inet not null,
	inport int not null,
	outaddr inet not null,
	outport int not null,
	outname text, 
	type text not null,
	sendReceiveMinTotal int,
	receiveCountTotal int,
	receiveKbTotal float,
	sendCountTotal int,
	sendKbTotal float,
	pingCountTotal int,
	pingLatencyMsAvg float,
	jitterAvg float,
	owner_id int,
	owner_name text,
	desk_app_id int,
	primary key (node_id, start_date, end_date, pid, name, inaddr, inport, outaddr, outport, type)
) partition by range (end_date);

-- we do look at start_date for rollup
create index summaryreports_psnd_end_time_idx on tnt_audit.summaryreport_process_stats_network_details (end_date);
create index summaryreports_psnd_node_idx on tnt_audit.summaryreport_process_stats_network_details (node_id);
-- for process table joins
create index summaryreports_psnd_process_idx on tnt_audit.summaryreport_process_stats_network_details (node_id, start_date, end_date, name, pid);

ALTER TABLE tnt_audit.summaryreport_process_stats_network_details OWNER TO impadmin;
REVOKE ALL ON TABLE tnt_audit.summaryreport_process_stats_network_details FROM PUBLIC;
REVOKE ALL ON TABLE tnt_audit.summaryreport_process_stats_network_details FROM impadmin;
GRANT ALL ON TABLE tnt_audit.summaryreport_process_stats_network_details TO impadmin;
GRANT SELECT ON TABLE tnt_audit.summaryreport_process_stats_network_details TO reports;
GRANT SELECT ON TABLE tnt_audit.summaryreport_process_stats_network_details TO vcops;

SELECT partman.create_parent('tnt_audit.summaryreport_process_stats_network_details', 'end_date', 'native', 'daily');
select partman.create_partition_time('tnt_audit.summaryreport_process_stats_network_details', ARRAY[date_trunc('day', now())]);
