CREATE TABLE tnt_audit.summaryreport_os_event_logs (
    node_id integer NOT NULL,
    start_date timestamp without time zone NOT NULL,
    end_date timestamp without time zone NOT NULL,
	log_name text not null,
	log_level text not null,
	log_id integer not null,
	log_recordid integer not null,
	log_source text not null,
	log_time timestamp not null,
	log_msg text,
	primary key (node_id, start_date, end_date, log_name, log_id, log_recordid, log_time) 
) partition by range (end_date);

-- we do look at start_date for rollup
create index summaryreports_ose_end_time_idx on tnt_audit.summaryreport_os_event_logs (end_date);
create index summaryreports_ose_node_idx on tnt_audit.summaryreport_os_event_logs (node_id);
-- for table joins
create index summaryreports_ose_rpt_idx on tnt_audit.summaryreport_os_event_logs (node_id, start_date, end_date);

ALTER TABLE tnt_audit.summaryreport_os_event_logs OWNER TO impadmin;
REVOKE ALL ON TABLE tnt_audit.summaryreport_os_event_logs FROM PUBLIC;
REVOKE ALL ON TABLE tnt_audit.summaryreport_os_event_logs FROM impadmin;
GRANT ALL ON TABLE tnt_audit.summaryreport_os_event_logs TO impadmin;
GRANT SELECT ON TABLE tnt_audit.summaryreport_os_event_logs TO reports;
GRANT SELECT ON TABLE tnt_audit.summaryreport_os_event_logs TO vcops;

SELECT partman.create_parent('tnt_audit.summaryreport_os_event_logs', 'end_date', 'native', 'daily');
select partman.create_partition_time('tnt_audit.summaryreport_os_event_logs', ARRAY[date_trunc('day', now())]);

update tnt_config.globaloptions set default_driver_options = default_driver_options || hstore('event_log_logs', NULL) || hstore('event_log_levels', NULL) || hstore('event_log_ids', NULL);
update tnt_config.policynode set driver_options = driver_options || hstore('event_log_logs', NULL) || hstore('event_log_levels', NULL) || hstore('event_log_ids', NULL);
