Create or Replace function "tnt_audit".ensure_partitions_for_today()
Returns void As
$$
DECLARE
        partitionName text;
        partitionDate timestamptz;
BEGIN
	select into partitionDate date_trunc('day', now());
        for partitionName in select parent_table from partman.part_config where datetime_string is not null loop 
                -- if the target exists, then copy data from legacy table into existing one and then delete
                -- might happen if legacy collectors are running for a bit
		raise debug 'Ensuring partition exists for %, date %', partitionName, partitionDate;
		execute 'select partman.create_partition_time(''' || partitionName || ''', ARRAY[''' || partitionDate ||  '''::timestamptz])';
        end loop;
END;
$$
Language plpgsql
Volatile
Called On Null Input
Security invoker;

alter table tnt_config.dashboards add ownerid integer;
alter table tnt_config.dashboards add groupids integer[];
