CREATE TABLE tnt_audit.summaryreport_process_optimizer_logs (
    node_id integer NOT NULL,
    start_date timestamp without time zone NOT NULL,
    end_date timestamp without time zone NOT NULL,
	pid integer not null,
	session_id integer,
	session_status integer,
	memory_working_set_before_kb integer,
	memory_working_set_after_kb integer,
	machine_cpu_usage_percent float,
	process_cpu_usage_percent float,
--	process_owner_name text,
	action text not null,
	action_time timestamp not null,
	process_name text not null,
	primary key (node_id, start_date, end_date, pid, session_id, process_name, action_time) 
) partition by range (end_date);

-- we do look at start_date for rollup
create index summaryreports_pop_end_time_idx on tnt_audit.summaryreport_process_optimizer_logs (end_date);
create index summaryreports_pop_node_idx on tnt_audit.summaryreport_process_optimizer_logs (node_id);
-- for table joins
create index summaryreports_pop_rpt_idx on tnt_audit.summaryreport_process_optimizer_logs (node_id, start_date, end_date);

ALTER TABLE tnt_audit.summaryreport_process_optimizer_logs OWNER TO impadmin;
REVOKE ALL ON TABLE tnt_audit.summaryreport_process_optimizer_logs FROM PUBLIC;
REVOKE ALL ON TABLE tnt_audit.summaryreport_process_optimizer_logs FROM impadmin;
GRANT ALL ON TABLE tnt_audit.summaryreport_process_optimizer_logs TO impadmin;
GRANT SELECT ON TABLE tnt_audit.summaryreport_process_optimizer_logs TO reports;
GRANT SELECT ON TABLE tnt_audit.summaryreport_process_optimizer_logs TO vcops;

SELECT partman.create_parent('tnt_audit.summaryreport_process_optimizer_logs', 'end_date', 'native', 'daily');
select partman.create_partition_time('tnt_audit.summaryreport_process_optimizer_logs', ARRAY[date_trunc('day', now())]);
