Create or Replace function "tnt_audit".fix_dp_primary_keys()
Returns void As
$$
DECLARE
        partitionName text;
	constraintName text;
BEGIN
        for partitionName in select tablename from pg_tables where schemaname = 'tnt_audit' and tablename like 'summaryreport_display_proto_stats%'  loop 
		raise debug 'Fixing primary key on %', partitionName;
		SELECT
         		max(kcu.constraint_name)
		into constraintName 
		FROM    INFORMATION_SCHEMA.TABLES t
	         LEFT JOIN INFORMATION_SCHEMA.TABLE_CONSTRAINTS tc
       	          ON tc.table_catalog = t.table_catalog
       	          AND tc.table_schema = t.table_schema
       	          AND tc.table_name = t.table_name
       	          AND tc.constraint_type = 'PRIMARY KEY'
       	  LEFT JOIN INFORMATION_SCHEMA.KEY_COLUMN_USAGE kcu
       	          ON kcu.table_catalog = tc.table_catalog
       	          AND kcu.table_schema = tc.table_schema
       	          AND kcu.table_name = tc.table_name
       	          AND kcu.constraint_name = tc.constraint_name
		WHERE   t.table_schema = 'tnt_audit' and t.table_name = partitionName;
		execute 'alter table tnt_audit.' || partitionName || ' drop constraint if exists ' || constraintName;
		execute 'alter table tnt_audit.' || partitionName || ' add primary key (node_id, start_date, end_date, session_start, type, connect_time)';
        end loop;
END;
$$
Language plpgsql
Volatile
Called On Null Input
Security invoker;

-- add column
alter table tnt_audit.summaryreport_display_proto_stats add connect_time timestamp;
update tnt_audit.summaryreport_display_proto_stats set connect_time = (case when details->'connect_time' is not null then cast(details->'connect_time' as timestamp) else session_start end);
alter table tnt_audit.summaryreport_display_proto_stats alter COLUMN connect_time set not null;
--select tnt_audit.fix_dp_primary_keys();
alter table tnt_audit.summaryreport_display_proto_stats drop constraint if exists summaryreport_display_proto_stats_pkey;
alter table tnt_audit.summaryreport_display_proto_stats add primary key (node_id, start_date, end_date, session_start, type, connect_time);
-- just on parent table now
drop function tnt_audit.fix_dp_primary_keys();

-- and rollup
Create or Replace function "lwl_rollup".fix_dpr_primary_keys()
Returns void As
$$
DECLARE
        partitionName text;
	constraintName text;
BEGIN
        for partitionName in select tablename from pg_tables where schemaname = 'lwl_rollup' and tablename like 'sr_display_proto_stats_da%'  order by tablename asc loop 
		raise debug 'Fixing primary key on %', partitionName;
		if partitionName = 'sr_display_proto_stats_da' then
			alter table lwl_rollup.sr_display_proto_stats_da add connect_time timestamp;
			update lwl_rollup.sr_display_proto_stats_da set connect_time = (case when details->'connect_time' is not null then cast(details->'connect_time' as timestamp) else session_start end);
		end if;
		SELECT
         		max(kcu.constraint_name)
		into constraintName 
		FROM    INFORMATION_SCHEMA.TABLES t
	         LEFT JOIN INFORMATION_SCHEMA.TABLE_CONSTRAINTS tc
       	          ON tc.table_catalog = t.table_catalog
       	          AND tc.table_schema = t.table_schema
       	          AND tc.table_name = t.table_name
       	          AND tc.constraint_type = 'PRIMARY KEY'
       	  LEFT JOIN INFORMATION_SCHEMA.KEY_COLUMN_USAGE kcu
       	          ON kcu.table_catalog = tc.table_catalog
       	          AND kcu.table_schema = tc.table_schema
       	          AND kcu.table_name = tc.table_name
       	          AND kcu.constraint_name = tc.constraint_name
		WHERE   t.table_schema = 'lwl_rollup' and t.table_name = partitionName;
		execute 'alter table lwl_rollup.' || partitionName || ' drop constraint if exists ' || constraintName;
		execute 'alter table lwl_rollup.' || partitionName || ' add primary key (node_id, start_date, end_date, session_start, type, connect_time)';
        end loop;
END;
$$
Language plpgsql
Volatile
Called On Null Input
Security invoker;

-- update rollup column 
--select lwl_rollup.fix_dpr_primary_keys();
--alter table lwl_rollup.sr_display_proto_stats_da drop constraint if exists sr_display_proto_stats_da_pkey;
--alter table lwl_rollup.sr_display_proto_stats_da add primary key (node_id, start_date, end_date, session_start, type, connect_time);
drop function lwl_rollup.fix_dpr_primary_keys();
