-- disable memory trim by default
update tnt_config.globaloptions set default_driver_options = default_driver_options || hstore('opt_memory_trim', 'true');
update tnt_config.policynode set driver_options = driver_options || hstore('opt_memory_trim', 'true');
CREATE TABLE tnt_audit.summaryreport_process_optimizer_summary_logs (
    node_id integer NOT NULL,
    start_date timestamp without time zone NOT NULL,
    end_date timestamp without time zone NOT NULL,
	pid integer not null,
	session_id integer,
	process_name text not null,
	total_action_count integer,
	trim_memory_action_count integer,
	terminate_action_count integer,
	raise_action_count integer,
	lower_action_count integer,
	foreground_action_count integer,
	low_priority_count integer,
	below_normal_priority_count integer,
	normal_priority_count integer,
	above_normal_priority_count integer,
	high_priority_count integer,
	avg_process_cpu_percent real,
	avg_mem_before integer,
	avg_mem_saving integer,
	total_mem_saving integer,
	total_fg_time_sec integer,
	primary key (node_id, start_date, end_date, pid, process_name, session_id) 
) partition by range (end_date) Without Oids;


-- we do look at start_date for rollup
create index summaryreports_pops_end_time_idx on tnt_audit.summaryreport_process_optimizer_summary_logs (end_date);
create index summaryreports_pops_node_idx on tnt_audit.summaryreport_process_optimizer_summary_logs (node_id);
-- for table joins
create index summaryreports_pops_rpt_idx on tnt_audit.summaryreport_process_optimizer_summary_logs (node_id, start_date, end_date);

ALTER TABLE tnt_audit.summaryreport_process_optimizer_summary_logs OWNER TO impadmin;
REVOKE ALL ON TABLE tnt_audit.summaryreport_process_optimizer_summary_logs FROM PUBLIC;
REVOKE ALL ON TABLE tnt_audit.summaryreport_process_optimizer_summary_logs FROM impadmin;
GRANT ALL ON TABLE tnt_audit.summaryreport_process_optimizer_summary_logs TO impadmin;
GRANT SELECT ON TABLE tnt_audit.summaryreport_process_optimizer_summary_logs TO reports;
GRANT SELECT ON TABLE tnt_audit.summaryreport_process_optimizer_summary_logs TO vcops;

SELECT partman.create_parent('tnt_audit.summaryreport_process_optimizer_summary_logs', 'end_date', 'native', 'daily');
select partman.create_partition_time('tnt_audit.summaryreport_process_optimizer_summary_logs', ARRAY[date_trunc('day', now())]);
