Create table "tnt_audit"."summaryreport_folder_sub_stats"
(
	"node_id" Integer NOT NULL,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"parent_cfgname" Text NOT NULL,
	"parent_name" Text NOT NULL,
	"name" Text NOT NULL,
	"count" Integer NOT NULL,
	"size" Bigint NOT NULL,
	primary key (node_id, start_date, end_date, parent_cfgname, parent_name, name) 
) partition by range (end_date) Without Oids;

-- we do look at start_date for rollup
create index summaryreports_fsub_end_time_idx on tnt_audit.summaryreport_folder_sub_stats (end_date);
create index summaryreports_fsub_node_idx on tnt_audit.summaryreport_folder_sub_stats (node_id);
-- for table joins
create index summaryreports_fsub_rpt_idx on tnt_audit.summaryreport_folder_sub_stats (node_id, start_date, end_date);

ALTER TABLE tnt_audit.summaryreport_folder_sub_stats OWNER TO impadmin;
REVOKE ALL ON TABLE tnt_audit.summaryreport_folder_sub_stats FROM PUBLIC;
REVOKE ALL ON TABLE tnt_audit.summaryreport_folder_sub_stats FROM impadmin;
GRANT ALL ON TABLE tnt_audit.summaryreport_folder_sub_stats TO impadmin;
GRANT SELECT ON TABLE tnt_audit.summaryreport_folder_sub_stats TO reports;
GRANT SELECT ON TABLE tnt_audit.summaryreport_folder_sub_stats TO vcops;

SELECT partman.create_parent('tnt_audit.summaryreport_folder_sub_stats', 'end_date', 'native', 'daily');
select partman.create_partition_time('tnt_audit.summaryreport_folder_sub_stats', ARRAY[date_trunc('day', now())]);
