alter table tnt_audit.summaryreport_nic_stats drop column if exists details;
alter table tnt_audit.summaryreport_nic_stats add if not exists macaddress macaddr; 

drop table if exists "tnt_audit"."summaryreport_wifi_stats" cascade;
-- manually cleanup partman
delete from partman.part_config where parent_table = 'tnt_audit.summaryreport_wifi_stats';
Create table if not exists "tnt_audit"."summaryreport_wifi_stats"
(
	"node_id" Integer NOT NULL,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"network_name" Text NOT NULL,
	"mac_address" macaddr NOT NULL,
	"assoc_start_time" timestamp not null,
	"assoc_end_time" timestamp,
	"nic_name" text not null,
	"band" real not null,
	"channel" smallint not null,
	"authtype" text,
	"cipher" text,
	"conntype" text,
	"is8021x" bool not null default false,
	"protocol" text not null,
	"secure" bool not null default false,
	"signal_strength_percent_avg" real,
	"signal_strength_percent_peak" real,
	"signal_strength_percent_min" real,
	"signal_strength_percent_raw" real[],
	"signal_strength_dbm_avg" real,
	"signal_strength_dbm_peak" real,
	"signal_strength_dbm_min" real,
	"signal_strength_dbm_raw" real[],
	"mreceive_rate_mbps_avg" real,
	"mreceive_rate_mbps_peak" real,
	"mreceive_rate_mbps_min" real,
	"mreceive_rate_mbps_raw" real[],
	"mtransmit_rate_mbps_avg" real,
	"mtransmit_rate_mbps_peak" real,
	"mtransmit_rate_mbps_min" real,
	"mtransmit_rate_mbps_raw" real[],
	primary key (node_id, start_date, end_date, network_name, mac_address, assoc_start_time)
) partition by range (end_date) Without Oids;

-- we do look at start_date for rollup
create index if not exists summaryreports_wifi_end_time_idx on tnt_audit.summaryreport_wifi_stats (end_date);
create index if not exists summaryreports_wifi_node_idx on tnt_audit.summaryreport_wifi_stats (node_id);
-- for table joins
create index if not exists summaryreports_wifi_rpt_idx on tnt_audit.summaryreport_wifi_stats (node_id, start_date, end_date);
-- for other things
create index if not exists summaryreports_wifi_nname_idx on tnt_audit.summaryreport_wifi_stats (network_name);

ALTER TABLE tnt_audit.summaryreport_wifi_stats OWNER TO impadmin;
REVOKE ALL ON TABLE tnt_audit.summaryreport_wifi_stats FROM PUBLIC;
REVOKE ALL ON TABLE tnt_audit.summaryreport_wifi_stats FROM impadmin;
GRANT ALL ON TABLE tnt_audit.summaryreport_wifi_stats TO impadmin;
GRANT SELECT ON TABLE tnt_audit.summaryreport_wifi_stats TO reports;
GRANT SELECT ON TABLE tnt_audit.summaryreport_wifi_stats TO vcops;

SELECT partman.create_parent('tnt_audit.summaryreport_wifi_stats', 'end_date', 'native', 'daily');
select partman.create_partition_time('tnt_audit.summaryreport_wifi_stats', ARRAY[date_trunc('day', now())]);
