alter table tnt_audit.summaryreports add battery_percent_avg real;
alter table tnt_audit.summaryreports add battery_percent_min real;
alter table tnt_audit.summaryreports add battery_percent_peak real;
alter table tnt_audit.summaryreports add battery_trend_raw real[];


drop table if exists "tnt_audit"."summaryreport_fan_stats" cascade;
-- manually cleanup partman
delete from partman.part_config where parent_table = 'tnt_audit.summaryreport_fan_stats';
Create table if not exists "tnt_audit"."summaryreport_fan_stats"
(
	"node_id" Integer NOT NULL,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"name" Text NOT NULL,
	"speed_rpm_min" real,
	"speed_rpm_avg" real,
	"speed_rpm_peak" real,
	"speed_rpm_raw" real[],
	primary key (node_id, start_date, end_date, name)
) partition by range (end_date) Without Oids;

-- we do look at start_date for rollup
create index if not exists summaryreports_fan_end_time_idx on tnt_audit.summaryreport_fan_stats (end_date);
create index if not exists summaryreports_fan_node_idx on tnt_audit.summaryreport_fan_stats (node_id);
-- for table joins
create index if not exists summaryreports_fan_rpt_idx on tnt_audit.summaryreport_fan_stats (node_id, start_date, end_date);
-- for other things
--create index if not exists summaryreports_fan_nname_idx on tnt_audit.summaryreport_fan_stats (network_name);

ALTER TABLE tnt_audit.summaryreport_fan_stats OWNER TO impadmin;
REVOKE ALL ON TABLE tnt_audit.summaryreport_fan_stats FROM PUBLIC;
REVOKE ALL ON TABLE tnt_audit.summaryreport_fan_stats FROM impadmin;
GRANT ALL ON TABLE tnt_audit.summaryreport_fan_stats TO impadmin;
GRANT SELECT ON TABLE tnt_audit.summaryreport_fan_stats TO reports;
GRANT SELECT ON TABLE tnt_audit.summaryreport_fan_stats TO vcops;

SELECT partman.create_parent('tnt_audit.summaryreport_fan_stats', 'end_date', 'native', 'daily');
select partman.create_partition_time('tnt_audit.summaryreport_fan_stats', ARRAY[date_trunc('day', now())]);
