Create or Replace function "tnt_audit".ensure_partitions_for_today()
Returns void As
$$
DECLARE
        partitionName text;
BEGIN
        for partitionName in select parent_table from partman.part_config where datetime_string is not null loop 
                -- if the target exists, then copy data from legacy table into existing one and then delete
                -- might happen if legacy collectors are running for a bit
		raise debug 'Ensuring partition exists for %', partitionName;
		execute 'select partman.create_partition_time(''' || partitionName || ''', ARRAY[date_trunc(''day'', now()), date_trunc(''day'', now() + interval ''1 day'')])';
		-- repartition any data in the base tables
		--call partman.partition_data_proc(partitionName);
		--execute 'vacuum analyze ' || partitionName;
        end loop;
END;
$$
Language plpgsql
Volatile
Called On Null Input
Security invoker;

-- turn down maintenance a bit
update tnt_config.job set schedule = '0 30 */3 * * ?' where name = 'Database Maintenance';

-- add a custom  maint that we don't override
insert into tnt_config.job (starttime, command, name, usescron, schedule) values (now(), 'bean:dbCommandJob', 'Custom Database Maintenance', false, '0 */30 * * * ?');
insert into tnt_config.jobattribute values ((select max(id) from tnt_config.job), 'CommandFilename', '/opt/tnt/db/dbmaint.custom.sql');
insert into tnt_config.jobattribute values ((select max(id) from tnt_config.job), 'RequiresSuperuser', 'true');
