-- touched for CSV update
create extension if not exists postgis;

drop table if exists "tnt_audit"."summaryreport_machine_location_stats" cascade;
-- manually cleanup partman
delete from partman.part_config where parent_table = 'tnt_audit.summaryreport_machine_location_stats';
Create table if not exists "tnt_audit"."summaryreport_machine_location_stats"
(
	"node_id" Integer NOT NULL,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"latitude" real not null,
	"longitude" real not null,
	"city" text,
	"state" text,
	"country" text,
	"inferred" bool,

	primary key (node_id, start_date, end_date)
) partition by range (end_date) Without Oids;
-- we do look at start_date for rollup
create index if not exists summaryreports_mach_loc_end_time_idx on tnt_audit.summaryreport_machine_location_stats (end_date);
create index if not exists summaryreports_mach_loc_node_idx on tnt_audit.summaryreport_machine_location_stats (node_id);

ALTER TABLE tnt_audit.summaryreport_machine_location_stats OWNER TO impadmin;
REVOKE ALL ON TABLE tnt_audit.summaryreport_machine_location_stats FROM PUBLIC;
REVOKE ALL ON TABLE tnt_audit.summaryreport_machine_location_stats FROM impadmin;
GRANT ALL ON TABLE tnt_audit.summaryreport_machine_location_stats TO impadmin;
GRANT SELECT ON TABLE tnt_audit.summaryreport_machine_location_stats TO reports;
GRANT SELECT ON TABLE tnt_audit.summaryreport_machine_location_stats TO vcops;

SELECT partman.create_parent('tnt_audit.summaryreport_machine_location_stats', 'end_date', 'native', 'daily');
select partman.create_partition_time('tnt_audit.summaryreport_machine_location_stats', ARRAY[date_trunc('day', now())]);


-- create empty table by default, rebuilt async
create table if not exists tnt_config.location (
	ip_range cidr,
	continent text,
	country text,
	stateprov text,
	city text,
	coordinates geography(Point,4326)
);

ALTER TABLE tnt_config.location OWNER TO impadmin;
REVOKE ALL ON TABLE tnt_config.location FROM PUBLIC;
REVOKE ALL ON TABLE tnt_config.location FROM impadmin;
GRANT ALL ON TABLE tnt_config.location TO impadmin;
GRANT SELECT ON TABLE tnt_config.location TO reports;
GRANT SELECT ON TABLE tnt_config.location TO vcops;

