alter table tnt_audit.summaryreports drop if exists swap_loc;
alter table tnt_audit.summaryreports drop if exists swap_mgmt;
alter table tnt_audit.summaryreports add if not exists swap_temp boolean;
alter table tnt_audit.summaryreports drop if exists swap_set_min;
alter table tnt_audit.summaryreports drop if exists swap_set_base;
alter table tnt_audit.summaryreports drop if exists swap_set_peak;

Create table if not exists "tnt_audit"."summaryreport_page_file_stats"
(
	"node_id" Integer NOT NULL,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"location" text not null, 
	"mgmt" text not null,
	"init_size" double precision,
	"max_size" double precision,

	primary key (node_id, start_date, end_date, location)
) partition by range (end_date) Without Oids;
-- we do look at start_date for rollup
create index if not exists summaryreports_pgfile_rpt_idx on tnt_audit.summaryreport_page_file_stats (node_id, start_date, end_date);
create index if not exists summaryreports_pgfile_end_time_idx on tnt_audit.summaryreport_page_file_stats (end_date);
create index if not exists summaryreports_pgfile_node_idx on tnt_audit.summaryreport_page_file_stats (node_id);

ALTER TABLE tnt_audit.summaryreport_page_file_stats OWNER TO impadmin;
REVOKE ALL ON TABLE tnt_audit.summaryreport_page_file_stats FROM PUBLIC;
REVOKE ALL ON TABLE tnt_audit.summaryreport_page_file_stats FROM impadmin;
GRANT ALL ON TABLE tnt_audit.summaryreport_page_file_stats TO impadmin;
GRANT SELECT ON TABLE tnt_audit.summaryreport_page_file_stats TO reports;
GRANT SELECT ON TABLE tnt_audit.summaryreport_page_file_stats TO vcops;

SELECT partman.create_parent('tnt_audit.summaryreport_page_file_stats', 'end_date', 'native', 'daily');
select partman.create_partition_time('tnt_audit.summaryreport_page_file_stats', ARRAY[date_trunc('day', now())]);
