drop function sys_df();
CREATE OR REPLACE FUNCTION sys_df()
RETURNS TABLE (device text, total_k bigint, used_k bigint, avail_k bigint, percent_used int, mountpoint text) as
'
BEGIN
    -- /dev/sdc1       10327040 311108  10015932   4% /var/lib/pgsql
    CREATE TEMP TABLE IF NOT EXISTS tmp_sys_df (device text, total_k bigint, used_k bigint, avail_k bigint, percent_used int, mountpoint text) ON COMMIT DROP;
    COPY tmp_sys_df FROM PROGRAM ''df | tail -n +2 | sed -e s/\ \ */,/g -e s/%//'' with delimiter '','';
    RETURN QUERY SELECT * FROM tmp_sys_df;
END;
'
Language 'plpgsql'
 Volatile
 Called On Null Input
 Security invoker;
ALTER FUNCTION sys_df() OWNER TO postgres;
COMMENT ON FUNCTION sys_df() IS 'Get UNIX file system information using copy';
