Create or Replace function "tnt_audit".Add_indexes(pSchemaName Text, pTable_Name TEXT, pColumn_Name TEXT)
Returns int As
' 
DECLARE
        count int;
        vTable record;
BEGIN
        raise warning ''Adding indexes in % partitions'',  pTable_Name;

        count := 0;
        FOR vTable in select schemaname, tablename from pg_tables where schemaname= pSchemaName and tablename like 
pTable_Name  LOOP
                raise warning ''Adding indexes in % partitions'', vTable.tablename;   
        execute ''DROP INDEX IF EXISTS ''||vTable.schemaname||''.'' || vTable.tablename ||''_''||
pColumn_Name||''_idx'';               
        execute ''CREATE INDEX ''||vTable.tablename||''_''||pColumn_Name||''_idx ON ''||vTable.schemaname||''.'' 
|| vTable.tablename ||'' USING BTREE''||''(''||pColumn_Name||'')'';  
                count := count+1;
        end loop; 
     return count; 
END;
' 
 Language 'plpgsql'
 Volatile
 Called On Null Input
 Security invoker;
--tnt_config.vdi_rating_profile (done)
SELECT "tnt_audit".Add_indexes('tnt_config','vdi_rating_profile', 'id');
SELECT "tnt_audit".Add_indexes('tnt_config','vdi_rating_profile', 'name');


--tnt_config.vdi_rating_profile_components (done)
SELECT "tnt_audit".Add_indexes('tnt_config','vdi_rating_profile_components ', 'rating_profile_id');
 

--tnt_config.virtualdisk (done)
SELECT "tnt_audit".Add_indexes('tnt_config','virtualdisk ', 'datastoreid');
 

--tnt_config.datastore 
SELECT "tnt_audit".Add_indexes('tnt_config','datastore', 'id');
SELECT "tnt_audit".Add_indexes('tnt_config','datastore', 'disk_names');

drop function tnt_audit.add_indexes(text, text, text);
