create or replace function "tnt_audit".recreate_connection_id_index()
returns integer as
'
declare
	indexName text;
	tableName text;
	indexCount int;
begin
	indexCount := 0;
	for indexName in select relname from pg_class where relname ilike ''connectattempt%connection_id'' LOOP
		raise debug ''Processing index: %'', indexName;
		select into tableName regexp_replace(indexName, ''(connectattempt_\d+_\d+)_connection_id'', ''\1'');
		raise debug ''Table is: %'', tableName;
		execute ''drop index tnt_audit.'' || indexName;
		execute ''create index '' || indexName || '' on tnt_audit.'' || tableName || '' (connection_id, has_app_details) where has_app_details = true'';
		indexCount := indexCount + 1;
	end loop;

	return indexCount;
end;
'
Language 'plpgsql'
 Volatile
 Called On Null Input
 Security invoker;

select tnt_audit.recreate_connection_id_index();
drop function tnt_audit.recreate_connection_id_index();
