
CREATE or replace FUNCTION get_user_last_active_date(integer)
RETURNS TIMESTAMP AS $$
   select end_date
     from tnt_audit.summaryreport_login_stats
    where user_id = $1
 order by end_date desc limit 1
$$ LANGUAGE SQL;

CREATE or replace FUNCTION get_vhost_name(integer)
RETURNS TEXT AS $$
   select name
     from tnt_config.vmhost
    where id = $1 and delete_time is null
 order by creation_time desc limit 1
$$ LANGUAGE SQL;


CREATE or replace FUNCTION get_vhost(TIMESTAMP WITHOUT TIME ZONE, integer)
RETURNS INTEGER AS $$
   select vmhost_id
     from tnt_config.node_vmhost
    where creation_time <= $1 and node_id = $2
 order by creation_time desc limit 1
$$ LANGUAGE SQL;

CREATE OR REPLACE FUNCTION array_max(text[])
RETURNS double precision AS $$
SELECT max(CASE WHEN v='' then NULL else v::numeric END)::double precision FROM unnest($1) g(v)
$$ LANGUAGE sql;

create table if not exists tnt_config.api_data (
    id serial,
    system integer default 0 not null,
    type character varying DEFAULT ''::character varying NOT NULL,
    api_data text DEFAULT ''::text NOT NULL,
    api_meta text DEFAULT ''::text NOT NULL,
    created_by character varying DEFAULT ''::character varying NOT NULL,
    created timestamp without time zone,
    last_updated_by character varying DEFAULT ''::character varying NOT NULL,
    last_updated timestamp without time zone,
    primary key (id)
);
alter table tnt_config.api_data OWNER TO impadmin;

Grant select on "tnt_config"."api_data" to "impadmin";
Grant update on "tnt_config"."api_data" to "impadmin";
Grant delete on "tnt_config"."api_data" to "impadmin";
Grant insert on "tnt_config"."api_data" to "impadmin";
Grant references on "tnt_config"."api_data" to "impadmin";
Grant select on "tnt_config"."api_data" to "reports";

