CREATE OR REPLACE VIEW tnt_config.lwl_vcops AS 
 SELECT ' '::text AS resourcename, ' '::text AS resourcekind, ' '::text AS adapterkind, now() AS "timestamp", ' '::text AS metricname1, 0::double precision AS value1, ' '::text AS metricname2, 0::double precision AS value2, ' '::text AS metricname3, 0::double precision AS value3, ' '::text AS metricname4, 0::double precision AS value4, ' '::text AS metricname5, 0::double precision AS value5, ' '::text AS metricname6, 0::double precision AS value6, ' '::text AS metricname7, 0::double precision AS value7, ' '::text AS metricname8, 0::double precision AS value8, ' '::text AS metricname9, 0::double precision AS value9, ' '::text AS metricname10, 0::double precision AS value10, ' '::text AS metricname11, 0::double precision AS value11, ' '::text AS metricname12, 0::double precision AS value12, ' '::text AS metricname13, 0::double precision AS value13, ' '::text AS metricname14, 0::double precision AS value14, ' '::text AS metricname15, 0::double precision AS value15, ' '::text AS metricname16, 0::double precision AS value16, ' '::text AS metricname17, 0::double precision AS value17, ' '::text AS metricname18, 0::double precision AS value18, ' '::text AS metricname19, 0::double precision AS value19, ' '::text AS metricname20, 0::double precision AS value20, ' '::text AS metricname21, 0::double precision AS value21, ' '::text AS metricname22, 0::double precision AS value22, ' '::text AS metricname23, 0::double precision AS value23, ' '::text AS metricname24, 0::double precision AS value24, ' '::text AS metricname25, 0::double precision AS value25, ' '::text AS metricname26, 0::double precision AS value26, ' '::text AS metricname27, 0::double precision AS value27, ' '::text AS metricname28, 0::double precision AS value28, ' '::text AS metricname29, 0::double precision AS value29, ' '::text AS metricname30, 0::double precision AS value30, ' '::text AS metricname31, 0::double precision AS value31, ' '::text AS metricname32, 0::double precision AS value32, ' '::text AS metricname33, 0::double precision AS value33, ' '::text AS metricname34, 0::double precision AS value34, ' '::text AS metricname35, 0::double precision AS value35, ' '::text AS metricname36, 0::double precision AS value36, ' '::text AS metricname37, 0::double precision AS value37, ' '::text AS metricname38, 0::double precision AS value38, ' '::text AS metricname39, 0::double precision AS value39, ' '::text AS metricname40, 0::double precision AS value40;

CREATE OR REPLACE FUNCTION tnt_config.func_lwl_vcops(timestamp,timestamp,text)
          returns setof tnt_config.lwl_vcops as
$$
DECLARE
    -- This function will export User Groups, Machine Groups and an intersect
    -- of 'User / Machine : Machine Group' from a combination of the User Groups
    -- and Machine Groups selected for export.
    --
    -- It will also auto create 6 groups, for all.
    -- Machine Groups: _All Machines, _All Machines Physical, _All Machines Virtual
    -- User Groups: _All Users, _All Users Physical, _All Users Virtual
    --
    -- This function requires a view called 'tnt_config.lwl_vcops' as the output format
    -- The options passed to it are the START_DATE, END_DATE and 'site id override'
    -- Putting something in the 3rd field will use that for the ADAPTERKIND, this
    -- is useful as a SITE-ID. When multiple Stratusphere feeds to VCOPS.
    -- When run, this function looks for flags that enable the interface and the export.
    -- If the VCOPS or the INTERFACE is not enabled, one record will returned,
    --            'CHECK LWL VCOPS SETTINGS'::text as RESOURCENAME
    --
    -- IF the START_DATE to END_DATE time is LESS then the CID callback, then the
    -- reporting time range will be expanded to attempt to get at least 1 CID per NODE.

    INTV text;
    MINS numeric;
    DIFF numeric;
    RECORD tnt_config.lwl_vcops%rowtype;
    var_START_DATE timestamp;
    var_END_DATE timestamp;
    RES_KIND text := 'Liquidware Labs-User Groups';
    RES_NODE_KIND text := 'Liquidware Labs-Machine Groups';
    RES_NODE_USER_KIND text := 'Liquidware Labs-User-Machine Group';

    BAD_KIND text := 'Liquidware Labs';
    ADAPTER text  := 'Stratusphere Adapter';
    var_VCOPS_ENABLED       numeric := 0;
    var_INTERFACE_ACTIVE    numeric := 0;
    var_VCOPS_MACHINE_GROUP numeric := 0;
    var_VCOPS_USER_GROUP    numeric := 0;
    var_USER_INTERSECT      numeric := 0;

BEGIN

    -- CHECK SWITCHES
    select CASE WHEN vcops_enabled is true THEN 1 ELSE 0 END
      from tnt_config.portalbase into var_VCOPS_ENABLED;

    select CASE WHEN vcops_interface_active is true THEN 1 ELSE 0 END
      from tnt_config.portalbase into var_INTERFACE_ACTIVE;

    select CASE WHEN vcops_export_usergroups is true THEN 1 ELSE 0 END
      from tnt_config.portalbase into var_VCOPS_USER_GROUP;

    select CASE WHEN vcops_export_nodegroups is true THEN 1 ELSE 0 END
    from tnt_config.portalbase into var_VCOPS_MACHINE_GROUP;

    select CASE WHEN vcops_user_machine_intersection is true THEN 1 ELSE 0 END
    from tnt_config.portalbase into var_USER_INTERSECT;




    IF ($3 <> '') THEN
        ADAPTER := $3;
    END IF;
    var_END_DATE := date_trunc('second', $2);

    -- GET DIFF IN REQUEST TIME
    select round(extract( epoch from (var_END_DATE::timestamp -  $1::timestamp)) /60)
                 into DIFF;
    IF NOT FOUND THEN
       DIFF := 1;
    END IF;

    -- GET CID CALLBACK INTERVAL
    select round((max(COALESCE(defaultihostupdateinterval+1,1)) * 1.1)) into MINS
      from  tnt_config.portalbase;
    IF NOT FOUND THEN
       MINS := 67;
    END IF;
   --MINS := 67;

    IF (MINS::numeric > DIFF::numeric) THEN
        MINS := MINS - DIFF;
        INTV := MINS::text || ' minutes';
        var_START_DATE := $1 - INTV::interval;
        --var_START_DATE := $1;
    ELSE
        var_START_DATE := $1;
    END IF;
    var_START_DATE := date_trunc('second', var_START_DATE);


FOR RECORD IN


with
PN as (
    select id
     from tnt_config.policynode pn
    where delete_time is null and pn.type <= 2
),

NGN as (
   select nodeid,
          nodegroupid
     from tnt_config.nodegroup_node ngn
     join tnt_config.policynode pn on (ngn.nodegroupid = pn.id)
     join tnt_config.nodegroup  ng on (ngn.nodegroupid = ng.id)
    where ngn.delete_time is null
      and ng.vcops_monitor is TRUE
  UNION
   select id as nodeid,
          -1 as nodegroupid
     from tnt_config.node
    where delete_time is null
  UNION
   select id as nodeid,
          -2 as nodegroupid
     from tnt_config.node
    where delete_time is null
      and vmtype is null
  UNION
   select id as nodeid,
          -3 as nodegroupid
     from tnt_config.node
    where delete_time is null
      and vmtype is not null
),

  macgrp as (
     select -1 as id, '_All Machines' as name
  UNION
     select -2 as id, '_All Machines Physical' as name
  UNION
     select -3 as id, '_All Machines Virtual' as name
  UNION
     select id, name from tnt_config.policynode
),


ALL_USER_NGN as (
   select id as nodeid,
          -1 as nodegroupid
     from tnt_config.node
    where delete_time is null
  UNION
   select id as nodeid,
          -2 as nodegroupid
     from tnt_config.node
    where delete_time is null
      and vmtype is null
  UNION
   select id as nodeid,
          -3 as nodegroupid
     from tnt_config.node
    where delete_time is null
      and vmtype is not null
),

  all_user_macgrp as (
     select -1 as id, '_All Users' as name
  UNION
     select -2 as id, '_All Users Physical' as name
  UNION
     select -3 as id, '_All Users Virtual' as name
  UNION
     select id, name from tnt_config.policynode
),

USER_COUNT_NODE_GROUP as (
  select nodegroupid as nodegroup_id,
         count(distinct user_id) as user_count
     from tnt_config.nodegroup_node ngn
     join tnt_config.policynode pn on (ngn.nodegroupid = pn.id)
     join tnt_config.nodegroup  ng on (ngn.nodegroupid = ng.id)
     join tnt_audit.summaryreport_login_stats s on (ngn.nodeid = s.node_id)
    WHERE s.end_date between var_start_date and var_end_date
     and  ngn.delete_time is null
     and ng.vcops_monitor is TRUE
 group by nodegroupid
  UNION
   select -1 as nodegroup_id,
           count(distinct user_id) as user_count
      from tnt_audit.summaryreport_login_stats s
     WHERE s.end_date between var_start_date and var_end_date
 UNION
   select -2 as nodegroup_id,
          count(distinct user_id) as user_count
     from tnt_audit.summaryreport_login_stats s
     join tnt_config.node on node.id = s.node_id and delete_time is null and vmtype is null
     WHERE s.end_date between var_start_date and var_end_date
 UNION
   select -3 as nodegroup_id,
          count(distinct user_id) as user_count
     from tnt_audit.summaryreport_login_stats s
     join tnt_config.node on node.id = s.node_id and delete_time is null and vmtype is not null
     WHERE s.end_date between var_start_date and var_end_date

),


CPU_SUM as(
     SELECT n.id cpu_node_id,
            os_id,
            ihostversion,
            CASE WHEN vmtype is null then 0 else 1 END as is_vm,
            ROUND(sum(c.cores)::numeric)               as sum_cores,
            ROUND(avg(c.speed_mhz)::numeric)           as avg_speed_mhz,
            ROUND(sum(c.speed_mhz * c.cores)::numeric) as sum_speed_mhz

       FROM tnt_config.node n,
            tnt_config.node_hardware_cpus c
      WHERE c.hardware_id = n.hardware_id
      GROUP BY n.id, n.os_id, n.ihostversion

),

GPU_NODE as (
    select node_id, end_date,
           avg(core_avg) as core_avg
      from tnt_audit.summaryreport_gpu_stats s
     WHERE s.end_date between var_start_date and var_end_date
  group by node_id,end_date
),

LOGIN_DELAY_NODE as (
   select node_id delay_node_id,
           end_date,
          ROUND(avg(CASE WHEN first_record is true THEN login_delay_ms ELSE NULL END)::numeric)
                  as login_delay_ms,
          ROUND(sum(CASE WHEN first_record is true THEN 1 ELSE 0 END)::numeric) as login_count,
          ROUND(sum(CASE WHEN logout_time is not null THEN 1 ELSE 0 END)::numeric) as logout_count
      from tnt_audit.summaryreport_login_stats s
     WHERE s.end_date between var_start_date and var_end_date
       AND s.end_date != s.start_date
  group by node_id, end_date
),

LOGIN_DELAY_NODE_USER as (
   select node_id delay_node_id,
          user_id delay_user_id,
          end_date,
          ROUND(avg(CASE WHEN first_record is true THEN login_delay_ms ELSE NULL END)::numeric)
                  as login_delay_ms,
          ROUND(sum(CASE WHEN first_record is true THEN 1 ELSE 0 END)::numeric) as login_count,
          ROUND(sum(CASE WHEN logout_time is not null THEN 1 ELSE 0 END)::numeric) as logout_count
      from tnt_audit.summaryreport_login_stats s
     WHERE s.end_date between var_start_date and var_end_date
       AND s.end_date != s.start_date
  group by node_id, user_id, end_date
),


tmp_node_disk as (
   select s.node_id,
          s.name,
          is_network,
          s.end_date,
          extract(epoch from s.end_date - s.start_date) as  cid_seconds,
          1 as DISK_COUNT,
          ' '::text,
          ((extract(epoch from s.end_date - s.start_date)*
                    read_avg)+read_peak)  as read_iops_sum,
          read_avg                         as read_iops_avg,
          ' '::text,
          ((extract(epoch from s.end_date - s.start_date)*
                    write_avg)+write_peak)  as write_iops_sum,
          (write_avg)                        as write_iops_avg,
          ' '::text,
          ((extract(epoch from s.end_date - s.start_date)* 1024 * read_io_avg)+read_io_peak)        as  read_IO_sum,
          (read_io_avg*1024)                 as  read_io_avg,
          ' '::text,
          ((extract(epoch from s.end_date - s.start_date)* 1024 * write_io_avg)+write_io_peak)       as  write_IO_sum,
          (write_io_avg*1024)                as write_io_avg,
          ' '::text,
          avg_used  as avg_used,
          size      as avg_size,
          ' '::text,
          queue_avg as queue_avg
     from tnt_audit.summaryreport_partition_stats s
     WHERE s.end_date between var_start_date and var_end_date
       AND s.end_date != s.start_date
      and extract(epoch from s.end_date - s.start_date) < 15000
      and extract(epoch from s.end_date - s.start_date) > 0
      and COALESCE(read_io_avg,0) < 2000000
      and COALESCE(write_io_avg,0) < 2000000

),
node_disk as (
   select s.node_id                              as disk_node_id,
          s.end_date                             as end_date,
          ' '::text,
          avg(cid_seconds)      as cid_seconds,
          sum(disk_count)       as DISK_COUNT,
          ' '::text,
          SUM(read_iops_sum)                      as sum_read_IOPS,
          (SUM(read_iops_sum) / (avg(cid_seconds)+.001)) as read_iops_avg,
          ' '::text,
          SUM(write_iops_sum)                     as sum_write_IOPS,
          (SUM(write_iops_sum) / (avg(cid_seconds)+.001)) as write_iops_avg,
          ' '::text,
          SUM(read_io_sum)                        as sum_read_IO,
          (SUM(read_io_sum) / (avg(cid_seconds)+.001))   as read_io_bps,
          ' '::text,
          SUM(write_io_sum)                       as sum_write_IO,
          (SUM(write_io_sum) / (avg(cid_seconds)+.001))  as write_io_bps,
          ' '::text,
          SUM(avg_used/1048576)                   as avg_used_gb,
          SUM(avg_size/1048576)                   as avg_size_gb,
          ' '::text,
          SUM(queue_avg)                          as queue_avg
     from tmp_node_disk s
    where 1=1
 group by s.node_id, s.end_date
),

tmp_node_net as (
   select s.node_id,
          s.end_date,
          ' '::text,
          s.name                                        as nic_name,
          extract(epoch from s.end_date - s.start_date) as cid_seconds,
          1                                             as NIC_COUNT,
          ' '::text,
          (send_total*1024)                          as sum_send_total_bytes,
          ((send_total*1024) / ((extract(epoch from s.end_date - s.start_date))+1))
                                                     as send_total_bps,
          ' '::text,
          (receive_total*1024)                       as sum_receive_total_bytes,
          (receive_total*1024) / ((extract(epoch from s.end_date - s.start_date))+1)
                                                     as receive_total_bps
     from tnt_audit.summaryreport_nic_stats s
     WHERE s.end_date between var_start_date and var_end_date
       AND s.end_date != s.start_date
       and COALESCE((receive_total*1024) / ((extract(epoch from s.end_date - s.start_date))+1),0) < 2000000000
       and COALESCE((send_total*1024) / ((extract(epoch from s.end_date - s.start_date))+1),0) < 2000000000
),

node_net as (
   select s.node_id                              as net_node_id,
          s.end_date,
          avg(cid_seconds)                       as cid_seconds,
          sum(nic_count)                                  as nic_COUNT,
          ' '::text,
          SUM(sum_send_total_bytes)                       as sum_send_total_bytes,
          (SUM(sum_send_total_bytes) / (avg(cid_seconds)+.001))  as send_bps,
          ' '::text,
          SUM(sum_receive_total_bytes)                     as sum_receive_total_bytes,
          SUM(sum_receive_total_bytes) / (avg(cid_seconds)+.001) as receive_bps
     from tmp_node_net s
 group by s.node_id, s.end_date
),

xnode_pr as (
   select s.node_id   as pr_node_id,
               end_date,
               avg(graph_avg) as graph_avg,
               AVG( CASE WHEN s.first_record is TRUE and
                              launch_delay_ms > 1000
                         THEN s.launch_delay_ms
                         ELSE NULL END )/1000          as launch_delay_ms
          from tnt_audit.summaryreport_process_stats s
     WHERE s.end_date between var_start_date and var_end_date
      group by s.node_id,  s.end_date
),

sumrpt_user_group as (
    SELECT
            COALESCE(pi.id,0)           as user_group_id,
            COALESCE((pi.name),'')      as user_group_name,
            count(distinct l.user_id)    as user_count,
            ROUND( (SUM(round(extract(epoch from s.end_date - s.start_date)::numeric)) /
                   COALESCE( count(distinct COALESCE(l.user_id,0)),1)  )::numeric,0) as cid_seconds,

            CASE WHEN ROUND(AVG(login.login_delay_ms/1000)::numeric,0) = 0
              THEN NULL
              ELSE ROUND(AVG(login.login_delay_ms/1000)::numeric,0)
             END  as Login_Delay_avg,

           count(distinct s.node_id)  as node_count,
           count(distinct ncpu.os_id)                   as os_count,
           count(distinct ncpu.ihostversion)            as cid_version_count,
           count(*)                                     as record_count,
           SUM(COALESCE(login_count,0))                 as login_count,
           SUM(logout_count)                            as logout_count,
           ' '::text,
           round(avg(s.vdi_ux_overall)::numeric,2)      as Overall_UX_Rating_avg,
           round(avg(s.vdi_fit_overall)::numeric,2)     as Overall_FIT_Rating_avg,
           ' '::text,
           ROUND(AVG(p.launch_delay_ms)::numeric,1)     as Application_Load_Time_avg,
           ROUND(avg(p.graph_avg)::numeric,0)           as GDI_Objects,
           ROUND(avg(gpu.core_avg)::numeric,1)          as GPU_percent_used,
           round(avg(s.total_app_pf)::numeric,0)        as Page_Faults_Soft,
           round(avg(s.swap_pf_avg)::numeric,0)         as Page_Faults_Hard,
           ROUND(sum(s.total_app_anr)::numeric,0)       as Non_Responding_Apps,
           ROUND(avg(s.avg_center_nrt/1000)::numeric,3) as Network_Latency_ms_avg,
           round(avg(s.avg_inc_nrt/1000)::numeric,3)    as avg_inc_nrt,
           round(sum(s.inc_conn_count)::numeric,0)      as Failed_Connects,

           ' '::text,

           ROUND((AVG(ncpu.sum_cores))::numeric,1)               as Total_Cores_CPUs,
           ROUND((AVG(ncpu.sum_cores)*count(distinct l.user_id))::numeric,1)   as sum_Total_Cores_CPUs,
           ROUND((AVG(ncpu.sum_speed_mhz))::numeric)             as CPU_Allocated_Mhz,
           ROUND((AVG(ncpu.sum_speed_mhz)*count(distinct l.user_id))::numeric) as sum_CPU_Allocated_Mhz,
           round(AVG(CASE WHEN s.cpu_queue_avg = 0 THEN NULL ELSE s.cpu_queue_avg END)::NUMERIC,2)
               as CPU_Queue_Length_avg,

           round(avg(s.cpu_cswitch_avg)::numeric,2)              as CPU_Context_switching_avg,
           round(avg(s.cpu_iowait_avg)::numeric,2)               as CPU_IO_wait_avg,
           ' '::text,
           ROUND((AVG((s.cpu_avg_sys * ncpu.sum_speed_mhz)/100))::numeric,1)
                                                                             as CPU_Sys_Mhz,
           ROUND((AVG((s.cpu_avg_sys * ncpu.sum_speed_mhz)/100)*count(distinct l.user_id))::numeric,1)
                                                                             as sum_CPU_Sys_Mhz,

           ROUND(((ROUND(AVG((s.cpu_avg_sys * ncpu.sum_speed_mhz) /
                 100)::numeric,1)) /  (ROUND(AVG(ncpu.sum_speed_mhz)::numeric)+.001) *
                 100)::numeric,1)                                            as CPU_Sys_Percent,
           ROUND((AVG((s.cpu_avg_user * ncpu.sum_speed_mhz)/100))::numeric,1)
                                                                             as CPU_User_Mhz,
           ROUND((AVG((s.cpu_avg_user * ncpu.sum_speed_mhz)/100)*count(distinct l.user_id))::numeric,1)
                                                                             as sum_CPU_User_Mhz,

           ROUND(((ROUND(AVG((s.cpu_avg_user  * ncpu.sum_speed_mhz) /
                 100)::numeric,1)) / (ROUND(AVG(ncpu.sum_speed_mhz)::numeric)+.001) *
                 100)::numeric,1)                                            as CPU_User_Percent,

           ROUND((AVG((s.cpu_avg_user * ncpu.sum_speed_mhz)/100))::numeric,1) +
           ROUND((AVG((s.cpu_avg_sys  * ncpu.sum_speed_mhz)/100))::numeric,1)
                                                                             as CPU_Used_Mhz,
           ROUND((AVG((s.cpu_avg_user * ncpu.sum_speed_mhz)/100)*count(distinct l.user_id))::numeric,1) +
           ROUND((AVG((s.cpu_avg_sys  * ncpu.sum_speed_mhz)/100)*count(distinct l.user_id))::numeric,1)
                                                                             as sum_CPU_Used_Mhz,


           ROUND(((ROUND(AVG((s.cpu_avg_sys   * ncpu.sum_speed_mhz)/100)::numeric,1) +
                 ROUND(AVG((s.cpu_avg_user  * ncpu.sum_speed_mhz) /
                 100)::numeric,1)) / (ROUND(AVG(ncpu.sum_speed_mhz)::numeric)+.001) *
                 100)::numeric,1)                                            as CPU_Used_Percent,
           ' '::text,
          round((AVG(s.mem_avg/1024))::numeric,0)                       as Memory_Used_mb,
          round((AVG(s.mem_avg/1024)*count(distinct l.user_id))::numeric,0)           as sum_Memory_Used_mb,
          round(((AVG(s.mem_avg) / (AVG(s.mem_alloc)+.001)) * 100)::numeric,1) as Memory_Used_Percent,
          round((AVG(s.mem_alloc/1024))::numeric,0)                     as Memory_Allocated_mb,
          round((AVG(s.mem_alloc/1024)*count(distinct l.user_id))::numeric,0)         as sum_Memory_Allocated_mb,
          ' '::text,
          round((AVG(s.swap_avg/1024))::numeric,0)                        as Page_Used_mb,
          round((AVG(s.swap_avg/1024)*count(distinct l.user_id))::numeric,0)            as sum_Page_Used_mb,
          round(((AVG(s.swap_avg) / (AVG(s.swap_alloc)+.001)) * 100)::numeric,1) as Page_Used_Percent,
          round((AVG(s.swap_alloc/1024))::numeric,0)                      as Page_Allocated_mb,
          round((AVG(s.swap_alloc/1024)*count(distinct l.user_id))::numeric,0)          as sum_Page_Allocated_mb,
           ' '::text,
          round((AVG(disk_count)*count(distinct l.user_id))::numeric,1)        as DISK_COUNT,
          round((AVG(disk_count))::numeric,1)                    as sum_DISK_COUNT,
          ' '::text,
          SUM(sum_read_iops)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as read_iops,
          SUM(sum_write_iops) / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as write_iops,
          SUM(sum_read_iops)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) +
          SUM(sum_write_iops) / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as total_iops,
          ' '::text,
          round(SUM(sum_read_iops)::numeric,2)                                 as sum_read_IOPS,
          round(SUM(sum_write_iops)::numeric,2)                                as sum_write_IOPS,
          round(SUM(sum_read_iops)::numeric,2) + round(SUM(sum_write_iops)::numeric,2)
                                                                               as sum_total_IOPS,
          ' '::text,
          SUM(sum_read_io)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as read_io_bps,
          SUM(sum_write_io) / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as write_io_bps,
          SUM(sum_read_io)  / SUM( ((extract(epoch from s.end_date - s.start_date)+1))) +
            SUM(sum_write_io) / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as total_io_bps,
          ' '::text,
          round(SUM(sum_read_io)::numeric,0)                                   as sum_read_IO,
          round(SUM(sum_write_io)::numeric,0)                                  as sum_write_IO,
          round(SUM(sum_read_io)::numeric,0) +  round(SUM(sum_write_io)::numeric,0)
                                                                               as sum_total_IO,
          ' '::text,
          round(AVG(avg_used_gb)::NUMERIC,2)                        as disk_used_gb,
          round((AVG(avg_used_gb)*count(distinct l.user_id))::NUMERIC,2)          as sum_disk_used_gb,
          round(((AVG(avg_used_gb) / (AVG(avg_size_gb)+.001)) * 100)::numeric,1)  as Disk_Used_Percent,
          round(AVG(avg_size_gb)::NUMERIC,2)                        as disk_size_gb,
          round((AVG(avg_size_gb)*count(distinct l.user_id))::NUMERIC,2)          as sum_disk_size_gb,
          round(AVG(CASE WHEN queue_avg = 0 THEN NULL ELSE queue_avg END)::NUMERIC,2)
               as disk_Queue_avg,
          ' '::text,
          round((AVG(nic_count))::numeric,1)             as nic_COUNT,
          round((AVG(nic_count)*count(distinct l.user_id))::numeric,1) as sum_nic_COUNT,
          ' '::text,
          SUM(sum_send_total_bytes)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1))
                                                                     as net_send_bps,
          SUM(sum_receive_total_bytes)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1))
                                                                     as net_receive_bps,
          SUM(sum_send_total_bytes)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) +
            SUM(sum_receive_total_bytes)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1))
                                                                     as net_total_bps,
          ' '::text,
          round(SUM(sum_send_total_bytes)::numeric,0)                as sum_send_bytes,
          round(SUM(sum_receive_total_bytes)::numeric,0)             as sum_receive_bytes,
          round(SUM(sum_send_total_bytes)::numeric,0) +
               round(SUM(sum_receive_total_bytes)::numeric,0)        as sum_net_total_bytes,
           ' '::text,
          round(avg(s.vdi_ux_x)::numeric,2)          as VDI_UX_x_avg,
          round(avg(s.vdi_ux_y)::numeric,2)          as VDI_UX_y_avg

      FROM tnt_audit.summaryreports s
      join PN on node_id = pn.id
 left join cpu_sum   ncpu
        on s.node_id    = ncpu.cpu_node_id
 left join GPU_NODE gpu
        on s.node_id    = gpu.node_id   and s.end_date   = gpu.end_date
 left join node_net   net
        on s.node_id    = net.net_node_id   and s.end_date   = net.end_date
 left join node_disk  d
        on s.node_id    = d.disk_node_id    and s.end_date   = d.end_date
 left join xnode_pr    p
        on s.node_id    = p.pr_node_id      and s.end_date   = p.end_date
 left join tnt_config.node    on node.id   = s.node_id

  left JOIN tnt_audit.summaryreport_login_stats l
        on s.node_id    = l.node_id and
           s.start_date = l.start_date and
           s.end_date   = l.end_date and logout_time is null

 left join tnt_config.identitygroup_identity igi
        on igi.uid = user_id and igi.delete_time is null
 left join tnt_config.policyidentity pi
        on pi.id = igi.groupid and pi.delete_time is null
     join tnt_config.identitygroup g
        on g.id = igi.groupid and vcops_monitor is TRUE

 left join LOGIN_DELAY_NODE_USER login
        on s.node_id = login.delay_node_id  and
           l.user_id = login.delay_user_id and
           s.end_date = login.end_date
     WHERE s.end_date between var_start_date and var_end_date
       AND s.end_date != s.start_date
       and extract(epoch from s.end_date - s.start_date) < 15000
       and extract(epoch from s.end_date - s.start_date) > 0
  GROUP BY  COALESCE(pi.id,0),COALESCE((pi.name),'')
),



data_sql as (
 select s.*
     from sumrpt_user_group s
    where 1=1
),

sumrpt_node_group as (
    SELECT
            COALESCE(ngn.nodegroupid,0)     as node_group_id,
            COALESCE((macgrp.name),'')      as node_group_name,
            0                               as user_count,
            ROUND( (SUM(round(extract(epoch from s.end_date - s.start_date)::numeric)) /
                    COALESCE(count(distinct COALESCE(s.node_id,0)),1) )::numeric,0) as cid_seconds,

            CASE WHEN ROUND(AVG(login.login_delay_ms/1000)::numeric,0) = 0
              THEN NULL
              ELSE ROUND(AVG(login.login_delay_ms/1000)::numeric,0)
             END  as Login_Delay_avg,

           count(distinct s.node_id)  as node_count,
           count(distinct ncpu.os_id)                   as os_count,
           count(distinct ncpu.ihostversion)            as cid_version_count,
           count(*)                                     as record_count,
           SUM(COALESCE(login_count,0))                 as login_count,
           SUM(logout_count)                            as logout_count,
           ' '::text,
           round(avg(s.vdi_ux_overall)::numeric,2)      as Overall_UX_Rating_avg,
           round(avg(s.vdi_fit_overall)::numeric,2)     as Overall_FIT_Rating_avg,
           ' '::text,
           ROUND(AVG(p.launch_delay_ms)::numeric,1)     as Application_Load_Time_avg,
           ROUND(avg(p.graph_avg)::numeric,0)           as GDI_Objects,
           ROUND(avg(gpu.core_avg)::numeric,1)          as GPU_percent_used,
           round(avg(s.total_app_pf)::numeric,0)        as Page_Faults_Soft,
           round(avg(s.swap_pf_avg)::numeric,0)         as Page_Faults_Hard,
           ROUND(sum(s.total_app_anr)::numeric,0)       as Non_Responding_Apps,
           ROUND(avg(s.avg_center_nrt/1000)::numeric,3) as Network_Latency_ms_avg,
           round(avg(s.avg_inc_nrt/1000)::numeric,3)    as avg_inc_nrt,
           round(sum(s.inc_conn_count)::numeric,0)      as Failed_Connects,

           ' '::text,

           ROUND((AVG(ncpu.sum_cores))::numeric,1)               as Total_Cores_CPUs,
           ROUND((AVG(ncpu.sum_cores)*count(distinct s.node_id))::numeric,1)   as sum_Total_Cores_CPUs,
           ROUND((AVG(ncpu.sum_speed_mhz))::numeric)             as CPU_Allocated_Mhz,
           ROUND((AVG(ncpu.sum_speed_mhz)*count(distinct s.node_id))::numeric) as sum_CPU_Allocated_Mhz,
           round(AVG(CASE WHEN s.cpu_queue_avg = 0 THEN NULL ELSE s.cpu_queue_avg END)::NUMERIC,2)
               as CPU_Queue_Length_avg,

           round(avg(s.cpu_cswitch_avg)::numeric,2)              as CPU_Context_switching_avg,
           round(avg(s.cpu_iowait_avg)::numeric,2)               as CPU_IO_wait_avg,
           ' '::text,
           ROUND((AVG((s.cpu_avg_sys * ncpu.sum_speed_mhz)/100))::numeric,1)
                                                                             as CPU_Sys_Mhz,
           ROUND((AVG((s.cpu_avg_sys * ncpu.sum_speed_mhz)/100)*count(distinct s.node_id))::numeric,1)
                                                                             as sum_CPU_Sys_Mhz,

           ROUND(((ROUND(AVG((s.cpu_avg_sys * ncpu.sum_speed_mhz) /
                 100)::numeric,1)) / ( ROUND(AVG(ncpu.sum_speed_mhz)::numeric)+.001) *
                 100)::numeric,1)                                            as CPU_Sys_Percent,
           ROUND((AVG((s.cpu_avg_user * ncpu.sum_speed_mhz)/100))::numeric,1)
                                                                             as CPU_User_Mhz,
           ROUND((AVG((s.cpu_avg_user * ncpu.sum_speed_mhz)/100)*count(distinct s.node_id))::numeric,1)
                                                                             as sum_CPU_User_Mhz,

           ROUND(((ROUND(AVG((s.cpu_avg_user  * ncpu.sum_speed_mhz) /
                 100)::numeric,1)) / (ROUND(AVG(ncpu.sum_speed_mhz)::numeric)+.001) *
                 100)::numeric,1)                                            as CPU_User_Percent,

           ROUND((AVG((s.cpu_avg_user * ncpu.sum_speed_mhz)/100))::numeric,1) +
           ROUND((AVG((s.cpu_avg_sys  * ncpu.sum_speed_mhz)/100))::numeric,1)
                                                                             as CPU_Used_Mhz,
           ROUND((AVG((s.cpu_avg_user * ncpu.sum_speed_mhz)/100)*count(distinct s.node_id))::numeric,1) +
           ROUND((AVG((s.cpu_avg_sys  * ncpu.sum_speed_mhz)/100)*count(distinct s.node_id))::numeric,1)
                                                                             as sum_CPU_Used_Mhz,


           ROUND(((ROUND(AVG((s.cpu_avg_sys   * ncpu.sum_speed_mhz)/100)::numeric,1) +
                 ROUND(AVG((s.cpu_avg_user  * ncpu.sum_speed_mhz) /
                 100)::numeric,1)) / (ROUND(AVG(ncpu.sum_speed_mhz)::numeric)+.001) *
                 100)::numeric,1)                                            as CPU_Used_Percent,
           ' '::text,
          round((AVG(s.mem_avg/1024))::numeric,0)                       as Memory_Used_mb,
          round((AVG(s.mem_avg/1024)*count(distinct s.node_id))::numeric,0)           as sum_Memory_Used_mb,
          round(((AVG(s.mem_avg) / (AVG(s.mem_alloc)+.001)) * 100)::numeric,1) as Memory_Used_Percent,
          round((AVG(s.mem_alloc/1024))::numeric,0)                     as Memory_Allocated_mb,
          round((AVG(s.mem_alloc/1024)*count(distinct s.node_id))::numeric,0)         as sum_Memory_Allocated_mb,
          ' '::text,
          round((AVG(s.swap_avg/1024))::numeric,0)                        as Page_Used_mb,
          round((AVG(s.swap_avg/1024)*count(distinct s.node_id))::numeric,0)            as sum_Page_Used_mb,
          round(((AVG(s.swap_avg) / (AVG(s.swap_alloc)+.001)) * 100)::numeric,1) as Page_Used_Percent,
          round((AVG(s.swap_alloc/1024))::numeric,0)                      as Page_Allocated_mb,
          round((AVG(s.swap_alloc/1024)*count(distinct s.node_id))::numeric,0)          as sum_Page_Allocated_mb,
           ' '::text,
          round((AVG(disk_count)*count(distinct s.node_id))::numeric,1)        as DISK_COUNT,
          round((AVG(disk_count))::numeric,1)                    as sum_DISK_COUNT,
          ' '::text,
          SUM(sum_read_iops)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as read_iops,
          SUM(sum_write_iops) / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as write_iops,
          SUM(sum_read_iops)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) +
          SUM(sum_write_iops) / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as total_iops,
          ' '::text,
          round(SUM(sum_read_iops)::numeric,2)                                 as sum_read_IOPS,
          round(SUM(sum_write_iops)::numeric,2)                                as sum_write_IOPS,
          round(SUM(sum_read_iops)::numeric,2) + round(SUM(sum_write_iops)::numeric,2)
                                                                               as sum_total_IOPS,
          ' '::text,
          SUM(sum_read_io)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as read_io_bps,
          SUM(sum_write_io) / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as write_io_bps,
          SUM(sum_read_io)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) +
            SUM(sum_write_io) / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as total_io_bps,
          ' '::text,
          round(SUM(sum_read_io)::numeric,0)                                   as sum_read_IO,
          round(SUM(sum_write_io)::numeric,0)                                  as sum_write_IO,
          round(SUM(sum_read_io)::numeric,0) +  round(SUM(sum_write_io)::numeric,0)
                                                                               as sum_total_IO,
          ' '::text,
          round(AVG(avg_used_gb)::NUMERIC,2)                        as disk_used_gb,
          round((AVG(avg_used_gb)*count(distinct s.node_id))::NUMERIC,2)          as sum_disk_used_gb,
          round(((AVG(avg_used_gb) / (AVG(avg_size_gb)+.001)) * 100)::numeric,1)  as Disk_Used_Percent,
          round(AVG(avg_size_gb)::NUMERIC,2)                        as disk_size_gb,
          round((AVG(avg_size_gb)*count(distinct s.node_id))::NUMERIC,2)          as sum_disk_size_gb,
          round(AVG(CASE WHEN queue_avg = 0 THEN NULL ELSE queue_avg END)::NUMERIC,2)
               as disk_Queue_avg,
          ' '::text,
          round((AVG(nic_count))::numeric,1)             as nic_COUNT,
          round((AVG(nic_count)*count(distinct s.node_id))::numeric,1) as sum_nic_COUNT,
          ' '::text,
          SUM(sum_send_total_bytes)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1))
                                                                     as net_send_bps,
          SUM(sum_receive_total_bytes)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1))
                                                                     as net_receive_bps,
          SUM(sum_send_total_bytes)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) +
            SUM(sum_receive_total_bytes)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1))
                                                                     as net_total_bps,
          ' '::text,
          round(SUM(sum_send_total_bytes)::numeric,0)                as sum_send_bytes,
          round(SUM(sum_receive_total_bytes)::numeric,0)             as sum_receive_bytes,
          round(SUM(sum_send_total_bytes)::numeric,0) +
               round(SUM(sum_receive_total_bytes)::numeric,0)        as sum_net_total_bytes,
           ' '::text,
          round(avg(s.vdi_ux_x)::numeric,2)          as VDI_UX_x_avg,
          round(avg(s.vdi_ux_y)::numeric,2)          as VDI_UX_y_avg

      FROM tnt_audit.summaryreports s
      join PN on s.node_id = pn.id
 left join cpu_sum   ncpu
        on s.node_id    = ncpu.cpu_node_id
 left join GPU_NODE gpu
        on s.node_id    = gpu.node_id   and s.end_date   = gpu.end_date
 left join node_net   net
        on s.node_id    = net.net_node_id   and s.end_date   = net.end_date
 left join node_disk  d
        on s.node_id    = d.disk_node_id    and s.end_date   = d.end_date
 left join xnode_pr    p
        on s.node_id    = p.pr_node_id      and s.end_date   = p.end_date
 left join tnt_config.node    on node.id   = s.node_id

 left join NGN    on ngn.nodeid = s.node_id
 left join macgrp on macgrp.id = ngn.nodegroupid

 left join LOGIN_DELAY_NODE login
        on s.node_id = login.delay_node_id  and
           s.end_date = login.end_date
     WHERE s.end_date between var_start_date and var_end_date
       AND s.end_date != s.start_date
       and extract(epoch from s.end_date - s.start_date) < 15000
       and extract(epoch from s.end_date - s.start_date) > 0

  GROUP BY COALESCE(ngn.nodegroupid,0), COALESCE((macgrp.name),'')
),

m_data_sql as (
 select s.*
     from sumrpt_node_group s
    where 1=1
),


sumrpt_all_user_group as (
    SELECT
            COALESCE(ngn.nodegroupid,0)     as node_group_id,
            COALESCE((macgrp.name),'')      as node_group_name,
            0                               as user_count,
            ROUND( (SUM(round(extract(epoch from s.end_date - s.start_date)::numeric)) /
                    COALESCE(count(distinct COALESCE(s.node_id,0)),1) )::numeric,0) as cid_seconds,

            CASE WHEN ROUND(AVG(login.login_delay_ms/1000)::numeric,0) = 0
              THEN NULL
              ELSE ROUND(AVG(login.login_delay_ms/1000)::numeric,0)
             END  as Login_Delay_avg,

           count(distinct s.node_id)  as node_count,
           count(distinct ncpu.os_id)                   as os_count,
           count(distinct ncpu.ihostversion)            as cid_version_count,
           count(*)                                     as record_count,
           SUM(COALESCE(login_count,0))                 as login_count,
           SUM(logout_count)                            as logout_count,
           ' '::text,
           round(avg(s.vdi_ux_overall)::numeric,2)      as Overall_UX_Rating_avg,
           round(avg(s.vdi_fit_overall)::numeric,2)     as Overall_FIT_Rating_avg,
           ' '::text,
           ROUND(AVG(p.launch_delay_ms)::numeric,1)     as Application_Load_Time_avg,
           ROUND(avg(p.graph_avg)::numeric,0)           as GDI_Objects,
           ROUND(avg(gpu.core_avg)::numeric,1)          as GPU_percent_used,
           round(avg(s.total_app_pf)::numeric,0)        as Page_Faults_Soft,
           round(avg(s.swap_pf_avg)::numeric,0)         as Page_Faults_Hard,
           ROUND(sum(s.total_app_anr)::numeric,0)       as Non_Responding_Apps,
           ROUND(avg(s.avg_center_nrt/1000)::numeric,3) as Network_Latency_ms_avg,
           round(avg(s.avg_inc_nrt/1000)::numeric,3)    as avg_inc_nrt,
           round(sum(s.inc_conn_count)::numeric,0)      as Failed_Connects,

           ' '::text,

           ROUND((AVG(ncpu.sum_cores))::numeric,1)               as Total_Cores_CPUs,
           ROUND((AVG(ncpu.sum_cores)*count(distinct s.node_id))::numeric,1)   as sum_Total_Cores_CPUs,
           ROUND((AVG(ncpu.sum_speed_mhz))::numeric)             as CPU_Allocated_Mhz,
           ROUND((AVG(ncpu.sum_speed_mhz)*count(distinct s.node_id))::numeric) as sum_CPU_Allocated_Mhz,
           round(AVG(CASE WHEN s.cpu_queue_avg = 0 THEN NULL ELSE s.cpu_queue_avg END)::NUMERIC,2)
               as CPU_Queue_Length_avg,

           round(avg(s.cpu_cswitch_avg)::numeric,2)              as CPU_Context_switching_avg,
           round(avg(s.cpu_iowait_avg)::numeric,2)               as CPU_IO_wait_avg,
           ' '::text,
           ROUND((AVG((s.cpu_avg_sys * ncpu.sum_speed_mhz)/100))::numeric,1)
                                                                             as CPU_Sys_Mhz,
           ROUND((AVG((s.cpu_avg_sys * ncpu.sum_speed_mhz)/100)*count(distinct s.node_id))::numeric,1)
                                                                             as sum_CPU_Sys_Mhz,

           ROUND(((ROUND(AVG((s.cpu_avg_sys * ncpu.sum_speed_mhz) /
                 100)::numeric,1)) /  (ROUND(AVG(ncpu.sum_speed_mhz)::numeric)+.001) *
                 100)::numeric,1)                                            as CPU_Sys_Percent,
           ROUND((AVG((s.cpu_avg_user * ncpu.sum_speed_mhz)/100))::numeric,1)
                                                                             as CPU_User_Mhz,
           ROUND((AVG((s.cpu_avg_user * ncpu.sum_speed_mhz)/100)*count(distinct s.node_id))::numeric,1)
                                                                             as sum_CPU_User_Mhz,

           ROUND(((ROUND(AVG((s.cpu_avg_user  * ncpu.sum_speed_mhz) /
                 100)::numeric,1)) / (ROUND(AVG(ncpu.sum_speed_mhz)::numeric)+.001) *
                 100)::numeric,1)                                            as CPU_User_Percent,

           ROUND((AVG((s.cpu_avg_user * ncpu.sum_speed_mhz)/100))::numeric,1) +
           ROUND((AVG((s.cpu_avg_sys  * ncpu.sum_speed_mhz)/100))::numeric,1)
                                                                             as CPU_Used_Mhz,
           ROUND((AVG((s.cpu_avg_user * ncpu.sum_speed_mhz)/100)*count(distinct s.node_id))::numeric,1) +
           ROUND((AVG((s.cpu_avg_sys  * ncpu.sum_speed_mhz)/100)*count(distinct s.node_id))::numeric,1)
                                                                             as sum_CPU_Used_Mhz,


           ROUND(((ROUND(AVG((s.cpu_avg_sys   * ncpu.sum_speed_mhz)/100)::numeric,1) +
                 ROUND(AVG((s.cpu_avg_user  * ncpu.sum_speed_mhz) /
                 100)::numeric,1)) / (ROUND(AVG(ncpu.sum_speed_mhz)::numeric)+.001) *
                 100)::numeric,1)                                            as CPU_Used_Percent,
           ' '::text,
          round((AVG(s.mem_avg/1024))::numeric,0)                       as Memory_Used_mb,
          round((AVG(s.mem_avg/1024)*count(distinct s.node_id))::numeric,0)           as sum_Memory_Used_mb,
          round(((AVG(s.mem_avg) / (AVG(s.mem_alloc)+.001)) * 100)::numeric,1) as Memory_Used_Percent,
          round((AVG(s.mem_alloc/1024))::numeric,0)                     as Memory_Allocated_mb,
          round((AVG(s.mem_alloc/1024)*count(distinct s.node_id))::numeric,0)         as sum_Memory_Allocated_mb,
          ' '::text,
          round((AVG(s.swap_avg/1024))::numeric,0)                        as Page_Used_mb,
          round((AVG(s.swap_avg/1024)*count(distinct s.node_id))::numeric,0)            as sum_Page_Used_mb,
          round(((AVG(s.swap_avg) / (AVG(s.swap_alloc)+.001)) * 100)::numeric,1) as Page_Used_Percent,
          round((AVG(s.swap_alloc/1024))::numeric,0)                      as Page_Allocated_mb,
          round((AVG(s.swap_alloc/1024)*count(distinct s.node_id))::numeric,0)          as sum_Page_Allocated_mb,
           ' '::text,
          round((AVG(disk_count)*count(distinct s.node_id))::numeric,1)        as DISK_COUNT,
          round((AVG(disk_count))::numeric,1)                    as sum_DISK_COUNT,
          ' '::text,
          SUM(sum_read_iops)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as read_iops,
          SUM(sum_write_iops) / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as write_iops,
          SUM(sum_read_iops)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) +
          SUM(sum_write_iops) / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as total_iops,
          ' '::text,
          round(SUM(sum_read_iops)::numeric,2)                                 as sum_read_IOPS,
          round(SUM(sum_write_iops)::numeric,2)                                as sum_write_IOPS,
          round(SUM(sum_read_iops)::numeric,2) + round(SUM(sum_write_iops)::numeric,2)
                                                                               as sum_total_IOPS,
          ' '::text,
          SUM(sum_read_io)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as read_io_bps,
          SUM(sum_write_io) / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as write_io_bps,
          SUM(sum_read_io)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) +
            SUM(sum_write_io) / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as total_io_bps,
          ' '::text,
          round(SUM(sum_read_io)::numeric,0)                                   as sum_read_IO,
          round(SUM(sum_write_io)::numeric,0)                                  as sum_write_IO,
          round(SUM(sum_read_io)::numeric,0) +  round(SUM(sum_write_io)::numeric,0)
                                                                               as sum_total_IO,
          ' '::text,
          round(AVG(avg_used_gb)::NUMERIC,2)                        as disk_used_gb,
          round((AVG(avg_used_gb)*count(distinct s.node_id))::NUMERIC,2)          as sum_disk_used_gb,
          round(((AVG(avg_used_gb) / (AVG(avg_size_gb)+.001)) * 100)::numeric,1)  as Disk_Used_Percent,
          round(AVG(avg_size_gb)::NUMERIC,2)                        as disk_size_gb,
          round((AVG(avg_size_gb)*count(distinct s.node_id))::NUMERIC,2)          as sum_disk_size_gb,
          round(AVG(CASE WHEN queue_avg = 0 THEN NULL ELSE queue_avg END)::NUMERIC,2)
               as disk_Queue_avg,
          ' '::text,
          round((AVG(nic_count))::numeric,1)             as nic_COUNT,
          round((AVG(nic_count)*count(distinct s.node_id))::numeric,1) as sum_nic_COUNT,
          ' '::text,
          SUM(sum_send_total_bytes)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1))
                                                                     as net_send_bps,
          SUM(sum_receive_total_bytes)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1))
                                                                     as net_receive_bps,
          SUM(sum_send_total_bytes)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) +
            SUM(sum_receive_total_bytes)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1))
                                                                     as net_total_bps,
          ' '::text,
          round(SUM(sum_send_total_bytes)::numeric,0)                as sum_send_bytes,
          round(SUM(sum_receive_total_bytes)::numeric,0)             as sum_receive_bytes,
          round(SUM(sum_send_total_bytes)::numeric,0) +
               round(SUM(sum_receive_total_bytes)::numeric,0)        as sum_net_total_bytes,
           ' '::text,
          round(avg(s.vdi_ux_x)::numeric,2)          as VDI_UX_x_avg,
          round(avg(s.vdi_ux_y)::numeric,2)          as VDI_UX_y_avg

      FROM tnt_audit.summaryreports s
      join PN on s.node_id = pn.id
 left join cpu_sum   ncpu
        on s.node_id    = ncpu.cpu_node_id
 left join GPU_NODE gpu
        on s.node_id    = gpu.node_id   and s.end_date   = gpu.end_date
 left join node_net   net
        on s.node_id    = net.net_node_id   and s.end_date   = net.end_date
 left join node_disk  d
        on s.node_id    = d.disk_node_id    and s.end_date   = d.end_date
 left join xnode_pr    p
        on s.node_id    = p.pr_node_id      and s.end_date   = p.end_date
 left join tnt_config.node    on node.id   = s.node_id

 left join ALL_USER_NGN  NGN  on ngn.nodeid = s.node_id
 left join ALL_USER_macgrp macgrp on macgrp.id = ngn.nodegroupid
 left join LOGIN_DELAY_NODE login
        on s.node_id = login.delay_node_id  and
           s.end_date = login.end_date

     WHERE s.end_date between var_start_date and var_end_date
       AND s.end_date != s.start_date
       and extract(epoch from s.end_date - s.start_date) < 15000
       and extract(epoch from s.end_date - s.start_date) > 0
       and login_ids is not null
  GROUP BY COALESCE(ngn.nodegroupid,0), COALESCE((macgrp.name),'')
),

u_data_sql as (
 select s.*
     from sumrpt_all_user_group s
    where 1=1
),

sumrpt_node_user_group as (
    SELECT
            l.user_id,
            lower(l.name)       as user_name,
            COALESCE(ngn.nodegroupid,0)     as node_group_id,
            COALESCE((macgrp.name),'')      as node_group_name,


            count(distinct l.user_id)    as user_count,
            ROUND( (SUM(round(extract(epoch from s.end_date - s.start_date)::numeric)) /
                    COALESCE(count(distinct COALESCE(l.user_id,0)),1) )::numeric,0) as cid_seconds,

            CASE WHEN ROUND(AVG(login.login_delay_ms/1000)::numeric,0) = 0
              THEN NULL
              ELSE ROUND(AVG(login.login_delay_ms/1000)::numeric,0)
             END  as Login_Delay_avg,

           count(distinct s.node_id)  as node_count,
           count(distinct ncpu.os_id)                   as os_count,
           count(distinct ncpu.ihostversion)            as cid_version_count,
           count(*)                                     as record_count,
           SUM(COALESCE(login_count,0))                 as login_count,
           SUM(logout_count)                            as logout_count,
           ' '::text,
           round(avg(s.vdi_ux_overall)::numeric,2)      as Overall_UX_Rating_avg,
           round(avg(s.vdi_fit_overall)::numeric,2)     as Overall_FIT_Rating_avg,
           ' '::text,
           ROUND(AVG(p.launch_delay_ms)::numeric,1)     as Application_Load_Time_avg,
           ROUND(avg(p.graph_avg)::numeric,0)           as GDI_Objects,
           ROUND(avg(gpu.core_avg)::numeric,1)          as GPU_percent_used,
           round(avg(s.total_app_pf)::numeric,0)        as Page_Faults_Soft,
           round(avg(s.swap_pf_avg)::numeric,0)         as Page_Faults_Hard,
           ROUND(sum(s.total_app_anr)::numeric,0)       as Non_Responding_Apps,
           ROUND(avg(s.avg_center_nrt/1000)::numeric,3) as Network_Latency_ms_avg,
           round(avg(s.avg_inc_nrt/1000)::numeric,3)    as avg_inc_nrt,
           round(sum(s.inc_conn_count)::numeric,0)      as Failed_Connects,

           ' '::text,

           ROUND((AVG(ncpu.sum_cores))::numeric,1)               as Total_Cores_CPUs,
           ROUND((AVG(ncpu.sum_cores)*count(distinct l.user_id))::numeric,1)   as sum_Total_Cores_CPUs,
           ROUND((AVG(ncpu.sum_speed_mhz))::numeric)             as CPU_Allocated_Mhz,
           ROUND((AVG(ncpu.sum_speed_mhz)*count(distinct l.user_id))::numeric) as sum_CPU_Allocated_Mhz,
           round(AVG(CASE WHEN s.cpu_queue_avg = 0 THEN NULL ELSE s.cpu_queue_avg END)::NUMERIC,2)
               as CPU_Queue_Length_avg,

           round(avg(s.cpu_cswitch_avg)::numeric,2)              as CPU_Context_switching_avg,
           round(avg(s.cpu_iowait_avg)::numeric,2)               as CPU_IO_wait_avg,
           ' '::text,
           ROUND((AVG((s.cpu_avg_sys * ncpu.sum_speed_mhz)/100))::numeric,1)
                                                                             as CPU_Sys_Mhz,
           ROUND((AVG((s.cpu_avg_sys * ncpu.sum_speed_mhz)/100)*count(distinct l.user_id))::numeric,1)
                                                                             as sum_CPU_Sys_Mhz,

           ROUND(((ROUND(AVG((s.cpu_avg_sys * ncpu.sum_speed_mhz) /
                 100)::numeric,1)) /  (ROUND(AVG(ncpu.sum_speed_mhz)::numeric)+.001) *
                 100)::numeric,1)                                            as CPU_Sys_Percent,
           ROUND((AVG((s.cpu_avg_user * ncpu.sum_speed_mhz)/100))::numeric,1)
                                                                             as CPU_User_Mhz,
           ROUND((AVG((s.cpu_avg_user * ncpu.sum_speed_mhz)/100)*count(distinct l.user_id))::numeric,1)
                                                                             as sum_CPU_User_Mhz,

           ROUND(((ROUND(AVG((s.cpu_avg_user  * ncpu.sum_speed_mhz) /
                 100)::numeric,1)) / (ROUND(AVG(ncpu.sum_speed_mhz)::numeric)+.001) *
                 100)::numeric,1)                                            as CPU_User_Percent,

           ROUND((AVG((s.cpu_avg_user * ncpu.sum_speed_mhz)/100))::numeric,1) +
           ROUND((AVG((s.cpu_avg_sys  * ncpu.sum_speed_mhz)/100))::numeric,1)
                                                                             as CPU_Used_Mhz,
           ROUND((AVG((s.cpu_avg_user * ncpu.sum_speed_mhz)/100)*count(distinct l.user_id))::numeric,1) +
           ROUND((AVG((s.cpu_avg_sys  * ncpu.sum_speed_mhz)/100)*count(distinct l.user_id))::numeric,1)
                                                                             as sum_CPU_Used_Mhz,


           ROUND(((ROUND(AVG((s.cpu_avg_sys   * ncpu.sum_speed_mhz)/100)::numeric,1) +
                 ROUND(AVG((s.cpu_avg_user  * ncpu.sum_speed_mhz) /
                 100)::numeric,1)) / (ROUND(AVG(ncpu.sum_speed_mhz)::numeric)+.001) *
                 100)::numeric,1)                                            as CPU_Used_Percent,
           ' '::text,
          round((AVG(s.mem_avg/1024))::numeric,0)                       as Memory_Used_mb,
          round((AVG(s.mem_avg/1024)*count(distinct l.user_id))::numeric,0)           as sum_Memory_Used_mb,
          round(((AVG(s.mem_avg) / (AVG(s.mem_alloc)+.001)) * 100)::numeric,1) as Memory_Used_Percent,
          round((AVG(s.mem_alloc/1024))::numeric,0)                     as Memory_Allocated_mb,
          round((AVG(s.mem_alloc/1024)*count(distinct l.user_id))::numeric,0)         as sum_Memory_Allocated_mb,
          ' '::text,
          round((AVG(s.swap_avg/1024))::numeric,0)                        as Page_Used_mb,
          round((AVG(s.swap_avg/1024)*count(distinct l.user_id))::numeric,0)            as sum_Page_Used_mb,
          round(((AVG(s.swap_avg) / (AVG(s.swap_alloc)+.001)) * 100)::numeric,1) as Page_Used_Percent,
          round((AVG(s.swap_alloc/1024))::numeric,0)                      as Page_Allocated_mb,
          round((AVG(s.swap_alloc/1024)*count(distinct l.user_id))::numeric,0)          as sum_Page_Allocated_mb,
           ' '::text,
          round((AVG(disk_count)*count(distinct l.user_id))::numeric,1)        as DISK_COUNT,
          round((AVG(disk_count))::numeric,1)                    as sum_DISK_COUNT,
          ' '::text,
          SUM(sum_read_iops)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as read_iops,
          SUM(sum_write_iops) / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as write_iops,
          SUM(sum_read_iops)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) +
          SUM(sum_write_iops) / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as total_iops,
          ' '::text,
          round(SUM(sum_read_iops)::numeric,2)                                 as sum_read_IOPS,
          round(SUM(sum_write_iops)::numeric,2)                                as sum_write_IOPS,
          round(SUM(sum_read_iops)::numeric,2) + round(SUM(sum_write_iops)::numeric,2)
                                                                               as sum_total_IOPS,
          ' '::text,
          SUM(sum_read_io)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as read_io_bps,
          SUM(sum_write_io) / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as write_io_bps,
          SUM(sum_read_io)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) +
            SUM(sum_write_io) / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) as total_io_bps,
          ' '::text,
          round(SUM(sum_read_io)::numeric,0)                                   as sum_read_IO,
          round(SUM(sum_write_io)::numeric,0)                                  as sum_write_IO,
          round(SUM(sum_read_io)::numeric,0) +  round(SUM(sum_write_io)::numeric,0)
                                                                               as sum_total_IO,
          ' '::text,
          round(AVG(avg_used_gb)::NUMERIC,2)                        as disk_used_gb,
          round((AVG(avg_used_gb)*count(distinct l.user_id))::NUMERIC,2)          as sum_disk_used_gb,
          round(((AVG(avg_used_gb) / (AVG(avg_size_gb)+.001)) * 100)::numeric,1)  as Disk_Used_Percent,
          round(AVG(avg_size_gb)::NUMERIC,2)                        as disk_size_gb,
          round((AVG(avg_size_gb)*count(distinct l.user_id))::NUMERIC,2)          as sum_disk_size_gb,
          round(AVG(CASE WHEN queue_avg = 0 THEN NULL ELSE queue_avg END)::NUMERIC,2)
               as disk_Queue_avg,
          ' '::text,
          round((AVG(nic_count))::numeric,1)             as nic_COUNT,
          round((AVG(nic_count)*count(distinct l.user_id))::numeric,1) as sum_nic_COUNT,
          ' '::text,
          SUM(sum_send_total_bytes)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1))
                                                                     as net_send_bps,
          SUM(sum_receive_total_bytes)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1))
                                                                     as net_receive_bps,
          SUM(sum_send_total_bytes)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1)) +
            SUM(sum_receive_total_bytes)  / SUM( ((extract(epoch from s.end_date - s.start_date))+1))
                                                                     as net_total_bps,
          ' '::text,
          round(SUM(sum_send_total_bytes)::numeric,0)                as sum_send_bytes,
          round(SUM(sum_receive_total_bytes)::numeric,0)             as sum_receive_bytes,
          round(SUM(sum_send_total_bytes)::numeric,0) +
               round(SUM(sum_receive_total_bytes)::numeric,0)        as sum_net_total_bytes,
           ' '::text,
          round(avg(s.vdi_ux_x)::numeric,2)          as VDI_UX_x_avg,
          round(avg(s.vdi_ux_y)::numeric,2)          as VDI_UX_y_avg

      FROM tnt_audit.summaryreports s
      join PN on node_id = pn.id
 left join cpu_sum   ncpu
        on s.node_id    = ncpu.cpu_node_id
 left join GPU_NODE gpu
        on s.node_id    = gpu.node_id   and s.end_date   = gpu.end_date
 left join node_net   net
        on s.node_id    = net.net_node_id   and s.end_date   = net.end_date
 left join node_disk  d
        on s.node_id    = d.disk_node_id    and s.end_date   = d.end_date
 left join xnode_pr    p
        on s.node_id    = p.pr_node_id      and s.end_date   = p.end_date
 left join tnt_config.node    on node.id   = s.node_id

 left join NGN    on ngn.nodeid = s.node_id
 left join macgrp on macgrp.id = ngn.nodegroupid

 JOIN tnt_audit.summaryreport_login_stats l
        on s.node_id    = l.node_id and
           s.start_date = l.start_date and
           s.end_date   = l.end_date and logout_time is null

 join tnt_config.identitygroup_identity igi
        on igi.uid = user_id and igi.delete_time is null
 join tnt_config.policyidentity pi
        on pi.id = igi.groupid and pi.delete_time is null
 join tnt_config.identitygroup g
        on g.id = igi.groupid and vcops_monitor is TRUE

 left join LOGIN_DELAY_NODE_USER login
        on s.node_id = login.delay_node_id  and
           l.user_id = login.delay_user_id and
           s.end_date = login.end_date


     WHERE s.end_date between var_start_date and var_end_date
       AND s.end_date != s.start_date
       and extract(epoch from s.end_date - s.start_date) < 15000
       and extract(epoch from s.end_date - s.start_date) > 0

       and pi.id is not null
       and pi.name is not null
       and macgrp.name is not null
       and ngn.nodegroupid is not null
       and ngn.nodegroupid > 0
       and l.name is not null

  GROUP BY l.user_id, l.name,
           COALESCE(ngn.nodegroupid,0), COALESCE((macgrp.name),'')


),



g_data_sql as (
 select s.*
     from sumrpt_node_user_group s
    where 1=1
),


USER_GROUP_avg as (
 select  'Avg'::text               as top_type,
         user_group_name           as user_group_name,
         node_count                as Node_Count,
         user_count                as User_Count,
' '::text,
         ROUND((read_iops)::numeric,1)            as Disk_Read_IOPS,
         ROUND((write_iops)::numeric,1)           as Disk_Write_IOPS,
         ROUND((read_iops+write_iops)::numeric,1) as Disk_IOPS,
' '::text,
         Overall_UX_Rating_avg     as Overall_UX_Rating_avg,
         Overall_FIT_Rating_avg    as Overall_FIT_Rating_avg,
         COALESCE(Login_Delay_avg,0)           as Login_Delay_avg,
         COALESCE(Non_Responding_Apps,0)       as Non_Responding_Apps,
         COALESCE(Page_Faults_Soft,0)          as Page_Faults_Soft,
         COALESCE(Page_Faults_Hard,0)          as Page_Faults_Hard,
         COALESCE(Application_Load_Time_avg,0) as Application_Load_Time_avg,
         COALESCE(gdi_objects,0)               as GDI_Objects,
         COALESCE(gpu_percent_used,0)          as GPU_percent_used,
         ' ' ::text,
         COALESCE(CPU_Queue_Length_avg,0)      as CPU_Queue_Length,
         ' ' ::text,
         ROUND((cpu_sys_mhz)::numeric,1)                             as CPU_Sys_mhz,
         ROUND(((cpu_sys_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1) as CPU_Sys_Percent,
         ' ' ::text,
         ROUND((cpu_user_mhz)::numeric,1)                            as CPU_user_mhz,
         ROUND(((cpu_user_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1)as CPU_User_Percent,
         ' ' ::text,
         ROUND((cpu_used_mhz )::numeric,1)                           as CPU_used_mhz,
         ROUND(((cpu_used_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1)as CPU_Used_Percent,
         ' ' ::text,

         ROUND((Memory_Allocated_mb/1024)::numeric,2) as Memory_Allocated_gb,
         ROUND((Memory_used_mb/1024)::numeric,2)      as Memory_Used_gb,
         ROUND((((Memory_used_mb) * 100) /
            (Memory_Allocated_mb+.001))::numeric,1)      as Memory_Used_Percent,

         ROUND((page_used_mb/1024)::numeric,2)      as page_Used_gb,
         ROUND((((page_used_mb) * 100) /
            (page_allocated_mb+.001))::numeric,1)        as page_Used_Percent,


          ' '::text,
         ROUND((read_io_bps/1024)::numeric,2)     as Disk_Read_IO_kbs,
         ROUND((write_io_bps/1024)::numeric,2)    as Disk_Write_IO_kbs,
         ROUND(((read_io_bps/1024)+(write_io_bps/1024))::numeric,2)
                                                  as Disk_IO_kbs,
          ' '::text,
         ROUND((disk_used_gb)::numeric,2)      as Disk_Used_gb,
         ROUND((disk_size_gb)::numeric,2)      as Disk_Size_gb,
         ROUND((COALESCE(disk_Queue_avg,0))::numeric,2)    as Disk_Queue,
          ' '::text,
         ROUND((net_send_bps/1024)::numeric,2)        as Net_Send_kbs,
         ROUND((net_receive_bps/1024)::numeric,2)     as Net_Receive_kbs,
         ROUND(((net_send_bps/1024)+(net_receive_bps/1024))::numeric,2) as Net_kbs,
         ROUND(Network_Latency_ms_avg::numeric,1)      as Network_Latency_ms_avg,
         ROUND(failed_connects::numeric,0)             as Failed_Connects,
          ' '::text,
         user_group_id             as user_group_id
  from data_sql
),

USER_GROUP_sum as (
 select  'Sum'::text               as top_type,
         user_group_name           as user_group_name,
         node_count                as Node_Count,
         user_count                as User_Count,
' '::text,
         ROUND((read_iops*user_count)::numeric,0)            as Disk_Read_IOPS,
         ROUND((write_iops*user_count)::numeric,0)           as Disk_Write_IOPS,
         ROUND(((read_iops+write_iops)*user_count)::numeric,0) as Disk_IOPS,

' '::text,
         Overall_UX_Rating_avg     as Overall_UX_Rating_avg,
         Overall_FIT_Rating_avg    as Overall_FIT_Rating_avg,
         COALESCE(Login_Delay_avg,0)           as Login_Delay_avg,
         COALESCE(Non_Responding_Apps,0)       as Non_Responding_Apps,
         COALESCE(Page_Faults_Soft,0)          as Page_Faults_Soft,
         COALESCE(Page_Faults_Hard,0)          as Page_Faults_Hard,
         COALESCE(Application_Load_Time_avg,0) as Application_Load_Time_avg,
         COALESCE(gdi_objects,0)               as GDI_Objects,
         COALESCE(gpu_percent_used,0)          as GPU_percent_used,
         ' ' ::text,
         ROUND((COALESCE(CPU_Queue_Length_avg,0) *user_count)::numeric,2)  as CPU_Queue_Length,
         ' ' ::text,
         ROUND((cpu_sys_mhz*user_count/1000)::numeric,3)                    as CPU_Sys_ghz,
         ROUND(((cpu_sys_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1)   as CPU_Sys_Percent,
         ' ' ::text,
         ROUND((cpu_user_mhz*user_count/1000)::numeric,3)                   as CPU_user_ghz,
         ROUND(((cpu_user_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1)  as CPU_User_Percent,
         ' ' ::text,
         ROUND((cpu_used_mhz*user_count/1000)::numeric,3)                   as CPU_used_ghz,
         ROUND(((cpu_used_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1)  as CPU_Used_Percent,
         ' ' ::text,

         ROUND(((Memory_Allocated_mb/1024)*user_count)::numeric,2) as Memory_Allocated_gb,
         ROUND(((Memory_used_mb/1024)*user_count)::numeric,2)      as Memory_Used_gb,
         ROUND((((Memory_used_mb) * 100) /
            (Memory_Allocated_mb+.001))::numeric,1)           as Memory_Used_Percent,

         ROUND(((page_used_mb/1024)*user_count)::numeric,2)      as page_Used_gb,
         ROUND((((page_used_mb) * 100) /
            (page_allocated_mb+.001))::numeric,1)           as page_Used_Percent,


          ' '::text,
         ROUND(((read_io_bps/1048576)*user_count)::numeric,2)     as Disk_Read_IO_mbs,
         ROUND(((write_io_bps/1048576)*user_count)::numeric,2)    as Disk_Write_IO_mbs,
         ROUND((((read_io_bps/1048576)*user_count)+((write_io_bps/1048576)*user_count))::numeric,2)
                                                     as Disk_IO_mbs,
          ' '::text,
         ROUND((disk_used_gb*user_count/1024)::numeric,2)      as Disk_Used_tb,
         ROUND((disk_size_gb*user_count/1024)::numeric,2)      as Disk_Size_tb,
         ROUND((COALESCE(disk_Queue_avg,0) *user_count)::numeric,2)  as Disk_Queue,
          ' '::text,
         ROUND(((net_send_bps/1048576)*user_count)::numeric,2)        as Net_Send_mbs,
         ROUND(((net_receive_bps/1048576)*user_count)::numeric,2)     as Net_Receive_mbs,
         ROUND((((net_send_bps/1048576)*user_count)+((net_receive_bps/1048576)*user_count))::numeric,2) as Net_mbs,
         ROUND(Network_Latency_ms_avg::numeric,1)       as Network_Latency_ms_avg,
         ROUND((failed_connects*user_count)::numeric,0) as Failed_Connects,
          ' '::text,
         user_group_id             as user_group_id
  from data_sql
),


NODE_GROUP_avg as (
 select  'Avg'::text               as top_type,
         node_group_name           as node_group_name,
         node_count                as Node_Count,
         UC.user_count                as User_Count,
' '::text,
         ROUND((read_iops)::numeric,1)            as Disk_Read_IOPS,
         ROUND((write_iops)::numeric,1)           as Disk_Write_IOPS,
         ROUND((read_iops+write_iops)::numeric,1) as Disk_IOPS,
' '::text,
         Overall_UX_Rating_avg     as Overall_UX_Rating_avg,
         Overall_FIT_Rating_avg    as Overall_FIT_Rating_avg,
         COALESCE(Login_Delay_avg,0)           as Login_Delay_avg,
         COALESCE(Non_Responding_Apps,0)       as Non_Responding_Apps,
         COALESCE(Page_Faults_Soft,0)          as Page_Faults_Soft,
         COALESCE(Page_Faults_Hard,0)          as Page_Faults_Hard,
         COALESCE(Application_Load_Time_avg,0) as Application_Load_Time_avg,
         COALESCE(gdi_objects,0)               as GDI_Objects,
         COALESCE(gpu_percent_used,0)          as GPU_percent_used,
         ' ' ::text,
         COALESCE(CPU_Queue_Length_avg,0)      as CPU_Queue_Length,
         ' ' ::text,
         ROUND((cpu_sys_mhz)::numeric,1)                             as CPU_Sys_mhz,
         ROUND(((cpu_sys_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1) as CPU_Sys_Percent,
         ' ' ::text,
         ROUND((cpu_user_mhz)::numeric,1)                            as CPU_user_mhz,
         ROUND(((cpu_user_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1)as CPU_User_Percent,
         ' ' ::text,
         ROUND((cpu_used_mhz )::numeric,1)                           as CPU_used_mhz,
         ROUND(((cpu_used_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1)as CPU_Used_Percent,
         ' ' ::text,

         ROUND((Memory_Allocated_mb/1024)::numeric,2) as Memory_Allocated_gb,
         ROUND((Memory_used_mb/1024)::numeric,2)      as Memory_Used_gb,
         ROUND((((Memory_used_mb) * 100) /
            (Memory_Allocated_mb+.001))::numeric,1)      as Memory_Used_Percent,

         ROUND((page_used_mb/1024)::numeric,2)      as page_Used_gb,
         ROUND((((page_used_mb) * 100) /
            (page_allocated_mb+.001))::numeric,1)        as page_Used_Percent,


          ' '::text,
         ROUND((read_io_bps/1024)::numeric,2)     as Disk_Read_IO_kbs,
         ROUND((write_io_bps/1024)::numeric,2)    as Disk_Write_IO_kbs,
         ROUND(((read_io_bps/1024)+(write_io_bps/1024))::numeric,2)
                                                  as Disk_IO_kbs,
          ' '::text,
         ROUND((disk_used_gb)::numeric,2)      as Disk_Used_gb,
         ROUND((disk_size_gb)::numeric,2)      as Disk_Size_gb,
         ROUND((COALESCE(disk_Queue_avg,0))::numeric,2)    as Disk_Queue,
          ' '::text,
         ROUND((net_send_bps/1024)::numeric,2)        as Net_Send_kbs,
         ROUND((net_receive_bps/1024)::numeric,2)     as Net_Receive_kbs,
         ROUND(((net_send_bps/1024)+(net_receive_bps/1024))::numeric,2) as Net_kbs,
         ROUND(Network_Latency_ms_avg::numeric,1)      as Network_Latency_ms_avg,
         ROUND(failed_connects::numeric,0)             as Failed_Connects,
          ' '::text,
         node_group_id             as node_group_id
  from m_data_sql
left join USER_COUNT_NODE_GROUP UC on node_group_id = nodegroup_id
),


ALL_USER_GROUP_avg as (
 select  'Avg'::text               as top_type,
         node_group_name           as node_group_name,
         node_count                as Node_Count,
         UC.user_count             as User_Count,
' '::text,
         ROUND((read_iops)::numeric,1)            as Disk_Read_IOPS,
         ROUND((write_iops)::numeric,1)           as Disk_Write_IOPS,
         ROUND((read_iops+write_iops)::numeric,1) as Disk_IOPS,
' '::text,
         Overall_UX_Rating_avg     as Overall_UX_Rating_avg,
         Overall_FIT_Rating_avg    as Overall_FIT_Rating_avg,
         COALESCE(Login_Delay_avg,0)           as Login_Delay_avg,
         COALESCE(Non_Responding_Apps,0)       as Non_Responding_Apps,
         COALESCE(Page_Faults_Soft,0)          as Page_Faults_Soft,
         COALESCE(Page_Faults_Hard,0)          as Page_Faults_Hard,
         COALESCE(Application_Load_Time_avg,0) as Application_Load_Time_avg,
         COALESCE(gdi_objects,0)               as GDI_Objects,
         COALESCE(gpu_percent_used,0)          as GPU_percent_used,
         ' ' ::text,
         COALESCE(CPU_Queue_Length_avg,0)      as CPU_Queue_Length,
         ' ' ::text,
         ROUND((cpu_sys_mhz)::numeric,1)                             as CPU_Sys_mhz,
         ROUND(((cpu_sys_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1) as CPU_Sys_Percent,
         ' ' ::text,
         ROUND((cpu_user_mhz)::numeric,1)                            as CPU_user_mhz,
         ROUND(((cpu_user_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1)as CPU_User_Percent,
         ' ' ::text,
         ROUND((cpu_used_mhz )::numeric,1)                           as CPU_used_mhz,
         ROUND(((cpu_used_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1)as CPU_Used_Percent,
         ' ' ::text,

         ROUND((Memory_Allocated_mb/1024)::numeric,2) as Memory_Allocated_gb,
         ROUND((Memory_used_mb/1024)::numeric,2)      as Memory_Used_gb,
         ROUND((((Memory_used_mb) * 100) /
            (Memory_Allocated_mb+.001))::numeric,1)      as Memory_Used_Percent,

         ROUND((page_used_mb/1024)::numeric,2)      as page_Used_gb,
         ROUND((((page_used_mb) * 100) /
            (page_allocated_mb+.001))::numeric,1)        as page_Used_Percent,


          ' '::text,
         ROUND((read_io_bps/1024)::numeric,2)     as Disk_Read_IO_kbs,
         ROUND((write_io_bps/1024)::numeric,2)    as Disk_Write_IO_kbs,
         ROUND(((read_io_bps/1024)+(write_io_bps/1024))::numeric,2)
                                                  as Disk_IO_kbs,
          ' '::text,
         ROUND((disk_used_gb)::numeric,2)      as Disk_Used_gb,
         ROUND((disk_size_gb)::numeric,2)      as Disk_Size_gb,
         ROUND((COALESCE(disk_Queue_avg,0))::numeric,2)    as Disk_Queue,
          ' '::text,
         ROUND((net_send_bps/1024)::numeric,2)        as Net_Send_kbs,
         ROUND((net_receive_bps/1024)::numeric,2)     as Net_Receive_kbs,
         ROUND(((net_send_bps/1024)+(net_receive_bps/1024))::numeric,2) as Net_kbs,
         ROUND(Network_Latency_ms_avg::numeric,1)      as Network_Latency_ms_avg,
         ROUND(failed_connects::numeric,0)             as Failed_Connects,
          ' '::text,
         node_group_id                                  as node_group_id
  from u_data_sql
 left join USER_COUNT_NODE_GROUP UC on node_group_id = nodegroup_id
),

node_user_group_avg as (
 select  'Avg'::text               as top_type,
         user_name || ':' ||node_group_name as node_user_name,
         node_count                as Node_Count,
         user_count                as User_Count,
' '::text,
         ROUND((read_iops)::numeric,1)            as Disk_Read_IOPS,
         ROUND((write_iops)::numeric,1)           as Disk_Write_IOPS,
         ROUND((read_iops+write_iops)::numeric,1) as Disk_IOPS,
' '::text,
         Overall_UX_Rating_avg     as Overall_UX_Rating_avg,
         Overall_FIT_Rating_avg    as Overall_FIT_Rating_avg,
         COALESCE(Login_Delay_avg,0)           as Login_Delay_avg,
         COALESCE(Non_Responding_Apps,0)       as Non_Responding_Apps,
         COALESCE(Page_Faults_Soft,0)          as Page_Faults_Soft,
         COALESCE(Page_Faults_Hard,0)          as Page_Faults_Hard,
         COALESCE(Application_Load_Time_avg,0) as Application_Load_Time_avg,
         COALESCE(gdi_objects,0)               as GDI_Objects,
         COALESCE(gpu_percent_used,0)          as GPU_percent_used,
         ' ' ::text,
         COALESCE(CPU_Queue_Length_avg,0)      as CPU_Queue_Length,
         ' ' ::text,
         ROUND((cpu_sys_mhz)::numeric,1)                             as CPU_Sys_mhz,
         ROUND(((cpu_sys_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1) as CPU_Sys_Percent,
         ' ' ::text,
         ROUND((cpu_user_mhz)::numeric,1)                            as CPU_user_mhz,
         ROUND(((cpu_user_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1)as CPU_User_Percent,
         ' ' ::text,
         ROUND((cpu_used_mhz )::numeric,1)                           as CPU_used_mhz,
         ROUND(((cpu_used_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1)as CPU_Used_Percent,
         ' ' ::text,

         ROUND((Memory_Allocated_mb/1024)::numeric,2) as Memory_Allocated_gb,
         ROUND((Memory_used_mb/1024)::numeric,2)      as Memory_Used_gb,
         ROUND((((Memory_used_mb) * 100) /
            (Memory_Allocated_mb+.001))::numeric,1)      as Memory_Used_Percent,

         ROUND((page_used_mb/1024)::numeric,2)      as page_Used_gb,
         ROUND((((page_used_mb) * 100) /
            (page_allocated_mb+.001))::numeric,1)        as page_Used_Percent,


          ' '::text,
         ROUND((read_io_bps/1024)::numeric,2)     as Disk_Read_IO_kbs,
         ROUND((write_io_bps/1024)::numeric,2)    as Disk_Write_IO_kbs,
         ROUND(((read_io_bps/1024)+(write_io_bps/1024))::numeric,2)
                                                  as Disk_IO_kbs,
          ' '::text,
         ROUND((disk_used_gb)::numeric,2)      as Disk_Used_gb,
         ROUND((disk_size_gb)::numeric,2)      as Disk_Size_gb,
         ROUND((COALESCE(disk_Queue_avg,0))::numeric,2)    as Disk_Queue,
          ' '::text,
         ROUND((net_send_bps/1024)::numeric,2)        as Net_Send_kbs,
         ROUND((net_receive_bps/1024)::numeric,2)     as Net_Receive_kbs,
         ROUND(((net_send_bps/1024)+(net_receive_bps/1024))::numeric,2) as Net_kbs,
         ROUND(Network_Latency_ms_avg::numeric,1)      as Network_Latency_ms_avg,
         ROUND(failed_connects::numeric,0)             as Failed_Connects,
          ' '::text,
         user_id
  from g_data_sql
),

NODE_GROUP_sum as (
 select  'Sum'::text               as top_type,
         node_group_name           as node_group_name,
         node_count                as Node_Count,
         UC.user_count             as User_Count,
' '::text,
         ROUND((read_iops*node_count)::numeric,0)            as Disk_Read_IOPS,
         ROUND((write_iops*node_count)::numeric,0)           as Disk_Write_IOPS,
         ROUND(((read_iops+write_iops)*node_count)::numeric,0) as Disk_IOPS,

' '::text,
         Overall_UX_Rating_avg     as Overall_UX_Rating_avg,
         Overall_FIT_Rating_avg    as Overall_FIT_Rating_avg,
         COALESCE(Login_Delay_avg,0)           as Login_Delay_avg,
         COALESCE(Non_Responding_Apps,0)       as Non_Responding_Apps,
         COALESCE(Page_Faults_Soft,0)          as Page_Faults_Soft,
         COALESCE(Page_Faults_Hard,0)          as Page_Faults_Hard,
         COALESCE(Application_Load_Time_avg,0) as Application_Load_Time_avg,
         COALESCE(gdi_objects,0)               as GDI_Objects,
         COALESCE(gpu_percent_used,0)          as GPU_percent_used,
         ' ' ::text,
         ROUND((COALESCE(CPU_Queue_Length_avg,0) *node_count)::numeric,2)  as CPU_Queue_Length,
         ' ' ::text,
         ROUND((cpu_sys_mhz*node_count/1000)::numeric,3)                    as CPU_Sys_ghz,
         ROUND(((cpu_sys_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1)   as CPU_Sys_Percent,
         ' ' ::text,
         ROUND((cpu_user_mhz*node_count/1000)::numeric,3)                   as CPU_user_ghz,
         ROUND(((cpu_user_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1)  as CPU_User_Percent,
         ' ' ::text,
         ROUND((cpu_used_mhz*node_count/1000)::numeric,3)                   as CPU_used_ghz,
         ROUND(((cpu_used_mhz * 100) / (cpu_allocated_Mhz+001))::numeric,1)  as CPU_Used_Percent,
         ' ' ::text,

         ROUND(((Memory_Allocated_mb/1024)*node_count)::numeric,2) as Memory_Allocated_gb,
         ROUND(((Memory_used_mb/1024)*node_count)::numeric,2)      as Memory_Used_gb,
         ROUND((((Memory_used_mb) * 100) /
            (Memory_Allocated_mb+.001))::numeric,1)           as Memory_Used_Percent,

         ROUND(((page_used_mb/1024)*node_count)::numeric,2)      as page_Used_gb,
         ROUND((((page_used_mb) * 100) /
            (page_allocated_mb+.001))::numeric,1)           as page_Used_Percent,


          ' '::text,
         ROUND(((read_io_bps/1048576)*node_count)::numeric,2)     as Disk_Read_IO_mbs,
         ROUND(((write_io_bps/1048576)*node_count)::numeric,2)    as Disk_Write_IO_mbs,
         ROUND((((read_io_bps/1048576)*node_count)+((write_io_bps/1048576)*node_count))::numeric,2)
                                                     as Disk_IO_mbs,
          ' '::text,
         ROUND((disk_used_gb*node_count/1024)::numeric,2)      as Disk_Used_tb,
         ROUND((disk_size_gb*node_count/1024)::numeric,2)      as Disk_Size_tb,
         ROUND((COALESCE(disk_Queue_avg,0) *node_count)::numeric,2)  as Disk_Queue,
          ' '::text,
         ROUND(((net_send_bps/1048576)*node_count)::numeric,2)        as Net_Send_mbs,
         ROUND(((net_receive_bps/1048576)*node_count)::numeric,2)     as Net_Receive_mbs,
         ROUND((((net_send_bps/1048576)*node_count)+((net_receive_bps/1048576)*node_count))::numeric,2) as Net_mbs,
         ROUND(Network_Latency_ms_avg::numeric,1)       as Network_Latency_ms_avg,
         ROUND((failed_connects*node_count)::numeric,0) as Failed_Connects,
          ' '::text,
         node_group_id             as node_group_id
  from m_data_sql
 left join USER_COUNT_NODE_GROUP UC on node_group_id = nodegroup_id
),

ALL_USER_GROUP_sum as (
 select  'Sum'::text               as top_type,
         node_group_name           as node_group_name,
         node_count                as Node_Count,
         uc.user_count             as User_Count,
' '::text,
         ROUND((read_iops*node_count)::numeric,0)            as Disk_Read_IOPS,
         ROUND((write_iops*node_count)::numeric,0)           as Disk_Write_IOPS,
         ROUND(((read_iops+write_iops)*node_count)::numeric,0) as Disk_IOPS,

' '::text,
         Overall_UX_Rating_avg     as Overall_UX_Rating_avg,
         Overall_FIT_Rating_avg    as Overall_FIT_Rating_avg,
         COALESCE(Login_Delay_avg,0)           as Login_Delay_avg,
         COALESCE(Non_Responding_Apps,0)       as Non_Responding_Apps,
         COALESCE(Page_Faults_Soft,0)          as Page_Faults_Soft,
         COALESCE(Page_Faults_Hard,0)          as Page_Faults_Hard,
         COALESCE(Application_Load_Time_avg,0) as Application_Load_Time_avg,
         COALESCE(gdi_objects,0)               as GDI_Objects,
         COALESCE(gpu_percent_used,0)          as GPU_percent_used,
         ' ' ::text,
         ROUND((COALESCE(CPU_Queue_Length_avg,0) *node_count)::numeric,2)  as CPU_Queue_Length,
         ' ' ::text,
         ROUND((cpu_sys_mhz*node_count/1000)::numeric,3)                    as CPU_Sys_ghz,
         ROUND(((cpu_sys_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1)   as CPU_Sys_Percent,
         ' ' ::text,
         ROUND((cpu_user_mhz*node_count/1000)::numeric,3)                   as CPU_user_ghz,
         ROUND(((cpu_user_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1)  as CPU_User_Percent,
         ' ' ::text,
         ROUND((cpu_used_mhz*node_count/1000)::numeric,3)                   as CPU_used_ghz,
         ROUND(((cpu_used_mhz * 100) / (cpu_allocated_Mhz+.001))::numeric,1)  as CPU_Used_Percent,
         ' ' ::text,

         ROUND(((Memory_Allocated_mb/1024)*node_count)::numeric,2) as Memory_Allocated_gb,
         ROUND(((Memory_used_mb/1024)*node_count)::numeric,2)      as Memory_Used_gb,
         ROUND((((Memory_used_mb) * 100) /
            (Memory_Allocated_mb+.001))::numeric,1)           as Memory_Used_Percent,

         ROUND(((page_used_mb/1024)*node_count)::numeric,2)      as page_Used_gb,
         ROUND((((page_used_mb) * 100) /
            (page_allocated_mb+.001))::numeric,1)           as page_Used_Percent,


          ' '::text,
         ROUND(((read_io_bps/1048576)*node_count)::numeric,2)     as Disk_Read_IO_mbs,
         ROUND(((write_io_bps/1048576)*node_count)::numeric,2)    as Disk_Write_IO_mbs,
         ROUND((((read_io_bps/1048576)*node_count)+((write_io_bps/1048576)*node_count))::numeric,2)
                                                     as Disk_IO_mbs,
          ' '::text,
         ROUND((disk_used_gb*node_count/1024)::numeric,2)      as Disk_Used_tb,
         ROUND((disk_size_gb*node_count/1024)::numeric,2)      as Disk_Size_tb,
         ROUND((COALESCE(disk_Queue_avg,0) *node_count)::numeric,2)  as Disk_Queue,
          ' '::text,
         ROUND(((net_send_bps/1048576)*node_count)::numeric,2)        as Net_Send_mbs,
         ROUND(((net_receive_bps/1048576)*node_count)::numeric,2)     as Net_Receive_mbs,
         ROUND((((net_send_bps/1048576)*node_count)+((net_receive_bps/1048576)*node_count))::numeric,2) as Net_mbs,
         ROUND(Network_Latency_ms_avg::numeric,1)       as Network_Latency_ms_avg,
         ROUND((failed_connects*node_count)::numeric,0) as Failed_Connects,
          ' '::text,
         node_group_id            as node_group_id
  from u_data_sql
 left join USER_COUNT_NODE_GROUP UC on node_group_id = nodegroup_id
),

vcops_sum_user_group as (
select
         user_group_name as RESOURCENAME,
         RES_KIND::text  as RESOURCEKIND,
         ADAPTER::text   as ADAPTERKIND,
         date_trunc('second',(var_end_date)::timestamp)                AS TIMESTAMP,
          top_type || '|node count'::text as METRICNAME1,
                 COALESCE(node_count,0)::double precision as VALUE1,
          top_type || '|user count'::text as METRICNAME2,
                 COALESCE(user_count,0)::double precision as VALUE2,
          top_type || '|overall ux rating avg'::text as METRICNAME3,
                 COALESCE(overall_ux_rating_avg,0)::double precision as VALUE3,
          top_type || '|overall fit rating avg'::text as METRICNAME4,
                 COALESCE(overall_fit_rating_avg,0)::double precision as VALUE4,
          top_type || '|login delay avg'::text as METRICNAME5,
                 COALESCE(login_delay_avg,0)::double precision as VALUE5,
          top_type || '|non responding apps'::text as METRICNAME6,
                 COALESCE(non_responding_apps,0)::double precision as VALUE6,
          top_type || '|page faults soft'::text as METRICNAME7,
                 COALESCE(page_faults_soft,0)::double precision as VALUE7,
          top_type || '|page faults hard'::text as METRICNAME8,
                 COALESCE(page_faults_hard,0)::double precision as VALUE8,
          top_type || '|application load time avg'::text as METRICNAME9,
                 COALESCE(application_load_time_avg,0)::double precision as VALUE9,
          top_type || '|gdi objects'::text as METRICNAME10,
                 COALESCE(gdi_objects,0)::double precision as VALUE10,
          top_type || '|gpu percent used'::text as METRICNAME11,
                 COALESCE(gpu_percent_used,0)::double precision as VALUE11,
          top_type || '|cpu queue length'::text as METRICNAME12,
                 COALESCE(cpu_queue_length,0)::double precision as VALUE12,
          top_type || '|cpu sys ghz'::text as METRICNAME13,
                 COALESCE(cpu_sys_ghz,0)::double precision as VALUE13,
          top_type || '|cpu sys percent'::text as METRICNAME14,
                 COALESCE(cpu_sys_percent,0)::double precision as VALUE14,
          top_type || '|cpu user ghz'::text as METRICNAME15,
                 COALESCE(cpu_user_ghz,0)::double precision as VALUE15,
          top_type || '|cpu user percent'::text as METRICNAME16,
                 COALESCE(cpu_user_percent,0)::double precision as VALUE16,
          top_type || '|cpu used ghz'::text as METRICNAME17,
                 COALESCE(cpu_used_ghz,0)::double precision as VALUE17,
          top_type || '|cpu used percent'::text as METRICNAME18,
                 COALESCE(cpu_used_percent,0)::double precision as VALUE18,
          top_type || '|memory allocated gb'::text as METRICNAME19,
                 COALESCE(memory_allocated_gb,0)::double precision as VALUE19,
          top_type || '|memory used gb'::text as METRICNAME20,
                 COALESCE(memory_used_gb,0)::double precision as VALUE20,
          top_type || '|memory used percent'::text as METRICNAME21,
                 COALESCE(memory_used_percent,0)::double precision as VALUE21,
          top_type || '|page used gb'::text as METRICNAME22,
                 COALESCE(page_used_gb,0)::double precision as VALUE22,
          top_type || '|page used percent'::text as METRICNAME23,
                 COALESCE(page_used_percent,0)::double precision as VALUE23,
          top_type || '|disk read iops'::text as METRICNAME24,
                 COALESCE(disk_read_iops,0)::double precision as VALUE24,
          top_type || '|disk write iops'::text as METRICNAME25,
                 COALESCE(disk_write_iops,0)::double precision as VALUE25,
          top_type || '|disk iops'::text as METRICNAME26,
                 COALESCE(disk_iops,0)::double precision as VALUE26,
          top_type || '|disk read io mbs'::text as METRICNAME27,
                 COALESCE(disk_read_io_mbs,0)::double precision as VALUE27,
          top_type || '|disk write io mbs'::text as METRICNAME28,
                 COALESCE(disk_write_io_mbs,0)::double precision as VALUE28,
          top_type || '|disk io mbs'::text as METRICNAME29,
                 COALESCE(disk_io_mbs,0)::double precision as VALUE29,
          top_type || '|disk used tb'::text as METRICNAME30,
                 COALESCE(disk_used_tb,0)::double precision as VALUE30,
          top_type || '|disk size tb'::text as METRICNAME31,
                 COALESCE(disk_size_tb,0)::double precision as VALUE31,
          top_type || '|disk queue'::text as METRICNAME32,
                 COALESCE(disk_queue,0)::double precision as VALUE32,
          top_type || '|net send mbs'::text as METRICNAME33,
                 COALESCE(net_send_mbs,0)::double precision as VALUE33,
          top_type || '|net receive mbs'::text as METRICNAME34,
                 COALESCE(net_receive_mbs,0)::double precision as VALUE34,
          top_type || '|net mbs'::text as METRICNAME35,
                 COALESCE(net_mbs,0)::double precision as VALUE35,
          top_type || '|network latency ms avg'::text as METRICNAME36,
                 COALESCE(network_latency_ms_avg,0)::double precision as VALUE36,
          top_type || '|failed connects'::text as METRICNAME37,
                 COALESCE(failed_connects,0)::double precision as VALUE37,
          ''::text as METRICNAME38, 0::double precision as VALUE38,
          ''::text as METRICNAME39, 0::double precision as VALUE39,
          ''::text as METRICNAME40, 0::double precision as VALUE40

      from user_group_sum s
     where user_group_id > 0
),


  vcops_avg_user_group as (
select
         user_group_name as RESOURCENAME,
         RES_KIND::text  as RESOURCEKIND,
         ADAPTER::text   as ADAPTERKIND,
         date_trunc('second',(var_end_date)::timestamp)                AS TIMESTAMP,
          top_type || '|node count'::text as METRICNAME1,
                 COALESCE(node_count,0)::double precision as VALUE1,
          top_type || '|user count'::text as METRICNAME2,
                 COALESCE(user_count,0)::double precision as VALUE2,
          top_type || '|overall ux rating avg'::text as METRICNAME3,
                 COALESCE(overall_ux_rating_avg,0)::double precision as VALUE3,
          top_type || '|overall fit rating avg'::text as METRICNAME4,
                 COALESCE(overall_fit_rating_avg,0)::double precision as VALUE4,
          top_type || '|login delay avg'::text as METRICNAME5,
                 COALESCE(login_delay_avg,0)::double precision as VALUE5,
          top_type || '|non responding apps'::text as METRICNAME6,
                 COALESCE(non_responding_apps,0)::double precision as VALUE6,
          top_type || '|page faults soft'::text as METRICNAME7,
                 COALESCE(page_faults_soft,0)::double precision as VALUE7,
          top_type || '|page faults hard'::text as METRICNAME8,
                 COALESCE(page_faults_hard,0)::double precision as VALUE8,
          top_type || '|application load time avg'::text as METRICNAME9,
                 COALESCE(application_load_time_avg,0)::double precision as VALUE9,
          top_type || '|gdi objects'::text as METRICNAME10,
                 COALESCE(gdi_objects,0)::double precision as VALUE10,
          top_type || '|gpu percent used'::text as METRICNAME11,
                 COALESCE(gpu_percent_used,0)::double precision as VALUE11,
          top_type || '|cpu queue length'::text as METRICNAME12,
                 COALESCE(cpu_queue_length,0)::double precision as VALUE12,
          top_type || '|cpu sys mhz'::text as METRICNAME13,
                 COALESCE(cpu_sys_mhz,0)::double precision as VALUE13,
          top_type || '|cpu sys percent'::text as METRICNAME14,
                 COALESCE(cpu_sys_percent,0)::double precision as VALUE14,
          top_type || '|cpu user mhz'::text as METRICNAME15,
                 COALESCE(cpu_user_mhz,0)::double precision as VALUE15,
          top_type || '|cpu user percent'::text as METRICNAME16,
                 COALESCE(cpu_user_percent,0)::double precision as VALUE16,
          top_type || '|cpu used mhz'::text as METRICNAME17,
                 COALESCE(cpu_used_mhz,0)::double precision as VALUE17,
          top_type || '|cpu used percent'::text as METRICNAME18,
                 COALESCE(cpu_used_percent,0)::double precision as VALUE18,
          top_type || '|memory allocated gb'::text as METRICNAME19,
                 COALESCE(memory_allocated_gb,0)::double precision as VALUE19,
          top_type || '|memory used gb'::text as METRICNAME20,
                 COALESCE(memory_used_gb,0)::double precision as VALUE20,
          top_type || '|memory used percent'::text as METRICNAME21,
                 COALESCE(memory_used_percent,0)::double precision as VALUE21,
          top_type || '|page used gb'::text as METRICNAME22,
                 COALESCE(page_used_gb,0)::double precision as VALUE22,
          top_type || '|page used percent'::text as METRICNAME23,
                 COALESCE(page_used_percent,0)::double precision as VALUE23,
          top_type || '|disk read iops'::text as METRICNAME24,
                 COALESCE(disk_read_iops,0)::double precision as VALUE24,
          top_type || '|disk write iops'::text as METRICNAME25,
                 COALESCE(disk_write_iops,0)::double precision as VALUE25,
          top_type || '|disk iops'::text as METRICNAME26,
                 COALESCE(disk_iops,0)::double precision as VALUE26,
          top_type || '|disk read io kbs'::text as METRICNAME27,
                 COALESCE(disk_read_io_kbs,0)::double precision as VALUE27,
          top_type || '|disk write io kbs'::text as METRICNAME28,
                 COALESCE(disk_write_io_kbs,0)::double precision as VALUE28,
          top_type || '|disk io kbs'::text as METRICNAME29,
                 COALESCE(disk_io_kbs,0)::double precision as VALUE29,
          top_type || '|disk used gb'::text as METRICNAME30,
                 COALESCE(disk_used_gb,0)::double precision as VALUE30,
          top_type || '|disk size gb'::text as METRICNAME31,
                 COALESCE(disk_size_gb,0)::double precision as VALUE31,
          top_type || '|disk queue'::text as METRICNAME32,
                 COALESCE(disk_queue,0)::double precision as VALUE32,
          top_type || '|net send kbs'::text as METRICNAME33,
                 COALESCE(net_send_kbs,0)::double precision as VALUE33,
          top_type || '|net receive kbs'::text as METRICNAME34,
                 COALESCE(net_receive_kbs,0)::double precision as VALUE34,
          top_type || '|net kbs'::text as METRICNAME35,
                 COALESCE(net_kbs,0)::double precision as VALUE35,
          top_type || '|network latency ms avg'::text as METRICNAME36,
                 COALESCE(network_latency_ms_avg,0)::double precision as VALUE36,
          top_type || '|failed connects'::text as METRICNAME37,
                 COALESCE(failed_connects,0)::double precision as VALUE37,
          ''::text as METRICNAME38, 0::double precision as VALUE38,
          ''::text as METRICNAME39, 0::double precision as VALUE39,
          ''::text as METRICNAME40, 0::double precision as VALUE40
      from user_group_avg s
     where user_group_id > 0
),

vcops_sum_node_group as (
select
         node_group_name as RESOURCENAME,
         RES_NODE_KIND::text  as RESOURCEKIND,
         ADAPTER::text   as ADAPTERKIND,
         date_trunc('second',(var_end_date)::timestamp)                AS TIMESTAMP,
          top_type || '|node count'::text as METRICNAME1,
                 COALESCE(node_count,0)::double precision as VALUE1,
          top_type || '|user count'::text as METRICNAME2,
                 COALESCE(user_count,0)::double precision as VALUE2,
          top_type || '|overall ux rating avg'::text as METRICNAME3,
                 COALESCE(overall_ux_rating_avg,0)::double precision as VALUE3,
          top_type || '|overall fit rating avg'::text as METRICNAME4,
                 COALESCE(overall_fit_rating_avg,0)::double precision as VALUE4,
          top_type || '|login delay avg'::text as METRICNAME5,
                 COALESCE(login_delay_avg,0)::double precision as VALUE5,
          top_type || '|non responding apps'::text as METRICNAME6,
                 COALESCE(non_responding_apps,0)::double precision as VALUE6,
          top_type || '|page faults soft'::text as METRICNAME7,
                 COALESCE(page_faults_soft,0)::double precision as VALUE7,
          top_type || '|page faults hard'::text as METRICNAME8,
                 COALESCE(page_faults_hard,0)::double precision as VALUE8,
          top_type || '|application load time avg'::text as METRICNAME9,
                 COALESCE(application_load_time_avg,0)::double precision as VALUE9,
          top_type || '|gdi objects'::text as METRICNAME10,
                 COALESCE(gdi_objects,0)::double precision as VALUE10,
          top_type || '|gpu percent used'::text as METRICNAME11,
                 COALESCE(gpu_percent_used,0)::double precision as VALUE11,
          top_type || '|cpu queue length'::text as METRICNAME12,
                 COALESCE(cpu_queue_length,0)::double precision as VALUE12,
          top_type || '|cpu sys ghz'::text as METRICNAME13,
                 COALESCE(cpu_sys_ghz,0)::double precision as VALUE13,
          top_type || '|cpu sys percent'::text as METRICNAME14,
                 COALESCE(cpu_sys_percent,0)::double precision as VALUE14,
          top_type || '|cpu user ghz'::text as METRICNAME15,
                 COALESCE(cpu_user_ghz,0)::double precision as VALUE15,
          top_type || '|cpu user percent'::text as METRICNAME16,
                 COALESCE(cpu_user_percent,0)::double precision as VALUE16,
          top_type || '|cpu used ghz'::text as METRICNAME17,
                 COALESCE(cpu_used_ghz,0)::double precision as VALUE17,
          top_type || '|cpu used percent'::text as METRICNAME18,
                 COALESCE(cpu_used_percent,0)::double precision as VALUE18,
          top_type || '|memory allocated gb'::text as METRICNAME19,
                 COALESCE(memory_allocated_gb,0)::double precision as VALUE19,
          top_type || '|memory used gb'::text as METRICNAME20,
                 COALESCE(memory_used_gb,0)::double precision as VALUE20,
          top_type || '|memory used percent'::text as METRICNAME21,
                 COALESCE(memory_used_percent,0)::double precision as VALUE21,
          top_type || '|page used gb'::text as METRICNAME22,
                 COALESCE(page_used_gb,0)::double precision as VALUE22,
          top_type || '|page used percent'::text as METRICNAME23,
                 COALESCE(page_used_percent,0)::double precision as VALUE23,
          top_type || '|disk read iops'::text as METRICNAME24,
                 COALESCE(disk_read_iops,0)::double precision as VALUE24,
          top_type || '|disk write iops'::text as METRICNAME25,
                 COALESCE(disk_write_iops,0)::double precision as VALUE25,
          top_type || '|disk iops'::text as METRICNAME26,
                 COALESCE(disk_iops,0)::double precision as VALUE26,
          top_type || '|disk read io mbs'::text as METRICNAME27,
                 COALESCE(disk_read_io_mbs,0)::double precision as VALUE27,
          top_type || '|disk write io mbs'::text as METRICNAME28,
                 COALESCE(disk_write_io_mbs,0)::double precision as VALUE28,
          top_type || '|disk io mbs'::text as METRICNAME29,
                 COALESCE(disk_io_mbs,0)::double precision as VALUE29,
          top_type || '|disk used tb'::text as METRICNAME30,
                 COALESCE(disk_used_tb,0)::double precision as VALUE30,
          top_type || '|disk size tb'::text as METRICNAME31,
                 COALESCE(disk_size_tb,0)::double precision as VALUE31,
          top_type || '|disk queue'::text as METRICNAME32,
                 COALESCE(disk_queue,0)::double precision as VALUE32,
          top_type || '|net send mbs'::text as METRICNAME33,
                 COALESCE(net_send_mbs,0)::double precision as VALUE33,
          top_type || '|net receive mbs'::text as METRICNAME34,
                 COALESCE(net_receive_mbs,0)::double precision as VALUE34,
          top_type || '|net mbs'::text as METRICNAME35,
                 COALESCE(net_mbs,0)::double precision as VALUE35,
          top_type || '|network latency ms avg'::text as METRICNAME36,
                 COALESCE(network_latency_ms_avg,0)::double precision as VALUE36,
          top_type || '|failed connects'::text as METRICNAME37,
                 COALESCE(failed_connects,0)::double precision as VALUE37,
          ''::text as METRICNAME38, 0::double precision as VALUE38,
          ''::text as METRICNAME39, 0::double precision as VALUE39,
          ''::text as METRICNAME40, 0::double precision as VALUE40
      from node_group_sum s
),

vcops_sum_all_user_group as (
select
         node_group_name as RESOURCENAME,
         RES_KIND::text  as RESOURCEKIND,
         ADAPTER::text   as ADAPTERKIND,
         date_trunc('second',(var_end_date)::timestamp)                AS TIMESTAMP,
          top_type || '|node count'::text as METRICNAME1,
                 COALESCE(node_count,0)::double precision as VALUE1,
          top_type || '|user count'::text as METRICNAME2,
                 COALESCE(user_count,0)::double precision as VALUE2,
          top_type || '|overall ux rating avg'::text as METRICNAME3,
                 COALESCE(overall_ux_rating_avg,0)::double precision as VALUE3,
          top_type || '|overall fit rating avg'::text as METRICNAME4,
                 COALESCE(overall_fit_rating_avg,0)::double precision as VALUE4,
          top_type || '|login delay avg'::text as METRICNAME5,
                 COALESCE(login_delay_avg,0)::double precision as VALUE5,
          top_type || '|non responding apps'::text as METRICNAME6,
                 COALESCE(non_responding_apps,0)::double precision as VALUE6,
          top_type || '|page faults soft'::text as METRICNAME7,
                 COALESCE(page_faults_soft,0)::double precision as VALUE7,
          top_type || '|page faults hard'::text as METRICNAME8,
                 COALESCE(page_faults_hard,0)::double precision as VALUE8,
          top_type || '|application load time avg'::text as METRICNAME9,
                 COALESCE(application_load_time_avg,0)::double precision as VALUE9,
          top_type || '|gdi objects'::text as METRICNAME10,
                 COALESCE(gdi_objects,0)::double precision as VALUE10,
          top_type || '|gpu percent used'::text as METRICNAME11,
                 COALESCE(gpu_percent_used,0)::double precision as VALUE11,
          top_type || '|cpu queue length'::text as METRICNAME12,
                 COALESCE(cpu_queue_length,0)::double precision as VALUE12,
          top_type || '|cpu sys ghz'::text as METRICNAME13,
                 COALESCE(cpu_sys_ghz,0)::double precision as VALUE13,
          top_type || '|cpu sys percent'::text as METRICNAME14,
                 COALESCE(cpu_sys_percent,0)::double precision as VALUE14,
          top_type || '|cpu user ghz'::text as METRICNAME15,
                 COALESCE(cpu_user_ghz,0)::double precision as VALUE15,
          top_type || '|cpu user percent'::text as METRICNAME16,
                 COALESCE(cpu_user_percent,0)::double precision as VALUE16,
          top_type || '|cpu used ghz'::text as METRICNAME17,
                 COALESCE(cpu_used_ghz,0)::double precision as VALUE17,
          top_type || '|cpu used percent'::text as METRICNAME18,
                 COALESCE(cpu_used_percent,0)::double precision as VALUE18,
          top_type || '|memory allocated gb'::text as METRICNAME19,
                 COALESCE(memory_allocated_gb,0)::double precision as VALUE19,
          top_type || '|memory used gb'::text as METRICNAME20,
                 COALESCE(memory_used_gb,0)::double precision as VALUE20,
          top_type || '|memory used percent'::text as METRICNAME21,
                 COALESCE(memory_used_percent,0)::double precision as VALUE21,
          top_type || '|page used gb'::text as METRICNAME22,
                 COALESCE(page_used_gb,0)::double precision as VALUE22,
          top_type || '|page used percent'::text as METRICNAME23,
                 COALESCE(page_used_percent,0)::double precision as VALUE23,
          top_type || '|disk read iops'::text as METRICNAME24,
                 COALESCE(disk_read_iops,0)::double precision as VALUE24,
          top_type || '|disk write iops'::text as METRICNAME25,
                 COALESCE(disk_write_iops,0)::double precision as VALUE25,
          top_type || '|disk iops'::text as METRICNAME26,
                 COALESCE(disk_iops,0)::double precision as VALUE26,
          top_type || '|disk read io mbs'::text as METRICNAME27,
                 COALESCE(disk_read_io_mbs,0)::double precision as VALUE27,
          top_type || '|disk write io mbs'::text as METRICNAME28,
                 COALESCE(disk_write_io_mbs,0)::double precision as VALUE28,
          top_type || '|disk io mbs'::text as METRICNAME29,
                 COALESCE(disk_io_mbs,0)::double precision as VALUE29,
          top_type || '|disk used tb'::text as METRICNAME30,
                 COALESCE(disk_used_tb,0)::double precision as VALUE30,
          top_type || '|disk size tb'::text as METRICNAME31,
                 COALESCE(disk_size_tb,0)::double precision as VALUE31,
          top_type || '|disk queue'::text as METRICNAME32,
                 COALESCE(disk_queue,0)::double precision as VALUE32,
          top_type || '|net send mbs'::text as METRICNAME33,
                 COALESCE(net_send_mbs,0)::double precision as VALUE33,
          top_type || '|net receive mbs'::text as METRICNAME34,
                 COALESCE(net_receive_mbs,0)::double precision as VALUE34,
          top_type || '|net mbs'::text as METRICNAME35,
                 COALESCE(net_mbs,0)::double precision as VALUE35,
          top_type || '|network latency ms avg'::text as METRICNAME36,
                 COALESCE(network_latency_ms_avg,0)::double precision as VALUE36,
          top_type || '|failed connects'::text as METRICNAME37,
                 COALESCE(failed_connects,0)::double precision as VALUE37,
          ''::text as METRICNAME38, 0::double precision as VALUE38,
          ''::text as METRICNAME39, 0::double precision as VALUE39,
          ''::text as METRICNAME40, 0::double precision as VALUE40
      from all_user_group_sum s
),


  vcops_avg_node_group as (
select
         node_group_name as RESOURCENAME,
         RES_NODE_KIND::text  as RESOURCEKIND,
         ADAPTER::text   as ADAPTERKIND,
         date_trunc('second',(var_end_date)::timestamp)                AS TIMESTAMP,
          top_type || '|node count'::text as METRICNAME1,
                 COALESCE(node_count,0)::double precision as VALUE1,
          top_type || '|user count'::text as METRICNAME2,
                 COALESCE(user_count,0)::double precision as VALUE2,
          top_type || '|overall ux rating avg'::text as METRICNAME3,
                 COALESCE(overall_ux_rating_avg,0)::double precision as VALUE3,
          top_type || '|overall fit rating avg'::text as METRICNAME4,
                 COALESCE(overall_fit_rating_avg,0)::double precision as VALUE4,
          top_type || '|login delay avg'::text as METRICNAME5,
                 COALESCE(login_delay_avg,0)::double precision as VALUE5,
          top_type || '|non responding apps'::text as METRICNAME6,
                 COALESCE(non_responding_apps,0)::double precision as VALUE6,
          top_type || '|page faults soft'::text as METRICNAME7,
                 COALESCE(page_faults_soft,0)::double precision as VALUE7,
          top_type || '|page faults hard'::text as METRICNAME8,
                 COALESCE(page_faults_hard,0)::double precision as VALUE8,
          top_type || '|application load time avg'::text as METRICNAME9,
                 COALESCE(application_load_time_avg,0)::double precision as VALUE9,
          top_type || '|gdi objects'::text as METRICNAME10,
                 COALESCE(gdi_objects,0)::double precision as VALUE10,
          top_type || '|gpu percent used'::text as METRICNAME11,
                 COALESCE(gpu_percent_used,0)::double precision as VALUE11,
          top_type || '|cpu queue length'::text as METRICNAME12,
                 COALESCE(cpu_queue_length,0)::double precision as VALUE12,
          top_type || '|cpu sys mhz'::text as METRICNAME13,
                 COALESCE(cpu_sys_mhz,0)::double precision as VALUE13,
          top_type || '|cpu sys percent'::text as METRICNAME14,
                 COALESCE(cpu_sys_percent,0)::double precision as VALUE14,
          top_type || '|cpu user mhz'::text as METRICNAME15,
                 COALESCE(cpu_user_mhz,0)::double precision as VALUE15,
          top_type || '|cpu user percent'::text as METRICNAME16,
                 COALESCE(cpu_user_percent,0)::double precision as VALUE16,
          top_type || '|cpu used mhz'::text as METRICNAME17,
                 COALESCE(cpu_used_mhz,0)::double precision as VALUE17,
          top_type || '|cpu used percent'::text as METRICNAME18,
                 COALESCE(cpu_used_percent,0)::double precision as VALUE18,
          top_type || '|memory allocated gb'::text as METRICNAME19,
                 COALESCE(memory_allocated_gb,0)::double precision as VALUE19,
          top_type || '|memory used gb'::text as METRICNAME20,
                 COALESCE(memory_used_gb,0)::double precision as VALUE20,
          top_type || '|memory used percent'::text as METRICNAME21,
                 COALESCE(memory_used_percent,0)::double precision as VALUE21,
          top_type || '|page used gb'::text as METRICNAME22,
                 COALESCE(page_used_gb,0)::double precision as VALUE22,
          top_type || '|page used percent'::text as METRICNAME23,
                 COALESCE(page_used_percent,0)::double precision as VALUE23,
          top_type || '|disk read iops'::text as METRICNAME24,
                 COALESCE(disk_read_iops,0)::double precision as VALUE24,
          top_type || '|disk write iops'::text as METRICNAME25,
                 COALESCE(disk_write_iops,0)::double precision as VALUE25,
          top_type || '|disk iops'::text as METRICNAME26,
                 COALESCE(disk_iops,0)::double precision as VALUE26,
          top_type || '|disk read io kbs'::text as METRICNAME27,
                 COALESCE(disk_read_io_kbs,0)::double precision as VALUE27,
          top_type || '|disk write io kbs'::text as METRICNAME28,
                 COALESCE(disk_write_io_kbs,0)::double precision as VALUE28,
          top_type || '|disk io kbs'::text as METRICNAME29,
                 COALESCE(disk_io_kbs,0)::double precision as VALUE29,
          top_type || '|disk used gb'::text as METRICNAME30,
                 COALESCE(disk_used_gb,0)::double precision as VALUE30,
          top_type || '|disk size gb'::text as METRICNAME31,
                 COALESCE(disk_size_gb,0)::double precision as VALUE31,
          top_type || '|disk queue'::text as METRICNAME32,
                 COALESCE(disk_queue,0)::double precision as VALUE32,
          top_type || '|net send kbs'::text as METRICNAME33,
                 COALESCE(net_send_kbs,0)::double precision as VALUE33,
          top_type || '|net receive kbs'::text as METRICNAME34,
                 COALESCE(net_receive_kbs,0)::double precision as VALUE34,
          top_type || '|net kbs'::text as METRICNAME35,
                 COALESCE(net_kbs,0)::double precision as VALUE35,
          top_type || '|network latency ms avg'::text as METRICNAME36,
                 COALESCE(network_latency_ms_avg,0)::double precision as VALUE36,
          top_type || '|failed connects'::text as METRICNAME37,
                 COALESCE(failed_connects,0)::double precision as VALUE37,
          ''::text as METRICNAME38, 0::double precision as VALUE38,
          ''::text as METRICNAME39, 0::double precision as VALUE39,
          ''::text as METRICNAME40, 0::double precision as VALUE40
      from node_group_avg s
),

  vcops_avg_all_user_group as (
select
         node_group_name as RESOURCENAME,
         RES_KIND::text  as RESOURCEKIND,
         ADAPTER::text   as ADAPTERKIND,
         date_trunc('second',(var_end_date)::timestamp)                AS TIMESTAMP,
          top_type || '|node count'::text as METRICNAME1,
                 COALESCE(node_count,0)::double precision as VALUE1,
          top_type || '|user count'::text as METRICNAME2,
                 COALESCE(user_count,0)::double precision as VALUE2,
          top_type || '|overall ux rating avg'::text as METRICNAME3,
                 COALESCE(overall_ux_rating_avg,0)::double precision as VALUE3,
          top_type || '|overall fit rating avg'::text as METRICNAME4,
                 COALESCE(overall_fit_rating_avg,0)::double precision as VALUE4,
          top_type || '|login delay avg'::text as METRICNAME5,
                 COALESCE(login_delay_avg,0)::double precision as VALUE5,
          top_type || '|non responding apps'::text as METRICNAME6,
                 COALESCE(non_responding_apps,0)::double precision as VALUE6,
          top_type || '|page faults soft'::text as METRICNAME7,
                 COALESCE(page_faults_soft,0)::double precision as VALUE7,
          top_type || '|page faults hard'::text as METRICNAME8,
                 COALESCE(page_faults_hard,0)::double precision as VALUE8,
          top_type || '|application load time avg'::text as METRICNAME9,
                 COALESCE(application_load_time_avg,0)::double precision as VALUE9,
          top_type || '|gdi objects'::text as METRICNAME10,
                 COALESCE(gdi_objects,0)::double precision as VALUE10,
          top_type || '|gpu percent used'::text as METRICNAME11,
                 COALESCE(gpu_percent_used,0)::double precision as VALUE11,
          top_type || '|cpu queue length'::text as METRICNAME12,
                 COALESCE(cpu_queue_length,0)::double precision as VALUE12,
          top_type || '|cpu sys mhz'::text as METRICNAME13,
                 COALESCE(cpu_sys_mhz,0)::double precision as VALUE13,
          top_type || '|cpu sys percent'::text as METRICNAME14,
                 COALESCE(cpu_sys_percent,0)::double precision as VALUE14,
          top_type || '|cpu user mhz'::text as METRICNAME15,
                 COALESCE(cpu_user_mhz,0)::double precision as VALUE15,
          top_type || '|cpu user percent'::text as METRICNAME16,
                 COALESCE(cpu_user_percent,0)::double precision as VALUE16,
          top_type || '|cpu used mhz'::text as METRICNAME17,
                 COALESCE(cpu_used_mhz,0)::double precision as VALUE17,
          top_type || '|cpu used percent'::text as METRICNAME18,
                 COALESCE(cpu_used_percent,0)::double precision as VALUE18,
          top_type || '|memory allocated gb'::text as METRICNAME19,
                 COALESCE(memory_allocated_gb,0)::double precision as VALUE19,
          top_type || '|memory used gb'::text as METRICNAME20,
                 COALESCE(memory_used_gb,0)::double precision as VALUE20,
          top_type || '|memory used percent'::text as METRICNAME21,
                 COALESCE(memory_used_percent,0)::double precision as VALUE21,
          top_type || '|page used gb'::text as METRICNAME22,
                 COALESCE(page_used_gb,0)::double precision as VALUE22,
          top_type || '|page used percent'::text as METRICNAME23,
                 COALESCE(page_used_percent,0)::double precision as VALUE23,
          top_type || '|disk read iops'::text as METRICNAME24,
                 COALESCE(disk_read_iops,0)::double precision as VALUE24,
          top_type || '|disk write iops'::text as METRICNAME25,
                 COALESCE(disk_write_iops,0)::double precision as VALUE25,
          top_type || '|disk iops'::text as METRICNAME26,
                 COALESCE(disk_iops,0)::double precision as VALUE26,
          top_type || '|disk read io kbs'::text as METRICNAME27,
                 COALESCE(disk_read_io_kbs,0)::double precision as VALUE27,
          top_type || '|disk write io kbs'::text as METRICNAME28,
                 COALESCE(disk_write_io_kbs,0)::double precision as VALUE28,
          top_type || '|disk io kbs'::text as METRICNAME29,
                 COALESCE(disk_io_kbs,0)::double precision as VALUE29,
          top_type || '|disk used gb'::text as METRICNAME30,
                 COALESCE(disk_used_gb,0)::double precision as VALUE30,
          top_type || '|disk size gb'::text as METRICNAME31,
                 COALESCE(disk_size_gb,0)::double precision as VALUE31,
          top_type || '|disk queue'::text as METRICNAME32,
                 COALESCE(disk_queue,0)::double precision as VALUE32,
          top_type || '|net send kbs'::text as METRICNAME33,
                 COALESCE(net_send_kbs,0)::double precision as VALUE33,
          top_type || '|net receive kbs'::text as METRICNAME34,
                 COALESCE(net_receive_kbs,0)::double precision as VALUE34,
          top_type || '|net kbs'::text as METRICNAME35,
                 COALESCE(net_kbs,0)::double precision as VALUE35,
          top_type || '|network latency ms avg'::text as METRICNAME36,
                 COALESCE(network_latency_ms_avg,0)::double precision as VALUE36,
          top_type || '|failed connects'::text as METRICNAME37,
                 COALESCE(failed_connects,0)::double precision as VALUE37,
          ''::text as METRICNAME38, 0::double precision as VALUE38,
          ''::text as METRICNAME39, 0::double precision as VALUE39,
          ''::text as METRICNAME40, 0::double precision as VALUE40
      from all_user_group_avg s
),

 vcops_avg_node_user_group as (
select
         node_user_name            as RESOURCENAME,
         RES_NODE_USER_KIND::text  as RESOURCEKIND,
         ADAPTER::text             as ADAPTERKIND,
         date_trunc('second',(var_end_date)::timestamp)                AS TIMESTAMP,
          top_type || '|node count'::text as METRICNAME1,
                 1::double precision as VALUE1,
          top_type || '|user count'::text as METRICNAME2,
                 1::double precision as VALUE2,
          top_type || '|overall ux rating avg'::text as METRICNAME3,
                 COALESCE(overall_ux_rating_avg,0)::double precision as VALUE3,
          top_type || '|overall fit rating avg'::text as METRICNAME4,
                 COALESCE(overall_fit_rating_avg,0)::double precision as VALUE4,
          top_type || '|login delay avg'::text as METRICNAME5,
                 COALESCE(login_delay_avg,0)::double precision as VALUE5,
          top_type || '|non responding apps'::text as METRICNAME6,
                 COALESCE(non_responding_apps,0)::double precision as VALUE6,
          top_type || '|page faults soft'::text as METRICNAME7,
                 COALESCE(page_faults_soft,0)::double precision as VALUE7,
          top_type || '|page faults hard'::text as METRICNAME8,
                 COALESCE(page_faults_hard,0)::double precision as VALUE8,
          top_type || '|application load time avg'::text as METRICNAME9,
                 COALESCE(application_load_time_avg,0)::double precision as VALUE9,
          top_type || '|gdi objects'::text as METRICNAME10,
                 COALESCE(gdi_objects,0)::double precision as VALUE10,
          top_type || '|gpu percent used'::text as METRICNAME11,
                 COALESCE(gpu_percent_used,0)::double precision as VALUE11,
          top_type || '|cpu queue length'::text as METRICNAME12,
                 COALESCE(cpu_queue_length,0)::double precision as VALUE12,
          top_type || '|cpu sys mhz'::text as METRICNAME13,
                 COALESCE(cpu_sys_mhz,0)::double precision as VALUE13,
          top_type || '|cpu sys percent'::text as METRICNAME14,
                 COALESCE(cpu_sys_percent,0)::double precision as VALUE14,
          top_type || '|cpu user mhz'::text as METRICNAME15,
                 COALESCE(cpu_user_mhz,0)::double precision as VALUE15,
          top_type || '|cpu user percent'::text as METRICNAME16,
                 COALESCE(cpu_user_percent,0)::double precision as VALUE16,
          top_type || '|cpu used mhz'::text as METRICNAME17,
                 COALESCE(cpu_used_mhz,0)::double precision as VALUE17,
          top_type || '|cpu used percent'::text as METRICNAME18,
                 COALESCE(cpu_used_percent,0)::double precision as VALUE18,
          top_type || '|memory allocated gb'::text as METRICNAME19,
                 COALESCE(memory_allocated_gb,0)::double precision as VALUE19,
          top_type || '|memory used gb'::text as METRICNAME20,
                 COALESCE(memory_used_gb,0)::double precision as VALUE20,
          top_type || '|memory used percent'::text as METRICNAME21,
                 COALESCE(memory_used_percent,0)::double precision as VALUE21,
          top_type || '|page used gb'::text as METRICNAME22,
                 COALESCE(page_used_gb,0)::double precision as VALUE22,
          top_type || '|page used percent'::text as METRICNAME23,
                 COALESCE(page_used_percent,0)::double precision as VALUE23,
          top_type || '|disk read iops'::text as METRICNAME24,
                 COALESCE(disk_read_iops,0)::double precision as VALUE24,
          top_type || '|disk write iops'::text as METRICNAME25,
                 COALESCE(disk_write_iops,0)::double precision as VALUE25,
          top_type || '|disk iops'::text as METRICNAME26,
                 COALESCE(disk_iops,0)::double precision as VALUE26,
          top_type || '|disk read io kbs'::text as METRICNAME27,
                 COALESCE(disk_read_io_kbs,0)::double precision as VALUE27,
          top_type || '|disk write io kbs'::text as METRICNAME28,
                 COALESCE(disk_write_io_kbs,0)::double precision as VALUE28,
          top_type || '|disk io kbs'::text as METRICNAME29,
                 COALESCE(disk_io_kbs,0)::double precision as VALUE29,
          top_type || '|disk used gb'::text as METRICNAME30,
                 COALESCE(disk_used_gb,0)::double precision as VALUE30,
          top_type || '|disk size gb'::text as METRICNAME31,
                 COALESCE(disk_size_gb,0)::double precision as VALUE31,
          top_type || '|disk queue'::text as METRICNAME32,
                 COALESCE(disk_queue,0)::double precision as VALUE32,
          top_type || '|net send kbs'::text as METRICNAME33,
                 COALESCE(net_send_kbs,0)::double precision as VALUE33,
          top_type || '|net receive kbs'::text as METRICNAME34,
                 COALESCE(net_receive_kbs,0)::double precision as VALUE34,
          top_type || '|net kbs'::text as METRICNAME35,
                 COALESCE(net_kbs,0)::double precision as VALUE35,
          top_type || '|network latency ms avg'::text as METRICNAME36,
                 COALESCE(network_latency_ms_avg,0)::double precision as VALUE36,
          top_type || '|failed connects'::text as METRICNAME37,
                 COALESCE(failed_connects,0)::double precision as VALUE37,
          ''::text as METRICNAME38, 0::double precision as VALUE38,
          ''::text as METRICNAME39, 0::double precision as VALUE39,
          ''::text as METRICNAME40, 0::double precision as VALUE40
      from node_user_group_avg s
     where user_id > 0
),
 vcops_disabled as (
    select
         'CHECK LWL VCOPS SETTINGS'::text as RESOURCENAME,
         BAD_KIND::text  as RESOURCEKIND,
         ADAPTER::text   as ADAPTERKIND,
         date_trunc('second',(var_end_date)::timestamp)                AS TIMESTAMP,
          ''::text as METRICNAME1, 0::double precision as VALUE1,
          ''::text as METRICNAME2, 0::double precision as VALUE2,
          ''::text as METRICNAME3, 0::double precision as VALUE3,
          ''::text as METRICNAME4, 0::double precision as VALUE4,
          ''::text as METRICNAME5, 0::double precision as VALUE5,
          ''::text as METRICNAME6, 0::double precision as VALUE6,
          ''::text as METRICNAME7, 0::double precision as VALUE7,
          ''::text as METRICNAME8, 0::double precision as VALUE8,
          ''::text as METRICNAME9, 0::double precision as VALUE9,
          ''::text as METRICNAME10, 0::double precision as VALUE10,
          ''::text as METRICNAME11, 0::double precision as VALUE11,
          ''::text as METRICNAME12, 0::double precision as VALUE12,
          ''::text as METRICNAME13, 0::double precision as VALUE13,
          ''::text as METRICNAME14, 0::double precision as VALUE14,
          ''::text as METRICNAME15, 0::double precision as VALUE15,
          ''::text as METRICNAME16, 0::double precision as VALUE16,
          ''::text as METRICNAME17, 0::double precision as VALUE17,
          ''::text as METRICNAME18, 0::double precision as VALUE18,
          ''::text as METRICNAME19, 0::double precision as VALUE19,
          ''::text as METRICNAME20, 0::double precision as VALUE20,
          ''::text as METRICNAME21, 0::double precision as VALUE21,
          ''::text as METRICNAME22, 0::double precision as VALUE22,
          ''::text as METRICNAME23, 0::double precision as VALUE23,
          ''::text as METRICNAME24, 0::double precision as VALUE24,
          ''::text as METRICNAME25, 0::double precision as VALUE25,
          ''::text as METRICNAME26, 0::double precision as VALUE26,
          ''::text as METRICNAME27, 0::double precision as VALUE27,
          ''::text as METRICNAME28, 0::double precision as VALUE28,
          ''::text as METRICNAME29, 0::double precision as VALUE29,
          ''::text as METRICNAME30, 0::double precision as VALUE30,
          ''::text as METRICNAME31, 0::double precision as VALUE31,
          ''::text as METRICNAME32, 0::double precision as VALUE32,
          ''::text as METRICNAME33, 0::double precision as VALUE33,
          ''::text as METRICNAME34, 0::double precision as VALUE34,
          ''::text as METRICNAME35, 0::double precision as VALUE35,
          ''::text as METRICNAME36, 0::double precision as VALUE36,
          ''::text as METRICNAME37, 0::double precision as VALUE37,
          ''::text as METRICNAME38, 0::double precision as VALUE38,
          ''::text as METRICNAME39, 0::double precision as VALUE39,
          ''::text as METRICNAME40, 0::double precision as VALUE40
),


 vcops_no_groups as (
    select
         'NO USER GROUPS SET TO EXPORT'::text as RESOURCENAME,
         BAD_KIND::text  as RESOURCEKIND,
         ADAPTER::text   as ADAPTERKIND,
         date_trunc('second',(var_end_date)::timestamp)                AS TIMESTAMP,
          ''::text as METRICNAME1, 0::double precision as VALUE1,
          ''::text as METRICNAME2, 0::double precision as VALUE2,
          ''::text as METRICNAME3, 0::double precision as VALUE3,
          ''::text as METRICNAME4, 0::double precision as VALUE4,
          ''::text as METRICNAME5, 0::double precision as VALUE5,
          ''::text as METRICNAME6, 0::double precision as VALUE6,
          ''::text as METRICNAME7, 0::double precision as VALUE7,
          ''::text as METRICNAME8, 0::double precision as VALUE8,
          ''::text as METRICNAME9, 0::double precision as VALUE9,
          ''::text as METRICNAME10, 0::double precision as VALUE10,
          ''::text as METRICNAME11, 0::double precision as VALUE11,
          ''::text as METRICNAME12, 0::double precision as VALUE12,
          ''::text as METRICNAME13, 0::double precision as VALUE13,
          ''::text as METRICNAME14, 0::double precision as VALUE14,
          ''::text as METRICNAME15, 0::double precision as VALUE15,
          ''::text as METRICNAME16, 0::double precision as VALUE16,
          ''::text as METRICNAME17, 0::double precision as VALUE17,
          ''::text as METRICNAME18, 0::double precision as VALUE18,
          ''::text as METRICNAME19, 0::double precision as VALUE19,
          ''::text as METRICNAME20, 0::double precision as VALUE20,
          ''::text as METRICNAME21, 0::double precision as VALUE21,
          ''::text as METRICNAME22, 0::double precision as VALUE22,
          ''::text as METRICNAME23, 0::double precision as VALUE23,
          ''::text as METRICNAME24, 0::double precision as VALUE24,
          ''::text as METRICNAME25, 0::double precision as VALUE25,
          ''::text as METRICNAME26, 0::double precision as VALUE26,
          ''::text as METRICNAME27, 0::double precision as VALUE27,
          ''::text as METRICNAME28, 0::double precision as VALUE28,
          ''::text as METRICNAME29, 0::double precision as VALUE29,
          ''::text as METRICNAME30, 0::double precision as VALUE30,
          ''::text as METRICNAME31, 0::double precision as VALUE31,
          ''::text as METRICNAME32, 0::double precision as VALUE32,
          ''::text as METRICNAME33, 0::double precision as VALUE33,
          ''::text as METRICNAME34, 0::double precision as VALUE34,
          ''::text as METRICNAME35, 0::double precision as VALUE35,
          ''::text as METRICNAME36, 0::double precision as VALUE36,
          ''::text as METRICNAME37, 0::double precision as VALUE37,
          ''::text as METRICNAME38, 0::double precision as VALUE38,
          ''::text as METRICNAME39, 0::double precision as VALUE39,
          ''::text as METRICNAME40, 0::double precision as VALUE40
),

 vcops_no_m_groups as (
    select
         'NO MACHINE GROUPS SET TO EXPORT'::text as RESOURCENAME,
         BAD_KIND::text  as RESOURCEKIND,
         ADAPTER::text   as ADAPTERKIND,
         date_trunc('second',(var_end_date)::timestamp)                AS TIMESTAMP,
          ''::text as METRICNAME1, 0::double precision as VALUE1,
          ''::text as METRICNAME2, 0::double precision as VALUE2,
          ''::text as METRICNAME3, 0::double precision as VALUE3,
          ''::text as METRICNAME4, 0::double precision as VALUE4,
          ''::text as METRICNAME5, 0::double precision as VALUE5,
          ''::text as METRICNAME6, 0::double precision as VALUE6,
          ''::text as METRICNAME7, 0::double precision as VALUE7,
          ''::text as METRICNAME8, 0::double precision as VALUE8,
          ''::text as METRICNAME9, 0::double precision as VALUE9,
          ''::text as METRICNAME10, 0::double precision as VALUE10,
          ''::text as METRICNAME11, 0::double precision as VALUE11,
          ''::text as METRICNAME12, 0::double precision as VALUE12,
          ''::text as METRICNAME13, 0::double precision as VALUE13,
          ''::text as METRICNAME14, 0::double precision as VALUE14,
          ''::text as METRICNAME15, 0::double precision as VALUE15,
          ''::text as METRICNAME16, 0::double precision as VALUE16,
          ''::text as METRICNAME17, 0::double precision as VALUE17,
          ''::text as METRICNAME18, 0::double precision as VALUE18,
          ''::text as METRICNAME19, 0::double precision as VALUE19,
          ''::text as METRICNAME20, 0::double precision as VALUE20,
          ''::text as METRICNAME21, 0::double precision as VALUE21,
          ''::text as METRICNAME22, 0::double precision as VALUE22,
          ''::text as METRICNAME23, 0::double precision as VALUE23,
          ''::text as METRICNAME24, 0::double precision as VALUE24,
          ''::text as METRICNAME25, 0::double precision as VALUE25,
          ''::text as METRICNAME26, 0::double precision as VALUE26,
          ''::text as METRICNAME27, 0::double precision as VALUE27,
          ''::text as METRICNAME28, 0::double precision as VALUE28,
          ''::text as METRICNAME29, 0::double precision as VALUE29,
          ''::text as METRICNAME30, 0::double precision as VALUE30,
          ''::text as METRICNAME31, 0::double precision as VALUE31,
          ''::text as METRICNAME32, 0::double precision as VALUE32,
          ''::text as METRICNAME33, 0::double precision as VALUE33,
          ''::text as METRICNAME34, 0::double precision as VALUE34,
          ''::text as METRICNAME35, 0::double precision as VALUE35,
          ''::text as METRICNAME36, 0::double precision as VALUE36,
          ''::text as METRICNAME37, 0::double precision as VALUE37,
          ''::text as METRICNAME38, 0::double precision as VALUE38,
          ''::text as METRICNAME39, 0::double precision as VALUE39,
          ''::text as METRICNAME40, 0::double precision as VALUE40
),

 get_group_count as (
  SELECT count(distinct pi.id) as group_count
      from tnt_config.identitygroup_identity igi
 left join tnt_config.policyidentity pi
        on pi.id = igi.groupid and pi.delete_time is null
  join tnt_config.identitygroup g
        on g.id = igi.groupid and vcops_monitor is TRUE
 where igi.delete_time is null
),

 get_machine_group_count as (
   select count(distinct nodegroupid) as group_count
     from tnt_config.nodegroup_node ngn
     join tnt_config.policynode pn on (ngn.nodegroupid = pn.id)
     join tnt_config.nodegroup  ng on (ngn.nodegroupid = ng.id)
    where ngn.delete_time is null
      and 1=1
),

 final as (
    select * from vcops_avg_user_group
UNION
    select * from vcops_sum_user_group
),

 m_final as (
    select * from vcops_avg_node_group
UNION
    select * from vcops_sum_node_group
),

 u_final as (
    select * from vcops_avg_all_user_group
UNION
    select * from vcops_sum_all_user_group
),



 m_intersect as (
    select * from vcops_avg_node_user_group
),

 vcops_check_disabled as (
    select * from  vcops_disabled
     where 2 != var_VCOPS_ENABLED + var_INTERFACE_ACTIVE
        or 1 > var_VCOPS_MACHINE_GROUP +  var_VCOPS_USER_GROUP
),

 vcops_machine_group_export as (
select * from m_final
 where 1 = var_VCOPS_MACHINE_GROUP
   and 1 = var_INTERFACE_ACTIVE
   and 1 = var_VCOPS_ENABLED
),


 XXXXXXvcops_machine_group_export as (
select * from m_final
 where 1 = var_VCOPS_MACHINE_GROUP
   and 1 = var_INTERFACE_ACTIVE
   and 1 = var_VCOPS_ENABLED
UNION
    select * from  vcops_no_m_groups
     where 0 in (select group_count from get_machine_group_count)
       and 3 = var_VCOPS_MACHINE_GROUP + var_INTERFACE_ACTIVE + var_VCOPS_ENABLED
),



vcops_intersect_export as (
select * from m_intersect
 where 1 = var_VCOPS_MACHINE_GROUP
   and 1 = var_VCOPS_USER_GROUP
   and 1 = var_INTERFACE_ACTIVE
   and 1 = var_VCOPS_ENABLED
   and 1 = var_USER_INTERSECT
),

 XXXXvcops_user_group_export as (
select * from final
 where 1 = var_VCOPS_USER_GROUP
   and 1 = var_INTERFACE_ACTIVE
   and 1 = var_VCOPS_ENABLED
UNION
    select * from  vcops_no_groups
     where 0 in (select group_count from get_group_count)
),

 vcops_user_group_export as (
    select * from final
     where 1 = var_VCOPS_USER_GROUP
       and 1 = var_INTERFACE_ACTIVE
       and 1 = var_VCOPS_ENABLED
UNION
    select * from u_final
     where 1 = var_VCOPS_USER_GROUP
       and 1 = var_INTERFACE_ACTIVE
       and 1 = var_VCOPS_ENABLED

)

   select *
     from vcops_machine_group_export s
UNION
   select *
     from vcops_user_group_export s
UNION
   select *
     from vcops_intersect_export s
UNION
   select * from vcops_check_disabled

LOOP
   RETURN NEXT RECORD;
END LOOP;
RETURN;

END
$$ LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION tnt_config.func_lwl_vcops(timestamp without time zone, timestamp without time zone, text) OWNER TO postgres;
REVOKE ALL ON FUNCTION tnt_config.func_lwl_vcops(timestamp,timestamp,text) FROM PUBLIC;
REVOKE ALL ON FUNCTION tnt_config.func_lwl_vcops(timestamp,timestamp,text) FROM postgres;
GRANT ALL ON FUNCTION tnt_config.func_lwl_vcops(timestamp,timestamp,text) TO postgres;
GRANT EXECUTE ON FUNCTION tnt_config.func_lwl_vcops(timestamp,timestamp,text) TO impadmin;
GRANT EXECUTE ON FUNCTION tnt_config.func_lwl_vcops(timestamp,timestamp,text) TO reports;
GRANT EXECUTE ON FUNCTION tnt_config.func_lwl_vcops(timestamp,timestamp,text) TO vcops;

