-- these functions are for looping through an array and creatign an average and a count
-- originally added for mentok sql against summaryreports
--

CREATE OR REPLACE FUNCTION array_check(double precision[],double precision,double precision)
RETURNS text AS $$
with
base as (
   SELECT CASE WHEN v > $2 THEN v END as p
     FROM unnest($1) g(v)
),
peak1 as (
   SELECT p as p1,
          CASE WHEN p > $3 THEN p ELSE null END as p2
     FROM base
),
peak2 as (
   SELECT avg(p1) as p1,
          count(p1) as c1,
          avg(p2) as p2,
          count(p2) as c2
     FROM peak1
)
select p1::text || '|' || c1::text || '|' || p2::text || '|' || c2::text
  from peak2
$$ LANGUAGE sql;

CREATE OR REPLACE FUNCTION array_avg(text[])
RETURNS double precision AS $$
SELECT avg(CASE WHEN v='' then NULL else v::numeric END)::double precision FROM unnest($1) g(v)
$$ LANGUAGE sql;

CREATE OR REPLACE FUNCTION array_sum(text[])
RETURNS double precision AS $$
SELECT sum(CASE WHEN v='' then NULL else v::numeric END)::double precision FROM unnest($1) g(v)
$$ LANGUAGE sql;

CREATE OR REPLACE FUNCTION array_avg(double precision[],double precision)
RETURNS double precision AS $$
SELECT avg(v) FROM unnest($1) g(v) where v > $2 + .01
$$ LANGUAGE sql;

CREATE OR REPLACE FUNCTION array_cnt(double precision[],numeric)
RETURNS numeric AS $$
SELECT sum(1)::numeric FROM unnest($1) g(v) where v > $2 + .01
$$ LANGUAGE sql;

CREATE OR REPLACE FUNCTION array_distinct_cnt(text[])
RETURNS numeric AS $$
SELECT count(distinct v)::numeric FROM unnest($1) g(v)
$$ LANGUAGE sql;

CREATE OR REPLACE FUNCTION array_distinct(text[])
RETURNS text[] AS $$
SELECT array_agg(distinct v::text) FROM unnest($1) g(v)
$$ LANGUAGE sql;

CREATE OR REPLACE FUNCTION ronzo(text[])
RETURNS numeric AS $$
SELECT count(distinct v)::numeric FROM unnest($1) g(v)
$$ LANGUAGE sql;


CREATE or replace FUNCTION round_minutes(TIMESTAMP WITHOUT TIME ZONE, integer)
RETURNS TIMESTAMP WITHOUT TIME ZONE AS $$
  SELECT date_trunc('hour', ($1 -
                    cast((((cast($2 as float) / 2) * 60)::varchar||' seconds') as interval)
                    ))
         + cast(($2::varchar||' min') as interval) * ABS(round(date_part('minute',($1 -
                    cast((((cast($2 as float) / 2) * 60)::varchar||' seconds') as interval)
                    ))::float / cast($2 as float)))
$$ LANGUAGE SQL;

