drop table if exists tnt_config.win7_apps;

CREATE TABLE IF NOT EXISTS tnt_config.win7_apps (
    id integer NOT NULL,
    app_name character varying(255) DEFAULT ''::character varying NOT NULL,
    major_version character varying(255) DEFAULT ''::character varying NOT NULL,
    minor_version character varying(255) DEFAULT ''::character varying NOT NULL,
    company_name character varying(255) DEFAULT ''::character varying NOT NULL,
    home_page character varying(255) DEFAULT ''::character varying NOT NULL,
    updated timestamp without time zone,
    compatable_32bit character varying(255) DEFAULT ''::character varying NOT NULL,
    compatable_64bit character varying(255) DEFAULT ''::character varying NOT NULL,
    lower_app_name character varying(255) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE tnt_config.win7_apps OWNER TO postgres;

--
-- Name: win7_apps_id_seq; Type: SEQUENCE; Schema: tnt_config; Owner: postgres
--

drop sequence if exists tnt_config.win7_apps_id_seq;

CREATE SEQUENCE tnt_config.win7_apps_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE tnt_config.win7_apps_id_seq OWNER TO postgres;

--
-- Name: win7_apps_id_seq; Type: SEQUENCE OWNED BY; Schema: tnt_config; Owner: postgres
--

ALTER SEQUENCE tnt_config.win7_apps_id_seq OWNED BY tnt_config.win7_apps.id;


--
-- Name: win7_apps_id_seq; Type: SEQUENCE SET; Schema: tnt_config; Owner: postgres
--

SELECT pg_catalog.setval('tnt_config.win7_apps_id_seq', 164790, true);


--
-- Name: id; Type: DEFAULT; Schema: tnt_config; Owner: postgres
--

ALTER TABLE tnt_config.win7_apps ALTER COLUMN id SET DEFAULT nextval('tnt_config.win7_apps_id_seq'::regclass);

--
-- Name: win7_apps; Type: ACL; Schema: tnt_config; Owner: postgres
--

REVOKE ALL ON TABLE tnt_config.win7_apps FROM PUBLIC;
REVOKE ALL ON TABLE tnt_config.win7_apps FROM postgres;
GRANT ALL ON TABLE tnt_config.win7_apps TO postgres;
GRANT SELECT,INSERT,REFERENCES,DELETE,UPDATE ON TABLE tnt_config.win7_apps TO impadmin;
GRANT SELECT ON TABLE tnt_config.win7_apps TO reports;
