Create table "tnt_audit"."summaryreports_hourly"
(
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"cpu_peak_user" Double precision NOT NULL,
	"cpu_avg_user" Double precision NOT NULL,
	"cpu_total_user" Double precision NOT NULL,
	"cpu_min_user" Double precision NOT NULL,
	"cpu_peak_sys" Double precision NOT NULL,
	"cpu_avg_sys" Double precision NOT NULL,
	"cpu_total_sys" Double precision NOT NULL,
	"cpu_min_sys" Double precision NOT NULL,
	"mem_peak" Double precision NOT NULL,
	"mem_avg" Double precision NOT NULL,
	"mem_alloc" Double precision NOT NULL,
	"swap_peak" Double precision NOT NULL,
	"swap_avg" Double precision NOT NULL,
	"swap_alloc" Double precision NOT NULL,
	"avg_center_nrt" Real,
	"cpu_queue_peak" Double precision NOT NULL,
	"cpu_queue_min" Double precision NOT NULL,
	"cpu_queue_avg" Double precision NOT NULL,
	"vdi_fit_overall" Double precision NOT NULL,
	"vdi_fit_x" Double precision NOT NULL,
	"vdi_fit_y" Double precision NOT NULL,
	"vdi_ux_overall" Double precision NOT NULL,
	"vdi_ux_x" Double precision NOT NULL,
	"vdi_ux_y" Double precision NOT NULL,
	"inc_conn_count" Integer NOT NULL,
	"avg_inc_nrt" Real,
	"login_ids" Integer[],
	"cpu_cswitch_min" Double precision,
	"cpu_cswitch_peak" Double precision,
	"cpu_cswitch_avg" Double precision,
	"total_app_anr" Integer NOT NULL Default 0,
	"total_app_pf" Integer NOT NULL Default 0,
	"node_id" Integer NOT NULL,
	"sample_count" Integer,
	"cpu_avg_user_count" Integer,
	"cpu_avg_sys_count" Integer,
	"mem_avg_count" Integer,
	"mem_alloc_count" Integer,
	"swap_avg_count" Integer,
	"swap_alloc_count" Integer,
	"avg_center_nrt_count" Integer,
	"avg_inc_nrt_count" Integer,
	"cpu_queue_avg_count" Integer,
	"vdi_fit_overall_count" Integer,
	"vdi_fit_x_count" Integer,
	"vdi_fit_y_count" Integer,
	"vdi_ux_overall_count" Integer,
	"vdi_ux_x_count" Integer,
	"vdi_ux_y_count" Integer,
	"cpu_cswitch_avg_count" Integer
) Without Oids;

Create table "tnt_audit"."summaryreports_daily"
(
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"cpu_peak_user" Double precision NOT NULL,
	"cpu_avg_user" Double precision NOT NULL,
	"cpu_total_user" Double precision NOT NULL,
	"cpu_min_user" Double precision NOT NULL,
	"cpu_peak_sys" Double precision NOT NULL,
	"cpu_avg_sys" Double precision NOT NULL,
	"cpu_total_sys" Double precision NOT NULL,
	"cpu_min_sys" Double precision NOT NULL,
	"mem_peak" Double precision NOT NULL,
	"mem_avg" Double precision NOT NULL,
	"mem_alloc" Double precision NOT NULL,
	"swap_peak" Double precision NOT NULL,
	"swap_avg" Double precision NOT NULL,
	"swap_alloc" Double precision NOT NULL,
	"avg_center_nrt" Real,
	"cpu_queue_peak" Double precision NOT NULL,
	"cpu_queue_min" Double precision NOT NULL,
	"cpu_queue_avg" Double precision NOT NULL,
	"vdi_fit_overall" Double precision NOT NULL,
	"vdi_fit_x" Double precision NOT NULL,
	"vdi_fit_y" Double precision NOT NULL,
	"vdi_ux_overall" Double precision NOT NULL,
	"vdi_ux_x" Double precision NOT NULL,
	"vdi_ux_y" Double precision NOT NULL,
	"inc_conn_count" Integer NOT NULL,
	"avg_inc_nrt" Real,
	"login_ids" Integer[],
	"cpu_cswitch_min" Double precision,
	"cpu_cswitch_peak" Double precision,
	"cpu_cswitch_avg" Double precision,
	"total_app_anr" Integer NOT NULL Default 0,
	"total_app_pf" Integer NOT NULL Default 0,
	"node_id" Integer NOT NULL,
	"sample_count" Integer,
	"cpu_avg_user_count" Integer,
	"cpu_avg_sys_count" Integer,
	"mem_avg_count" Integer,
	"mem_alloc_count" Integer,
	"swap_avg_count" Integer,
	"swap_alloc_count" Integer,
	"avg_center_nrt_count" Integer,
	"avg_inc_nrt_count" Integer,
	"cpu_queue_avg_count" Integer,
	"vdi_fit_overall_count" Integer,
	"vdi_fit_x_count" Integer,
	"vdi_fit_y_count" Integer,
	"vdi_ux_overall_count" Integer,
	"vdi_ux_x_count" Integer,
	"vdi_ux_y_count" Integer,
	"cpu_cswitch_avg_count" Integer
) Without Oids;

Create table "tnt_audit"."summaryreports_weekly"
(
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"cpu_peak_user" Double precision NOT NULL,
	"cpu_avg_user" Double precision NOT NULL,
	"cpu_total_user" Double precision NOT NULL,
	"cpu_min_user" Double precision NOT NULL,
	"cpu_peak_sys" Double precision NOT NULL,
	"cpu_avg_sys" Double precision NOT NULL,
	"cpu_total_sys" Double precision NOT NULL,
	"cpu_min_sys" Double precision NOT NULL,
	"mem_peak" Double precision NOT NULL,
	"mem_avg" Double precision NOT NULL,
	"mem_alloc" Double precision NOT NULL,
	"swap_peak" Double precision NOT NULL,
	"swap_avg" Double precision NOT NULL,
	"swap_alloc" Double precision NOT NULL,
	"avg_center_nrt" Real,
	"cpu_queue_peak" Double precision NOT NULL,
	"cpu_queue_min" Double precision NOT NULL,
	"cpu_queue_avg" Double precision NOT NULL,
	"vdi_fit_overall" Double precision NOT NULL,
	"vdi_fit_x" Double precision NOT NULL,
	"vdi_fit_y" Double precision NOT NULL,
	"vdi_ux_overall" Double precision NOT NULL,
	"vdi_ux_x" Double precision NOT NULL,
	"vdi_ux_y" Double precision NOT NULL,
	"inc_conn_count" Integer NOT NULL,
	"avg_inc_nrt" Real,
	"login_ids" Integer[],
	"cpu_cswitch_min" Double precision,
	"cpu_cswitch_peak" Double precision,
	"cpu_cswitch_avg" Double precision,
	"total_app_anr" Integer NOT NULL Default 0,
	"total_app_pf" Integer NOT NULL Default 0,
	"node_id" Integer NOT NULL,
	"sample_count" Integer,
	"cpu_avg_user_count" Integer,
	"cpu_avg_sys_count" Integer,
	"mem_avg_count" Integer,
	"mem_alloc_count" Integer,
	"swap_avg_count" Integer,
	"swap_alloc_count" Integer,
	"avg_center_nrt_count" Integer,
	"avg_inc_nrt_count" Integer,
	"cpu_queue_avg_count" Integer,
	"vdi_fit_overall_count" Integer,
	"vdi_fit_x_count" Integer,
	"vdi_fit_y_count" Integer,
	"vdi_ux_overall_count" Integer,
	"vdi_ux_x_count" Integer,
	"vdi_ux_y_count" Integer,
	"cpu_cswitch_avg_count" Integer
) Without Oids;

Create table "tnt_audit"."summaryreports_monthly"
(
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"cpu_peak_user" Double precision NOT NULL,
	"cpu_avg_user" Double precision NOT NULL,
	"cpu_total_user" Double precision NOT NULL,
	"cpu_min_user" Double precision NOT NULL,
	"cpu_peak_sys" Double precision NOT NULL,
	"cpu_avg_sys" Double precision NOT NULL,
	"cpu_total_sys" Double precision NOT NULL,
	"cpu_min_sys" Double precision NOT NULL,
	"mem_peak" Double precision NOT NULL,
	"mem_avg" Double precision NOT NULL,
	"mem_alloc" Double precision NOT NULL,
	"swap_peak" Double precision NOT NULL,
	"swap_avg" Double precision NOT NULL,
	"swap_alloc" Double precision NOT NULL,
	"avg_center_nrt" Real,
	"cpu_queue_peak" Double precision NOT NULL,
	"cpu_queue_min" Double precision NOT NULL,
	"cpu_queue_avg" Double precision NOT NULL,
	"vdi_fit_overall" Double precision NOT NULL,
	"vdi_fit_x" Double precision NOT NULL,
	"vdi_fit_y" Double precision NOT NULL,
	"vdi_ux_overall" Double precision NOT NULL,
	"vdi_ux_x" Double precision NOT NULL,
	"vdi_ux_y" Double precision NOT NULL,
	"inc_conn_count" Integer NOT NULL,
	"avg_inc_nrt" Real,
	"login_ids" Integer[],
	"cpu_cswitch_min" Double precision,
	"cpu_cswitch_peak" Double precision,
	"cpu_cswitch_avg" Double precision,
	"total_app_anr" Integer NOT NULL Default 0,
	"total_app_pf" Integer NOT NULL Default 0,
	"node_id" Integer NOT NULL,
	"sample_count" Integer,
	"cpu_avg_user_count" Integer,
	"cpu_avg_sys_count" Integer,
	"mem_avg_count" Integer,
	"mem_alloc_count" Integer,
	"swap_avg_count" Integer,
	"swap_alloc_count" Integer,
	"avg_center_nrt_count" Integer,
	"avg_inc_nrt_count" Integer,
	"cpu_queue_avg_count" Integer,
	"vdi_fit_overall_count" Integer,
	"vdi_fit_x_count" Integer,
	"vdi_fit_y_count" Integer,
	"vdi_ux_overall_count" Integer,
	"vdi_ux_x_count" Integer,
	"vdi_ux_y_count" Integer,
	"cpu_cswitch_avg_count" Integer
) Without Oids;


Grant select on "tnt_audit"."summaryreports_hourly" to "impadmin";
Grant update on "tnt_audit"."summaryreports_hourly" to "impadmin";
Grant delete on "tnt_audit"."summaryreports_hourly" to "impadmin";
Grant insert on "tnt_audit"."summaryreports_hourly" to "impadmin";
Grant references on "tnt_audit"."summaryreports_hourly" to "impadmin";
Grant select on "tnt_audit"."summaryreports_hourly" to "reports";
alter table tnt_audit.summaryreports_hourly owner to impadmin;

Grant select on "tnt_audit"."summaryreports_daily" to "impadmin";
Grant update on "tnt_audit"."summaryreports_daily" to "impadmin";
Grant delete on "tnt_audit"."summaryreports_daily" to "impadmin";
Grant insert on "tnt_audit"."summaryreports_daily" to "impadmin";
Grant references on "tnt_audit"."summaryreports_daily" to "impadmin";
Grant select on "tnt_audit"."summaryreports_daily" to "reports";
alter table tnt_audit.summaryreports_daily owner to impadmin;

Grant select on "tnt_audit"."summaryreports_weekly" to "impadmin";
Grant update on "tnt_audit"."summaryreports_weekly" to "impadmin";
Grant delete on "tnt_audit"."summaryreports_weekly" to "impadmin";
Grant insert on "tnt_audit"."summaryreports_weekly" to "impadmin";
Grant references on "tnt_audit"."summaryreports_weekly" to "impadmin";
Grant select on "tnt_audit"."summaryreports_weekly" to "reports";
alter table tnt_audit.summaryreports_weekly owner to impadmin;

Grant select on "tnt_audit"."summaryreports_monthly" to "impadmin";
Grant update on "tnt_audit"."summaryreports_monthly" to "impadmin";
Grant delete on "tnt_audit"."summaryreports_monthly" to "impadmin";
Grant insert on "tnt_audit"."summaryreports_monthly" to "impadmin";
Grant references on "tnt_audit"."summaryreports_monthly" to "impadmin";
Grant select on "tnt_audit"."summaryreports_monthly" to "reports";
alter table tnt_audit.summaryreports_monthly owner to impadmin;
