Create table "tnt_audit"."summaryreport_process_stats_hourly"
(
	"name" Text NOT NULL,
	"mem_peak" Double precision NOT NULL,
	"mem_avg" Double precision NOT NULL,
	"cpu_avg_user" Double precision NOT NULL,
	"cpu_peak_user" Double precision NOT NULL,
	"cpu_total_user" Double precision NOT NULL,
	"cpu_min_user" Double precision NOT NULL,
	"cpu_avg_sys" Double precision NOT NULL,
	"cpu_peak_sys" Double precision NOT NULL,
	"cpu_total_sys" Double precision NOT NULL,
	"cpu_min_sys" Double precision NOT NULL,
	"io_avg" Double precision NOT NULL,
	"io_peak" Double precision NOT NULL,
	"pf_avg" Double precision NOT NULL,
	"pf_peak" Double precision NOT NULL,
	"launch_delay_ms" Integer,
	"owner_name" Text,
	"node_id" Integer NOT NULL,
	"owner_id" Integer,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"graph_avg" Double precision,
	"graph_peak" Double precision,
	"graph_min" Double precision,
	"os_id" Integer,
	"desk_app_id" Integer,
	"non_responsive_count" Integer NOT NULL Default 0,
	"secs_active" Integer,
	"mem_avg_count" Integer,
	"cpu_avg_user_count" Integer,
	"cpu_avg_sys_count" Integer,
	"io_avg_count" Integer,
	"pf_avg_count" Integer,
	"launch_delay_ms_count" Integer,
	"sample_count" Integer,
	"graph_avg_count" Integer,
	"first_record" Boolean NOT NULL Default false
) Without Oids;

Create table "tnt_audit"."summaryreport_process_stats_daily"
(
	"name" Text NOT NULL,
	"mem_peak" Double precision NOT NULL,
	"mem_avg" Double precision NOT NULL,
	"cpu_avg_user" Double precision NOT NULL,
	"cpu_peak_user" Double precision NOT NULL,
	"cpu_total_user" Double precision NOT NULL,
	"cpu_min_user" Double precision NOT NULL,
	"cpu_avg_sys" Double precision NOT NULL,
	"cpu_peak_sys" Double precision NOT NULL,
	"cpu_total_sys" Double precision NOT NULL,
	"cpu_min_sys" Double precision NOT NULL,
	"io_avg" Double precision NOT NULL,
	"io_peak" Double precision NOT NULL,
	"pf_avg" Double precision NOT NULL,
	"pf_peak" Double precision NOT NULL,
	"launch_delay_ms" Integer,
	"owner_name" Text,
	"node_id" Integer NOT NULL,
	"owner_id" Integer,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"graph_avg" Double precision,
	"graph_peak" Double precision,
	"graph_min" Double precision,
	"os_id" Integer,
	"desk_app_id" Integer,
	"non_responsive_count" Integer NOT NULL Default 0,
	"secs_active" Integer,
	"mem_avg_count" Integer,
	"cpu_avg_user_count" Integer,
	"cpu_avg_sys_count" Integer,
	"io_avg_count" Integer,
	"pf_avg_count" Integer,
	"launch_delay_ms_count" Integer,
	"sample_count" Integer,
	"graph_avg_count" Integer,
	"first_record" Boolean NOT NULL Default false
) Without Oids;

Create table "tnt_audit"."summaryreport_process_stats_weekly"
(
	"name" Text NOT NULL,
	"mem_peak" Double precision NOT NULL,
	"mem_avg" Double precision NOT NULL,
	"cpu_avg_user" Double precision NOT NULL,
	"cpu_peak_user" Double precision NOT NULL,
	"cpu_total_user" Double precision NOT NULL,
	"cpu_min_user" Double precision NOT NULL,
	"cpu_avg_sys" Double precision NOT NULL,
	"cpu_peak_sys" Double precision NOT NULL,
	"cpu_total_sys" Double precision NOT NULL,
	"cpu_min_sys" Double precision NOT NULL,
	"io_avg" Double precision NOT NULL,
	"io_peak" Double precision NOT NULL,
	"pf_avg" Double precision NOT NULL,
	"pf_peak" Double precision NOT NULL,
	"launch_delay_ms" Integer,
	"owner_name" Text,
	"node_id" Integer NOT NULL,
	"owner_id" Integer,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"graph_avg" Double precision,
	"graph_peak" Double precision,
	"graph_min" Double precision,
	"os_id" Integer,
	"desk_app_id" Integer,
	"non_responsive_count" Integer NOT NULL Default 0,
	"secs_active" Integer,
	"mem_avg_count" Integer,
	"cpu_avg_user_count" Integer,
	"cpu_avg_sys_count" Integer,
	"io_avg_count" Integer,
	"pf_avg_count" Integer,
	"launch_delay_ms_count" Integer,
	"sample_count" Integer,
	"graph_avg_count" Integer,
	"first_record" Boolean NOT NULL Default false
) Without Oids;

Create table "tnt_audit"."summaryreport_process_stats_monthly"
(
	"name" Text NOT NULL,
	"mem_peak" Double precision NOT NULL,
	"mem_avg" Double precision NOT NULL,
	"cpu_avg_user" Double precision NOT NULL,
	"cpu_peak_user" Double precision NOT NULL,
	"cpu_total_user" Double precision NOT NULL,
	"cpu_min_user" Double precision NOT NULL,
	"cpu_avg_sys" Double precision NOT NULL,
	"cpu_peak_sys" Double precision NOT NULL,
	"cpu_total_sys" Double precision NOT NULL,
	"cpu_min_sys" Double precision NOT NULL,
	"io_avg" Double precision NOT NULL,
	"io_peak" Double precision NOT NULL,
	"pf_avg" Double precision NOT NULL,
	"pf_peak" Double precision NOT NULL,
	"launch_delay_ms" Integer,
	"owner_name" Text,
	"node_id" Integer NOT NULL,
	"owner_id" Integer,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"graph_avg" Double precision,
	"graph_peak" Double precision,
	"graph_min" Double precision,
	"os_id" Integer,
	"desk_app_id" Integer,
	"non_responsive_count" Integer NOT NULL Default 0,
	"secs_active" Integer,
	"mem_avg_count" Integer,
	"cpu_avg_user_count" Integer,
	"cpu_avg_sys_count" Integer,
	"io_avg_count" Integer,
	"pf_avg_count" Integer,
	"launch_delay_ms_count" Integer,
	"sample_count" Integer,
	"graph_avg_count" Integer,
	"first_record" Boolean NOT NULL Default false
) Without Oids;


Grant select on "tnt_audit"."summaryreport_process_stats_hourly" to "impadmin";
Grant update on "tnt_audit"."summaryreport_process_stats_hourly" to "impadmin";
Grant delete on "tnt_audit"."summaryreport_process_stats_hourly" to "impadmin";
Grant insert on "tnt_audit"."summaryreport_process_stats_hourly" to "impadmin";
Grant references on "tnt_audit"."summaryreport_process_stats_hourly" to "impadmin";
Grant select on "tnt_audit"."summaryreport_process_stats_hourly" to "reports";
alter table tnt_audit.summaryreport_process_stats_hourly owner to impadmin;

Grant select on "tnt_audit"."summaryreport_process_stats_daily" to "impadmin";
Grant update on "tnt_audit"."summaryreport_process_stats_daily" to "impadmin";
Grant delete on "tnt_audit"."summaryreport_process_stats_daily" to "impadmin";
Grant insert on "tnt_audit"."summaryreport_process_stats_daily" to "impadmin";
Grant references on "tnt_audit"."summaryreport_process_stats_daily" to "impadmin";
Grant select on "tnt_audit"."summaryreport_process_stats_daily" to "reports";
alter table tnt_audit.summaryreport_process_stats_daily owner to impadmin;

Grant select on "tnt_audit"."summaryreport_process_stats_weekly" to "impadmin";
Grant update on "tnt_audit"."summaryreport_process_stats_weekly" to "impadmin";
Grant delete on "tnt_audit"."summaryreport_process_stats_weekly" to "impadmin";
Grant insert on "tnt_audit"."summaryreport_process_stats_weekly" to "impadmin";
Grant references on "tnt_audit"."summaryreport_process_stats_weekly" to "impadmin";
Grant select on "tnt_audit"."summaryreport_process_stats_weekly" to "reports";
alter table tnt_audit.summaryreport_process_stats_weekly owner to impadmin;

Grant select on "tnt_audit"."summaryreport_process_stats_monthly" to "impadmin";
Grant update on "tnt_audit"."summaryreport_process_stats_monthly" to "impadmin";
Grant delete on "tnt_audit"."summaryreport_process_stats_monthly" to "impadmin";
Grant insert on "tnt_audit"."summaryreport_process_stats_monthly" to "impadmin";
Grant references on "tnt_audit"."summaryreport_process_stats_monthly" to "impadmin";
Grant select on "tnt_audit"."summaryreport_process_stats_monthly" to "reports";
alter table tnt_audit.summaryreport_process_stats_monthly owner to impadmin;
