Create table "tnt_audit"."summaryreport_partition_stats_hourly"
(
	"name" Text NOT NULL,
	"read_total" Double precision NOT NULL,
	"read_avg" Double precision NOT NULL,
	"read_peak" Double precision NOT NULL,
	"write_total" Double precision NOT NULL,
	"write_avg" Double precision NOT NULL,
	"write_peak" Double precision NOT NULL,
	"read_io_avg" Double precision NOT NULL,
	"read_io_peak" Double precision NOT NULL,
	"write_io_avg" Double precision NOT NULL,
	"write_io_peak" Double precision NOT NULL,
	"size" Double precision NOT NULL,
	"avg_used" Double precision NOT NULL,
	"peak_used" Double precision NOT NULL,
	"disk_id" Integer NOT NULL,
	"node_id" Integer NOT NULL,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"vdisk_id" Integer,
	"vdisk_datastoreid" Integer,
	"vdisk_node_id" Integer,
	"is_network" Boolean NOT NULL,
	"queue_min" Double precision NOT NULL,
	"queue_peak" Double precision NOT NULL,
	"queue_avg" Double precision NOT NULL,
	"read_min" Double precision NOT NULL,
	"write_min" Double precision NOT NULL,
	"read_avg_count" Integer,
	"write_avg_count" Integer,
	"read_io_avg_count" Integer,
	"write_io_avg_count" Integer,
	"sample_count" Integer,
	"size_count" Integer,
	"avg_used_count" Integer,
	"queue_avg_count" Integer
) Without Oids;

Create table "tnt_audit"."summaryreport_partition_stats_daily"
(
	"name" Text NOT NULL,
	"read_total" Double precision NOT NULL,
	"read_avg" Double precision NOT NULL,
	"read_peak" Double precision NOT NULL,
	"write_total" Double precision NOT NULL,
	"write_avg" Double precision NOT NULL,
	"write_peak" Double precision NOT NULL,
	"read_io_avg" Double precision NOT NULL,
	"read_io_peak" Double precision NOT NULL,
	"write_io_avg" Double precision NOT NULL,
	"write_io_peak" Double precision NOT NULL,
	"size" Double precision NOT NULL,
	"avg_used" Double precision NOT NULL,
	"peak_used" Double precision NOT NULL,
	"disk_id" Integer NOT NULL,
	"node_id" Integer NOT NULL,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"vdisk_id" Integer,
	"vdisk_datastoreid" Integer,
	"vdisk_node_id" Integer,
	"is_network" Boolean NOT NULL,
	"queue_min" Double precision NOT NULL,
	"queue_peak" Double precision NOT NULL,
	"queue_avg" Double precision NOT NULL,
	"read_min" Double precision NOT NULL,
	"write_min" Double precision NOT NULL,
	"read_avg_count" Integer,
	"write_avg_count" Integer,
	"read_io_avg_count" Integer,
	"write_io_avg_count" Integer,
	"sample_count" Integer,
	"size_count" Integer,
	"avg_used_count" Integer,
	"queue_avg_count" Integer
) Without Oids;

Create table "tnt_audit"."summaryreport_partition_stats_weekly"
(
	"name" Text NOT NULL,
	"read_total" Double precision NOT NULL,
	"read_avg" Double precision NOT NULL,
	"read_peak" Double precision NOT NULL,
	"write_total" Double precision NOT NULL,
	"write_avg" Double precision NOT NULL,
	"write_peak" Double precision NOT NULL,
	"read_io_avg" Double precision NOT NULL,
	"read_io_peak" Double precision NOT NULL,
	"write_io_avg" Double precision NOT NULL,
	"write_io_peak" Double precision NOT NULL,
	"size" Double precision NOT NULL,
	"avg_used" Double precision NOT NULL,
	"peak_used" Double precision NOT NULL,
	"disk_id" Integer NOT NULL,
	"node_id" Integer NOT NULL,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"vdisk_id" Integer,
	"vdisk_datastoreid" Integer,
	"vdisk_node_id" Integer,
	"is_network" Boolean NOT NULL,
	"queue_min" Double precision NOT NULL,
	"queue_peak" Double precision NOT NULL,
	"queue_avg" Double precision NOT NULL,
	"read_min" Double precision NOT NULL,
	"write_min" Double precision NOT NULL,
	"read_avg_count" Integer,
	"write_avg_count" Integer,
	"read_io_avg_count" Integer,
	"write_io_avg_count" Integer,
	"sample_count" Integer,
	"size_count" Integer,
	"avg_used_count" Integer,
	"queue_avg_count" Integer
) Without Oids;

Create table "tnt_audit"."summaryreport_partition_stats_monthly"
(
	"name" Text NOT NULL,
	"read_total" Double precision NOT NULL,
	"read_avg" Double precision NOT NULL,
	"read_peak" Double precision NOT NULL,
	"write_total" Double precision NOT NULL,
	"write_avg" Double precision NOT NULL,
	"write_peak" Double precision NOT NULL,
	"read_io_avg" Double precision NOT NULL,
	"read_io_peak" Double precision NOT NULL,
	"write_io_avg" Double precision NOT NULL,
	"write_io_peak" Double precision NOT NULL,
	"size" Double precision NOT NULL,
	"avg_used" Double precision NOT NULL,
	"peak_used" Double precision NOT NULL,
	"disk_id" Integer NOT NULL,
	"node_id" Integer NOT NULL,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"vdisk_id" Integer,
	"vdisk_datastoreid" Integer,
	"vdisk_node_id" Integer,
	"is_network" Boolean NOT NULL,
	"queue_min" Double precision NOT NULL,
	"queue_peak" Double precision NOT NULL,
	"queue_avg" Double precision NOT NULL,
	"read_min" Double precision NOT NULL,
	"write_min" Double precision NOT NULL,
	"read_avg_count" Integer,
	"write_avg_count" Integer,
	"read_io_avg_count" Integer,
	"write_io_avg_count" Integer,
	"sample_count" Integer,
	"size_count" Integer,
	"avg_used_count" Integer,
	"queue_avg_count" Integer
) Without Oids;

Grant select on "tnt_audit"."summaryreport_partition_stats_hourly" to "impadmin";
Grant update on "tnt_audit"."summaryreport_partition_stats_hourly" to "impadmin";
Grant delete on "tnt_audit"."summaryreport_partition_stats_hourly" to "impadmin";
Grant insert on "tnt_audit"."summaryreport_partition_stats_hourly" to "impadmin";
Grant references on "tnt_audit"."summaryreport_partition_stats_hourly" to "impadmin";
Grant select on "tnt_audit"."summaryreport_partition_stats_hourly" to "reports";
alter table tnt_audit.summaryreport_partition_stats_hourly owner to impadmin;

Grant select on "tnt_audit"."summaryreport_partition_stats_daily" to "impadmin";
Grant update on "tnt_audit"."summaryreport_partition_stats_daily" to "impadmin";
Grant delete on "tnt_audit"."summaryreport_partition_stats_daily" to "impadmin";
Grant insert on "tnt_audit"."summaryreport_partition_stats_daily" to "impadmin";
Grant references on "tnt_audit"."summaryreport_partition_stats_daily" to "impadmin";
Grant select on "tnt_audit"."summaryreport_partition_stats_daily" to "reports";
alter table tnt_audit.summaryreport_partition_stats_daily owner to impadmin;

Grant select on "tnt_audit"."summaryreport_partition_stats_weekly" to "impadmin";
Grant update on "tnt_audit"."summaryreport_partition_stats_weekly" to "impadmin";
Grant delete on "tnt_audit"."summaryreport_partition_stats_weekly" to "impadmin";
Grant insert on "tnt_audit"."summaryreport_partition_stats_weekly" to "impadmin";
Grant references on "tnt_audit"."summaryreport_partition_stats_weekly" to "impadmin";
Grant select on "tnt_audit"."summaryreport_partition_stats_weekly" to "reports";
alter table tnt_audit.summaryreport_partition_stats_weekly owner to impadmin;

Grant select on "tnt_audit"."summaryreport_partition_stats_monthly" to "impadmin";
Grant update on "tnt_audit"."summaryreport_partition_stats_monthly" to "impadmin";
Grant delete on "tnt_audit"."summaryreport_partition_stats_monthly" to "impadmin";
Grant insert on "tnt_audit"."summaryreport_partition_stats_monthly" to "impadmin";
Grant references on "tnt_audit"."summaryreport_partition_stats_monthly" to "impadmin";
Grant select on "tnt_audit"."summaryreport_partition_stats_monthly" to "reports";
alter table tnt_audit.summaryreport_partition_stats_monthly owner to impadmin;
