Create table "tnt_audit"."summaryreport_nic_stats_hourly"
(
	"node_id" Integer NOT NULL,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"name" Text NOT NULL,
	"speed" Integer,
	"bw_percent" Double precision,
	"send_total" Double precision,
	"send_avg" Double precision,
	"send_rate" Double precision,
	"send_peak" Double precision,
	"send_min" Double precision,
	"receive_total" Double precision,
	"receive_avg" Double precision,
	"receive_rate" Double precision,
	"receive_peak" Double precision,
	"receive_min" Double precision,
	"bw_percent_count" Integer,
	"send_avg_count" Integer,
	"receive_avg_count" Integer,
	"send_rate_count" Integer,
	"receive_rate_count" Integer,
	"sample_count" Integer
) Without Oids;


Create table "tnt_audit"."summaryreport_nic_stats_daily"
(
	"node_id" Integer NOT NULL,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"name" Text NOT NULL,
	"speed" Integer,
	"bw_percent" Double precision,
	"send_total" Double precision,
	"send_avg" Double precision,
	"send_rate" Double precision,
	"send_peak" Double precision,
	"send_min" Double precision,
	"receive_total" Double precision,
	"receive_avg" Double precision,
	"receive_rate" Double precision,
	"receive_peak" Double precision,
	"receive_min" Double precision,
	"bw_percent_count" Integer,
	"send_avg_count" Integer,
	"receive_avg_count" Integer,
	"send_rate_count" Integer,
	"receive_rate_count" Integer,
	"sample_count" Integer
) Without Oids;


Create table "tnt_audit"."summaryreport_nic_stats_weekly"
(
	"node_id" Integer NOT NULL,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"name" Text NOT NULL,
	"speed" Integer,
	"bw_percent" Double precision,
	"send_total" Double precision,
	"send_avg" Double precision,
	"send_rate" Double precision,
	"send_peak" Double precision,
	"send_min" Double precision,
	"receive_total" Double precision,
	"receive_avg" Double precision,
	"receive_rate" Double precision,
	"receive_peak" Double precision,
	"receive_min" Double precision,
	"bw_percent_count" Integer,
	"send_avg_count" Integer,
	"receive_avg_count" Integer,
	"send_rate_count" Integer,
	"receive_rate_count" Integer,
	"sample_count" Integer
) Without Oids;


Create table "tnt_audit"."summaryreport_nic_stats_monthly"
(
	"node_id" Integer NOT NULL,
	"start_date" Timestamp NOT NULL,
	"end_date" Timestamp NOT NULL,
	"name" Text NOT NULL,
	"speed" Integer,
	"bw_percent" Double precision,
	"send_total" Double precision,
	"send_avg" Double precision,
	"send_rate" Double precision,
	"send_peak" Double precision,
	"send_min" Double precision,
	"receive_total" Double precision,
	"receive_avg" Double precision,
	"receive_rate" Double precision,
	"receive_peak" Double precision,
	"receive_min" Double precision,
	"bw_percent_count" Integer,
	"send_avg_count" Integer,
	"receive_avg_count" Integer,
	"send_rate_count" Integer,
	"receive_rate_count" Integer,
	"sample_count" Integer
) Without Oids;


Grant select on "tnt_audit"."summaryreport_nic_stats_hourly" to "impadmin";
Grant update on "tnt_audit"."summaryreport_nic_stats_hourly" to "impadmin";
Grant delete on "tnt_audit"."summaryreport_nic_stats_hourly" to "impadmin";
Grant insert on "tnt_audit"."summaryreport_nic_stats_hourly" to "impadmin";
Grant references on "tnt_audit"."summaryreport_nic_stats_hourly" to "impadmin";
Grant select on "tnt_audit"."summaryreport_nic_stats_hourly" to "reports";
Grant select on "tnt_audit"."summaryreport_nic_stats_daily" to "impadmin";
Grant update on "tnt_audit"."summaryreport_nic_stats_daily" to "impadmin";
Grant delete on "tnt_audit"."summaryreport_nic_stats_daily" to "impadmin";
Grant insert on "tnt_audit"."summaryreport_nic_stats_daily" to "impadmin";
Grant references on "tnt_audit"."summaryreport_nic_stats_daily" to "impadmin";
Grant select on "tnt_audit"."summaryreport_nic_stats_daily" to "reports";
Grant select on "tnt_audit"."summaryreport_nic_stats_weekly" to "impadmin";
Grant update on "tnt_audit"."summaryreport_nic_stats_weekly" to "impadmin";
Grant delete on "tnt_audit"."summaryreport_nic_stats_weekly" to "impadmin";
Grant insert on "tnt_audit"."summaryreport_nic_stats_weekly" to "impadmin";
Grant references on "tnt_audit"."summaryreport_nic_stats_weekly" to "impadmin";
Grant select on "tnt_audit"."summaryreport_nic_stats_weekly" to "reports";
Grant select on "tnt_audit"."summaryreport_nic_stats_monthly" to "impadmin";
Grant update on "tnt_audit"."summaryreport_nic_stats_monthly" to "impadmin";
Grant delete on "tnt_audit"."summaryreport_nic_stats_monthly" to "impadmin";
Grant insert on "tnt_audit"."summaryreport_nic_stats_monthly" to "impadmin";
Grant references on "tnt_audit"."summaryreport_nic_stats_monthly" to "impadmin";
Grant select on "tnt_audit"."summaryreport_nic_stats_monthly" to "reports";

alter table tnt_audit.summaryreport_nic_stats_hourly owner to impadmin;
alter table tnt_audit.summaryreport_nic_stats_daily owner to impadmin;
alter table tnt_audit.summaryreport_nic_stats_weekly owner to impadmin;
alter table tnt_audit.summaryreport_nic_stats_monthly owner to impadmin;
