alter table tnt_config.desktop_app add status int not null default 0;
update tnt_config.desktop_app set status = 1 where is_patch = true;
alter table tnt_config.desktop_app drop column is_patch cascade; 

-- re-create views 
create view tnt_config.desktop_app_instance_details as
select da.*, count(distinct(na.node_id)) as node_count, 
avg(na.size) as avg_size, 
avg(na.svc_provided) as avg_svc_provided, 
avg(na.svc_required) as avg_svc_required, 
avg(na.drv_provided) as avg_drv_provided, 
min(na.install_date) as min_install_date, 
max(na.install_date) as max_install_date, 
min(na.minor_version_details) as minor_version_details 

from tnt_config.desktop_app da 

left outer join tnt_config.node_application na on 
(da.id = na.desktop_app_id) 
group by da.id, da.creation_time, da.name, da.process_names, 
da.app_version, da.description, da.version, da.type, 
da.parent_app_id, da.status;

/* Create Rules */
create or replace rule  desktop_app_instance_details_noop_update
AS ON UPDATE TO tnt_config.desktop_app_instance_details do instead
update tnt_config.desktop_app SET id=new.id where id=old.id;

Grant select on tnt_config.desktop_app_instance_details to "impadmin";
Grant update on tnt_config.desktop_app_instance_details to "impadmin";
Grant select on tnt_config.desktop_app_instance_details to "reports";

create or replace view lwl_query.desktop_app_inventory as
select

pmachine.name as machine_name,
machinegroup.name as machine_group,

desk_app.name as app_name,
desk_app.app_version as app_version,
app.install_date as install_date,
app.size / 1024 as install_size_mb,
app.svc_provided as number_services_installed,
app.svc_required as number_services_used,
app.drv_provided as number_drivers_installed,
desk_app.process_names as process_names

from tnt_config.policynode pmachine
left outer join tnt_config.nodegroup_node ngroup on (
        (pmachine.id = ngroup.nodeid)
        )

left outer join tnt_config.policynode machinegroup on (
        (ngroup.nodegroupid = machinegroup.id)
        )

join tnt_config.node_application app on
	(pmachine.id = app.node_id
	)

join tnt_config.desktop_app desk_app on
	(app.desktop_app_id = desk_app.id and ((desk_app.status & 1) = 0)
	)

;

Grant select on lwl_query.desktop_app_inventory to "query";
