drop view tnt_config.desktop_app_instance_details;

create or replace view tnt_config.desktop_app_instance_details as
SELECT da.id, da.parent_app_id, da.creation_time, da.name, da.process_names, da.app_version, da.description, da.version, da.type, da.status, count(DISTINCT na.node_id) AS node_count, avg(na.size) AS avg_size, avg(na.svc_provided) AS avg_svc_provided, avg(na.svc_required) AS avg_svc_required, avg(na.drv_provided) AS avg_drv_provided, min(na.install_date) AS min_install_date, max(na.install_date) AS max_install_date, min(na.minor_version_details) AS minor_version_details,
((da.status & 1) = 1) as is_patch,
((da.status & 2) = 2) as system_app,
((da.status & 4) = 4) as installs_shell_extensions,
((da.status & 8) = 8) as uses_dcom,
((da.status & 16) = 16) as include_for_virtualization
   FROM tnt_config.desktop_app da
   LEFT JOIN tnt_config.node_application na ON da.id = na.desktop_app_id
  GROUP BY da.id, da.creation_time, da.name, da.process_names, da.app_version, da.description, da.version, da.type, da.parent_app_id, da.status;

Grant select on tnt_config.desktop_app_instance_details to "impadmin";
Grant select on tnt_config.desktop_app_instance_details to "reports";
