create table tnt_audit.openconnections (updateid bigserial primary key, last_update timestamp without time zone default now(), update_count int default 1) inherits (tnt_audit.connectattempt);
-- standard indexes for reporting
create index openconnections_dst_ip ON tnt_audit.openconnections (dst_ip);
create index openconnections_dst_port_protocol on tnt_audit.openconnections (dst_port_icmp_code, protocol);
create index openconnections_packet_time on tnt_audit.openconnections (packet_time);
create index openconnections_src_sid_ip on tnt_audit.openconnections (src_sid, src_ip, protocol);
create index openconnections_src_uid on tnt_audit.openconnections (src_uid);
create index openconnections_status on tnt_audit.openconnections (status);
-- special index for us to find records to interval updating
create index openconnections_interval_update on tnt_audit.openconnections (packet_time, src_ip, src_port_icmp_type, dst_ip, dst_port_icmp_code, stationid, realm, status);

-- grant
Grant select on "tnt_audit"."openconnections" to "impadmin";
Grant update on "tnt_audit"."openconnections" to "impadmin";
Grant delete on "tnt_audit"."openconnections" to "impadmin";
Grant insert on "tnt_audit"."openconnections" to "impadmin";
Grant references on "tnt_audit"."openconnections" to "impadmin";
Grant select on "tnt_audit"."openconnections" to "reports";
grant all on tnt_audit.openconnections_updateid_seq to impadmin;
