Create table "tnt_config"."policyapplication"
(
	"id" Integer NOT NULL,
	"creation_time" Timestamp with time zone NOT NULL,
	"update_time" Timestamp with time zone,
	"delete_time" Timestamp with time zone,
	"name" Char(256) NOT NULL,
	"type" Integer NOT NULL Default 1,
	"version" Integer,
 primary key ("id")
) Without Oids;

Alter Table "tnt_config"."policyapplication" add UNIQUE ("id");

Create table "tnt_config"."applicationgroup"
(
	"description" Char(256),
	"id" Integer NOT NULL,
 primary key ("id")
) Without Oids;


Create table "tnt_config"."applicationgroup_application"
(
	"applicationgroupid" Integer NOT NULL,
	"applicationid" Integer NOT NULL,
 primary key ("applicationgroupid","applicationid")
) Without Oids;

Create index "policyapplication_type_idx" on "tnt_config"."policyapplication" using btree ("type");
Create index "policyapplication_name_idx" on "tnt_config"."policyapplication" using btree ("name");

Alter table "tnt_config"."applicationgroup" add  foreign key ("id") references "tnt_config"."policyapplication" ("id") on update restrict on delete cascade;
Alter table "tnt_config"."applicationgroup_application" add  foreign key ("applicationid") references "tnt_config"."policyapplication" ("id") on update restrict on delete cascade;
Alter table "tnt_config"."applicationgroup_application" add  foreign key ("applicationgroupid") references "tnt_config"."applicationgroup" ("id") on update restrict on delete cascade;

Grant select on "tnt_audit"."openconnections" to "impadmin";
Grant update on "tnt_audit"."openconnections" to "impadmin";
Grant delete on "tnt_audit"."openconnections" to "impadmin";
Grant insert on "tnt_audit"."openconnections" to "impadmin";
Grant references on "tnt_audit"."openconnections" to "impadmin";
Grant select on "tnt_audit"."openconnections" to "reports";
Grant select on "tnt_config"."policyapplication" to "impadmin";
Grant update on "tnt_config"."policyapplication" to "impadmin";
Grant delete on "tnt_config"."policyapplication" to "impadmin";
Grant insert on "tnt_config"."policyapplication" to "impadmin";
Grant references on "tnt_config"."policyapplication" to "impadmin";
Grant select on "tnt_config"."policyapplication" to "reports";
Grant select on "tnt_config"."applicationgroup" to "impadmin";
Grant update on "tnt_config"."applicationgroup" to "impadmin";
Grant delete on "tnt_config"."applicationgroup" to "impadmin";
Grant insert on "tnt_config"."applicationgroup" to "impadmin";
Grant references on "tnt_config"."applicationgroup" to "impadmin";
Grant select on "tnt_config"."applicationgroup" to "reports";
Grant select on "tnt_config"."applicationgroup_application" to "impadmin";
Grant update on "tnt_config"."applicationgroup_application" to "impadmin";
Grant delete on "tnt_config"."applicationgroup_application" to "impadmin";
Grant insert on "tnt_config"."applicationgroup_application" to "impadmin";
Grant references on "tnt_config"."applicationgroup_application" to "impadmin";
Grant select on "tnt_config"."applicationgroup_application" to "reports";

Comment on table "tnt_config"."policyapplication" is 'Abstract application that can be referenced in policy\r\n\r\nTypes include: application and applicationgroup';
Comment on table "tnt_config"."applicationgroup" is 'application group';
Comment on table "tnt_config"."applicationgroup_application" is 'Application group memberships';
Comment on column "tnt_config"."policyapplication"."name" is 'Name of application or application group';
Comment on column "tnt_config"."policyapplication"."type" is 'Indicates if it is a single application or an application group\r\n1: Application\r\n2: Application Group';
Comment on column "tnt_config"."policyapplication"."version" is 'internal use: object version for persistence ';
Comment on column "tnt_config"."applicationgroup"."description" is 'Group description or notes';
Comment on column "tnt_config"."applicationgroup_application"."applicationgroupid" is 'Parent application group';
Comment on column "tnt_config"."applicationgroup_application"."applicationid" is 'Member application id';