Create table "tnt_config"."datastore"
(
	"id" Serial NOT NULL,
	"version" Integer,
	"system_object" boolean default false,
	"creation_time" Timestamp NOT NULL Default current_timestamp,
	"update_time" Timestamp,
	"import_time" Timestamp,
	"delete_time" Timestamp,
	"name" Text NOT NULL,
	"size" Bigint NOT NULL,
	"freespace" Bigint,
	"type" Text NOT NULL,
	"uri" Text NOT NULL,
 primary key ("id")
) Without Oids;

Create unique index "datastore_name_idx" on "tnt_config"."datastore" using btree ("name") where delete_time is null;

Grant select on "tnt_config"."datastore" to "impadmin";
Grant update on "tnt_config"."datastore" to "impadmin";
Grant delete on "tnt_config"."datastore" to "impadmin";
Grant insert on "tnt_config"."datastore" to "impadmin";
Grant references on "tnt_config"."datastore" to "impadmin";
Grant select on "tnt_config"."datastore" to "reports";
grant all on tnt_config.datastore_id_seq to impadmin;

Comment on table "tnt_config"."datastore" is 'datastore table';

Comment on column "tnt_config"."datastore"."id" is 'primary key id';
Comment on column "tnt_config"."datastore"."version" is 'hibernate versioning column';
Comment on column "tnt_config"."datastore"."size" is 'datastore size in bytes';
Comment on column "tnt_config"."datastore"."freespace" is 'freespace in bytes';
Comment on column "tnt_config"."datastore"."type" is 'datastore type';
Comment on column "tnt_config"."datastore"."uri" is 'datastore uri';
