Create table "tnt_config"."virtualdisk"
(
	"id" Serial NOT NULL,
	"datastoreid" Integer NOT NULL,
	"nodeid" Integer NOT NULL,
	"version" Integer NOT NULL Default 0,
	"index" Smallint NOT NULL Default 0,
	"capacity" Bigint NOT NULL,
	"datastore_filename" Text NOT NULL,
 primary key ("id","datastoreid","nodeid")
) Without Oids;

Alter table "tnt_config"."virtualdisk" add  foreign key ("nodeid") references "tnt_config"."node" ("id") on update cascade on delete cascade;

Alter table "tnt_config"."virtualdisk" add  foreign key ("datastoreid") references "tnt_config"."datastore" ("id") on update cascade on delete cascade;

Create index "virtualdisk_nodeid_idx" on "tnt_config"."virtualdisk" using btree ("nodeid");

Comment on table "tnt_config"."virtualdisk" is 'node fk';
Comment on column "tnt_config"."virtualdisk"."id" is 'primary id';
Comment on column "tnt_config"."virtualdisk"."version" is 'used for hibernate versioning';
Comment on column "tnt_config"."virtualdisk"."index" is 'index on the virtual machine - first disk index 0, etc';
Comment on column "tnt_config"."virtualdisk"."capacity" is 'capacity of the disk';
Comment on column "tnt_config"."virtualdisk"."datastore_filename" is 'filename of disk on datastore';

Grant select on "tnt_config"."virtualdisk" to "impadmin";
Grant update on "tnt_config"."virtualdisk" to "impadmin";
Grant delete on "tnt_config"."virtualdisk" to "impadmin";
Grant insert on "tnt_config"."virtualdisk" to "impadmin";
Grant references on "tnt_config"."virtualdisk" to "impadmin";
Grant select on "tnt_config"."virtualdisk" to "reports";
grant all on tnt_config.virtualdisk_id_seq to impadmin;
