Create table "tnt_config"."alerts"
(
	"id" Serial NOT NULL,
        "date" Timestamp NOT NULL Default current_timestamp,
        "category" Smallint NOT NULL,
        "type" Smallint NOT NULL,
        "message" Text NOT NULL,
        "report_url" Text
) Without Oids;

Create index "alerts_date_idx" on "tnt_config"."alerts" using btree ("date");

Grant select on "tnt_config"."alerts" to "impadmin";
Grant update on "tnt_config"."alerts" to "impadmin";
Grant delete on "tnt_config"."alerts" to "impadmin";
Grant insert on "tnt_config"."alerts" to "impadmin";
Grant references on "tnt_config"."alerts" to "impadmin";
Grant select on "tnt_config"."alerts" to "reports";
grant all on tnt_config.alerts_id_seq to impadmin;

Comment on column "tnt_config"."alerts"."date" is 'time of the alert';
Comment on column "tnt_config"."alerts"."category" is 'alert category enum index';
Comment on column "tnt_config"."alerts"."type" is 'alert type enum index';
Comment on column "tnt_config"."alerts"."message" is 'alert message';
Comment on column "tnt_config"."alerts"."report_url" is 'report url';

-- move alert log records to new table
 insert into tnt_config.alerts (date, category, type, message) select logtime, 0, 0, logmsg from tnt_config.log where logmsgclass = 5;
delete from tnt_config.log where logmsgclass = 5;
