Create table "tnt_config"."network_addresses"
(
	"network_id" Integer NOT NULL,
	"address_space" Varchar(18) NOT NULL
) Without Oids;

Create index "network_id_idx" on "tnt_config"."network_addresses" using btree ("network_id");

Alter table "tnt_config"."network_addresses" add  foreign key ("network_id") references "tnt_config"."network" ("id") on update restrict on delete cascade;

Grant select on "tnt_config"."network_addresses" to "impadmin";
Grant update on "tnt_config"."network_addresses" to "impadmin";
Grant delete on "tnt_config"."network_addresses" to "impadmin";
Grant insert on "tnt_config"."network_addresses" to "impadmin";
Grant references on "tnt_config"."network_addresses" to "impadmin";
Grant select on "tnt_config"."network_addresses" to "reports";

Comment on column "tnt_config"."network_addresses"."network_id" is 'network id fk';
Comment on column "tnt_config"."network_addresses"."address_space" is 'cidr';

-- move existing data
insert into tnt_config.network_addresses select id, addressspace from tnt_config.network;
alter table tnt_config.network drop addressspace;
