Create table "tnt_config"."vmhost"
(
	"id" Serial NOT NULL,
	"vmsid" Integer NOT NULL,
	"creation_time" Timestamp with time zone NOT NULL Default current_timestamp,
	"update_time" Timestamp with time zone,
	"delete_time" Timestamp with time zone,
	"import_time" Timestamp with time zone NOT NULL,
	"version" Integer NOT NULL Default 0,
	"name" Text NOT NULL,
	"vmid" Text NOT NULL,
 primary key ("id")
) Without Oids;

Alter table "tnt_config"."vmhost" add  foreign key ("vmsid") references "tnt_config"."virtualmanagementsystem" ("id") on update restrict on delete restrict;

Grant select on "tnt_config"."vmhost" to "impadmin";
Grant update on "tnt_config"."vmhost" to "impadmin";
Grant delete on "tnt_config"."vmhost" to "impadmin";
Grant insert on "tnt_config"."vmhost" to "impadmin";
Grant references on "tnt_config"."vmhost" to "impadmin";
Grant select on "tnt_config"."vmhost" to "reports";
grant all on tnt_config.vmhost_id_seq to impadmin;

Comment on column "tnt_config"."vmhost"."id" is 'primary id';
Comment on column "tnt_config"."vmhost"."creation_time" is 'creation time';
Comment on column "tnt_config"."vmhost"."update_time" is 'last update time';
Comment on column "tnt_config"."vmhost"."delete_time" is 'delete time';
Comment on column "tnt_config"."vmhost"."version" is 'used for hibernate versioning';
Comment on column "tnt_config"."vmhost"."name" is 'host name';
Comment on column "tnt_config"."vmhost"."vmid" is 'id used by the vms to identify host';

alter table tnt_config.node add "vmhost_id" Integer;

Alter table "tnt_config"."node" add  foreign key ("vmhost_id") references "tnt_config"."vmhost" ("id") on update restrict on delete restrict;
