alter table tnt_audit.hoststats add avg_swap_used_kb Real;
alter table tnt_audit.hoststats add avg_swap_used_percent Real;
alter table tnt_audit.hoststats add disk_read_count integer; 
alter table tnt_audit.hoststats add disk_write_count integer; 
alter table tnt_audit.hoststats add disk_read_iops real;
alter table tnt_audit.hoststats add disk_write_iops real;
alter table tnt_audit.hoststats add "avg_swapin_kbs" Real;
alter table tnt_audit.hoststats add "avg_swapout_kbs" Real;
alter table tnt_audit.hoststats add "avg_mem_balloon_kb" Real;


drop view lwl_query.host_performance;

create or replace view lwl_query.host_performance as
select

vmhost.name as host_name,

hstats.start_date as inspect_start_time_utc,
hstats.end_date as inspect_end_time_utc,

avg(hstats.num_vms) as avg_num_machines,

avg(hstats.avg_cpu_used_percent) as avg_cpu_used_percent,
avg(hstats.avg_vm_ready_time_ms) as avg_cpu_ready_per_vm_ms,
sum(hstats.total_vm_ready_time_ms) as total_cpu_ready_time_ms,
avg(hstats.avg_mem_used_percent) as avg_mem_used_percent,
avg(hstats.avg_disk_io_kbps) as avg_disk_io_kb_s,
avg(hstats.avg_disk_latency_ms) as avg_disk_latency_ms,
avg(hstats.avg_net_io_kbps) as avg_net_io_kb_s,
sum(hstats.total_packets_rx) as total_net_packets_rx,
sum(hstats.total_packets_tx) as total_net_packets_tx,
avg(hstats.avg_swap_used_kb) as avg_swap_used_kb,
sum(hstats.disk_read_count) as disk_read_count,
sum(hstats.disk_write_count) as disk_write_count,
avg(hstats.disk_read_iops) as avg_disk_read_iops,
avg(hstats.disk_write_iops) as avg_disk_write_iops,
avg(hstats.avg_swapin_kbs) as avg_swapin_kbs,
avg(hstats.avg_swapout_kbs) as avg_swapout_kbs,
avg(hstats.avg_mem_balloon_kb) as avg_mem_balloon_kb

from tnt_audit.hoststats hstats

join tnt_config.vmhost vmhost on (hstats.vmhost_id = vmhost.id)

group by host_name, inspect_start_time_utc, inspect_end_time_utc
;

Grant select on lwl_query.host_performance to "query";
