-- update legacy data to include desktop_app_ids
Create or Replace function "tnt_audit"."update_summaryreport_desktop_ids"()
Returns text As
$$
declare
        record_count bigint := 0;
        partition_name text;
        partition_date text;
        report_entry record;
begin
        for partition_name in 
                select tablename from pg_tables where schemaname = 'tnt_audit' and tablename ilike 'summaryreports_2%' 
                order by tablename asc
        loop
                select into partition_date split_part(partition_name, '_', 2);
                raise debug 'Processing partition %, date %', partition_name, partition_date;
                        for report_entry in execute 
                                'select node_id, start_date, end_date from tnt_audit.' || partition_name ||  ' where desktop_app_ids is null' loop
                                raise debug 'Updating desktop app ids for node = %, start = %, end = %', report_entry.node_id, report_entry.start_date, report_entry.end_date;
                                execute 'update tnt_audit.' || partition_name || ' set desktop_app_ids = (select array_agg(distinct(desk_app_id)) from tnt_audit.summaryreport_process_stats_' || partition_date || ' where node_id = ' || report_entry.node_id || ' and start_date = ''' || report_entry.start_date || ''' and end_date = ''' || report_entry.end_date || ''') where  node_id = ' || report_entry.node_id || ' and start_date = ''' || report_entry.start_date || ''' and end_date = ''' || report_entry.end_date || ''''; 
                                record_count := record_count + 1;
                        end loop;
        end loop;
        return record_count || ' records updated';
end;
$$
 Language 'plpgsql'
 Volatile 
 Called On Null Input
 Security invoker;

select tnt_audit.update_summaryreport_desktop_ids();
drop function tnt_audit.update_summaryreport_desktop_ids();
