
Create or Replace function "tnt_audit".Add_indexes(pSchemaName Text, pTable_Name TEXT, pColumn_Name TEXT)
Returns int As
' 
DECLARE
        count int;
        vTable record;
BEGIN
        raise warning ''Adding indexes in % partitions'',  pTable_Name;

        count := 0;
        FOR vTable in select schemaname, tablename from pg_tables where schemaname= pSchemaName and tablename like pTable_Name  LOOP
                raise warning ''Adding indexes in % partitions'', vTable.tablename;   
        execute ''DROP INDEX IF EXISTS ''||vTable.schemaname||''.'' || vTable.tablename ||''_''||pColumn_Name||''_idx'';               
        execute ''CREATE INDEX ''||vTable.tablename||''_''||pColumn_Name||''_idx ON ''||vTable.schemaname||''.'' || vTable.tablename ||'' USING 

BTREE''||''(''||pColumn_Name||'')'';  
                count := count+1;
        end loop; 
     return count; 
END;
' 
 Language 'plpgsql'
 Volatile
 Called On Null Input
 Security invoker;


 
 

--tnt_config.policynode
SELECT "tnt_audit".Add_indexes('tnt_config','policynode', 'id');
SELECT "tnt_audit".Add_indexes('tnt_config','policynode', 'delete_time');
SELECT "tnt_audit".Add_indexes('tnt_config','policynode', 'type');

--tnt_config.desktop_app  
SELECT "tnt_audit".Add_indexes('tnt_config','desktop_app', 'id');

--tnt_config.policyidentity 
SELECT "tnt_audit".Add_indexes('tnt_config','policyidentity', 'id');

--tnt_config.identitygroup_identity 
SELECT "tnt_audit".Add_indexes('tnt_config','identitygroup_identity', 'groupid');


--tnt_config.nodegroup_node 
SELECT "tnt_audit".Add_indexes('tnt_config','nodegroup_node', 'nodegroupid');
SELECT "tnt_audit".Add_indexes('tnt_config','nodegroup_node', 'nodeid');


--tnt_config.interface 
SELECT "tnt_audit".Add_indexes('tnt_config','interface', 'id');
SELECT "tnt_audit".Add_indexes('tnt_config','interface', 'nodeid');

--tnt_config.protocol  
SELECT "tnt_audit".Add_indexes('tnt_config','protocol', 'id');

--tnt_config.node 
SELECT "tnt_audit".Add_indexes('tnt_config','node', 'id');
SELECT "tnt_audit".Add_indexes('tnt_config','node', 'vmhost_id');
SELECT "tnt_audit".Add_indexes('tnt_config','node', 'hardware_id');

--tnt_config.application 
SELECT "tnt_audit".Add_indexes('tnt_config','application', 'defaultprotocol');
SELECT "tnt_audit".Add_indexes('tnt_config','application', 'system_object');
SELECT "tnt_audit".Add_indexes('tnt_config','application', 'defaultportmin');
SELECT "tnt_audit".Add_indexes('tnt_config','application', 'defaultportmax');
SELECT "tnt_audit".Add_indexes('tnt_config','application', 'type');
SELECT "tnt_audit".Add_indexes('tnt_config','application', 'code');



--tnt_config.vmhost
SELECT "tnt_audit".Add_indexes('tnt_config','vmhost', 'id');
SELECT "tnt_audit".Add_indexes('tnt_config','vmhost', 'name');
 

--tnt_config.node_hardware
SELECT "tnt_audit".Add_indexes('tnt_config','node_hardware', 'id');

 



