create table if not exists tnt_config.optimization_profiles (id serial primary key, definition jsonb not null, sysdefault boolean not null default false);
truncate table tnt_config.optimization_profiles;
insert into tnt_config.optimization_profiles (definition) values ('{"name":"Single User: Conservative","components":[{"parameters":{"core_protection":"1","cpu_spike_throttle":"90","spike_last_time":"3"},"name":"CPUMachineWide"},{"parameters":{"user_reduced_priority":"2","ignore_foreground_peer":"1","foreground_priority":"4","sys_reduced_priority":"1","only_adjust_priority_below_sys":"4","enable_top_cpu_monitor":"1","top_cpus_throttle":"5","only_adjust_priority_below_user":"4","sys_cpu_core_spike":"60","user_cpu_core_spike":"90","priority_reduce_lasting_time":"3"},"name":"ProcessPerCore"},{"parameters":{"myself_priority":"3","new_process_exclude_seconds":"10","disable_optimizer":"0","disable_logStatus":"1","exclude_process_list":"wininit.exe,dwm.exe,winlogon.exe,mss.exe,csrss.exe,lsass.exe,userinit.exe,vds.exe,vhd.exe,dism.exe,rdpinit.exe,ctxinit.exe","exclude_path_list":"\\ProfileUnity,\\ProUX,\\Portability"},"name":"Optimizer"},{"parameters":{"disconnect_priority":"0"},"name":"OnDisconnectUser"},{"parameters":{"enable_trim_mem":"1","mem_trim_idletime_min":"15","mem_trim_only_user_process":"0","mem_trim_cpu_throttle_thousandth":"5"},"name":"IdleProcessTrim"}]}'::jsonb);
insert into tnt_config.optimization_profiles (definition) values ('{"name":"Single User: Agressive","components":[{"parameters":{"core_protection":"1","cpu_spike_throttle":"90","spike_last_time":"1"},"name":"CPUMachineWide"},{"parameters":{"user_reduced_priority":"1","ignore_foreground_peer":"1","foreground_priority":"4","sys_reduced_priority":"1","only_adjust_priority_below_sys":"4","enable_top_cpu_monitor":"1","top_cpus_throttle":"5","only_adjust_priority_below_user":"4","sys_cpu_core_spike":"30","user_cpu_core_spike":"70","priority_reduce_lasting_time":"5"},"name":"ProcessPerCore"},{"parameters":{"myself_priority":"3","new_process_exclude_seconds":"3","disable_optimizer":"0","disable_logStatus":"1","exclude_process_list":"wininit.exe,dwm.exe,winlogon.exe,smss.exe,csrss.exe,lsass.exe,userinit.exe,vds.exe,vhd.exe,dism.exe,rdpinit.exe,ctxinit.exe","exclude_path_list":"\\ProfileUnity,\\ProUX,\\Portability"},"name":"Optimizer"},{"parameters":{"disconnect_priority":"0"},"name":"OnDisconnectUser"},{"parameters":{"enable_trim_mem":"1","mem_trim_idletime_min":"15","mem_trim_only_user_process":"0","mem_trim_cpu_throttle_thousandth":"5"},"name":"IdleProcessTrim"}]}'::jsonb);
insert into tnt_config.optimization_profiles (definition) values ('{"name":"Multiuser: Recommended","components":[{"parameters":{"core_protection":"1","cpu_spike_throttle":"90","spike_last_time":"1"},"name":"CPUMachineWide"},{"parameters":{"user_reduced_priority":"1","ignore_foreground_peer":"0","foreground_priority":"4","sys_reduced_priority":"1","only_adjust_priority_below_sys":"4","enable_top_cpu_monitor":"1","top_cpus_throttle":"5","only_adjust_priority_below_user":"4","sys_cpu_core_spike":"30","user_cpu_core_spike":"70","priority_reduce_lasting_time":"6"},"name":"ProcessPerCore"},{"parameters":{"myself_priority":"3","new_process_exclude_seconds":"3","disable_optimizer":"0","disable_logStatus":"1","exclude_process_list":"wininit.exe,dwm.exe,winlogon.exe,smss.exe,csrss.exe,lsass.exe,userinit.exe,vds.exe,vhd.exe,dism.exe,rdpinit.exe,ctxinit.exe","exclude_path_list":"\\ProfileUnity,\\ProUX,\\Portability"},"name":"Optimizer"},{"parameters":{"disconnect_priority":"1"},"name":"OnDisconnectUser"},{"parameters":{"enable_trim_mem":"1","mem_trim_idletime_min":"5","mem_trim_only_user_process":"0","mem_trim_cpu_throttle_thousandth":"5"},"name":"IdleProcessTrim"}]}'::jsonb);
insert into tnt_config.optimization_profiles (definition) values ('{"name":"Multiuser: Density","components":[{"parameters":{"core_protection":"1","cpu_spike_throttle":"90","spike_last_time":"1"},"name":"CPUMachineWide"},{"parameters":{"user_reduced_priority":"1","ignore_foreground_peer":"0","foreground_priority":"4","sys_reduced_priority":"1","only_adjust_priority_below_sys":"4","enable_top_cpu_monitor":"1","top_cpus_throttle":"3","only_adjust_priority_below_user":"4","sys_cpu_core_spike":"25","user_cpu_core_spike":"50","priority_reduce_lasting_time":"9"},"name":"ProcessPerCore"},{"parameters":{"myself_priority":"3","new_process_exclude_seconds":"1","disable_optimizer":"0","disable_logStatus":"1","exclude_process_list":"wininit.exe,dwm.exe,winlogon.exe,smss.exe,csrss.exe,lsass.exe,userinit.exe,vds.exe,vhd.exe,dism.exe,rdpinit.exe,ctxinit.exe","exclude_path_list":"\\ProfileUnity,\\ProUX,\\Portability"},"name":"Optimizer"},{"parameters":{"disconnect_priority":"1"},"name":"OnDisconnectUser"},{"parameters":{"enable_trim_mem":"1","mem_trim_idletime_min":"5","mem_trim_only_user_process":"0","mem_trim_cpu_throttle_thousandth":"50"},"name":"IdleProcessTrim"}]}'::jsonb);
insert into tnt_config.optimization_profiles (definition) values ('{"name":"Single User: Recommended","defaultChoice":true,"components":[{"parameters":{"core_protection":"1","cpu_spike_throttle":"90","spike_last_time":"1"},"name":"CPUMachineWide"},{"parameters":{"user_reduced_priority":"1","ignore_foreground_peer":"1","foreground_priority":"4","sys_reduced_priority":"1","only_adjust_priority_below_sys":"4","enable_top_cpu_monitor":"1","top_cpus_throttle":"10","only_adjust_priority_below_user":"4","sys_cpu_core_spike":"50","user_cpu_core_spike":"80","priority_reduce_lasting_time":"4"},"name":"ProcessPerCore"},{"parameters":{"myself_priority":"3","new_process_exclude_seconds":"5","disable_optimizer":"0","disable_logStatus":"1","exclude_process_list":"wininit.exe,dwm.exe,winlogon.exe,smss.exe,csrss.exe,lsass.exe,userinit.exe,vds.exe,vhd.exe,dism.exe,rdpinit.exe,ctxinit.exe","exclude_path_list":"\\ProfileUnity,\\ProUX,\\Portability"},"name":"Optimizer"},{"parameters":{"disconnect_priority":"0"},"name":"OnDisconnectUser"},{"parameters":{"enable_trim_mem":"1","mem_trim_idletime_min":"15","mem_trim_only_user_process":"0","mem_trim_cpu_throttle_thousandth":"5"},"name":"IdleProcessTrim"}]}'::jsonb);
alter table tnt_config.optimization_profiles owner to impadmin;

update tnt_config.globaloptions set default_driver_options = default_driver_options || hstore('opt_activity_log', 'false') || hstore('opt_exclude_procs', 'wininit.exe,dwm.exe,winlogon.exe,smss.exe,csrss.exe,lsass.exe,userinit.exe,vds.exe,vhd.exe,dism.exe,rdpinit.exe,ctxinit.exe') || hstore('opt_exclude_paths', '\ProfileUnity,\ProUX,\Portability');
update tnt_config.policynode set driver_options = driver_options || hstore('opt_activity_log', 'false') || hstore('opt_exclude_procs', 'wininit.exe,dwm.exe,winlogon.exe,smss.exe,csrss.exe,lsass.exe,userinit.exe,vds.exe,vhd.exe,dism.exe,rdpinit.exe,ctxinit.exe') || hstore('opt_exclude_paths', '\ProfileUnity,\ProUX,\Portability');
