update tnt_config.optimization_profiles set definition = '{"name": "Single User: Conservative", "components": [{"name": "CPUMachineWide", "parameters": {"core_protection": "1", "spike_last_time": "2", "cpu_spike_throttle": "90", "smart_rule_core_protection": "0"}}, {"name": "ProcessPerCore", "parameters": {"top_cpus_throttle": "30", "sys_cpu_core_spike": "60", "foreground_priority": "4", "user_cpu_core_spike": "85", "sys_reduced_priority": "2", "user_reduced_priority": "2", "enable_top_cpu_monitor": "1", "ignore_foreground_peer": "1", "process_spike_lower_limit": "15", "priority_reduce_lasting_time": "3", "only_adjust_priority_below_sys": "4", "only_adjust_priority_below_user": "4"}}, {"name": "Optimizer", "parameters": {"myself_priority": "3", "disable_logStatus": "1", "disable_optimizer": "0", "terminate_list": "", "lower_list": "", "raise_list": "","exclude_exe_args":"svchost.exe TermService;svchost.exe ProfSvc","exclude_path_list": "\\ProfileUnity,\\ProUX,\\Portability,\\Citrix,\\VMware,\\Teradici,\\Amazon,\\AWS Tools,\\Microsoft RDInfra,\\WindowsAzure", "exclude_process_list": "wininit.exe,dwm.exe,winlogon.exe,smss.exe,csrss.exe,lsass.exe,userinit.exe,vds.exe,vhd.exe,dism.exe,rdpinit.exe,ctxinit.exe,explorer.exe", "new_process_exclude_seconds": "10"}}, {"name": "OnDisconnectUser", "parameters": {"disconnect_priority": "1"}}, {"name": "IdleProcessTrim", "parameters": {"enable_trim_mem": "1", "mem_trim_idletime_min": "15", "mem_trim_only_user_process": "0", "mem_trim_cpu_throttle_thousandth": "100"}}]}' where  definition->>'name' = 'Single User: Conservative';
update tnt_config.optimization_profiles set definition = '{"name": "Single User: Aggressive", "components": [{"name": "CPUMachineWide", "parameters": {"core_protection": "1", "spike_last_time": "1", "cpu_spike_throttle": "70", "smart_rule_core_protection": "1"}}, {"name": "ProcessPerCore", "parameters": {"top_cpus_throttle": "20", "sys_cpu_core_spike": "30", "foreground_priority": "4", "user_cpu_core_spike": "70", "sys_reduced_priority": "1", "user_reduced_priority": "1", "enable_top_cpu_monitor": "1", "ignore_foreground_peer": "0", "process_spike_lower_limit": "5", "priority_reduce_lasting_time": "5", "only_adjust_priority_below_sys": "4", "only_adjust_priority_below_user": "4"}}, {"name": "Optimizer", "parameters": {"myself_priority": "3", "disable_logStatus": "1", "disable_optimizer": "0", "terminate_list": "", "lower_list": "", "raise_list": "","exclude_exe_args":"svchost.exe TermService;svchost.exe ProfSvc","exclude_path_list": "\\ProfileUnity,\\ProUX,\\Portability,\\Citrix,\\VMware,\\Teradici,\\Amazon,\\AWS Tools,\\Microsoft RDInfra,\\WindowsAzure", "exclude_process_list": "wininit.exe,dwm.exe,winlogon.exe,smss.exe,csrss.exe,lsass.exe,userinit.exe,vds.exe,vhd.exe,dism.exe,rdpinit.exe,ctxinit.exe,explorer.exe", "new_process_exclude_seconds": "1"}}, {"name": "OnDisconnectUser", "parameters": {"disconnect_priority": "0"}}, {"name": "IdleProcessTrim", "parameters": {"enable_trim_mem": "1", "mem_trim_idletime_min": "5", "mem_trim_only_user_process": "0", "mem_trim_cpu_throttle_thousandth": "500"}}]}' where  definition->>'name' = 'Single User: Agressive';
update tnt_config.optimization_profiles set definition = '{"name": "Multi-user: Recommended", "components": [{"name": "CPUMachineWide", "parameters": {"core_protection": "1", "spike_last_time": "1", "cpu_spike_throttle": "80", "smart_rule_core_protection": "0"}}, {"name": "ProcessPerCore", "parameters": {"top_cpus_throttle": "20", "sys_cpu_core_spike": "30", "foreground_priority": "4", "user_cpu_core_spike": "70", "sys_reduced_priority": "1", "user_reduced_priority": "1", "enable_top_cpu_monitor": "1", "ignore_foreground_peer": "1", "process_spike_lower_limit": "5", "priority_reduce_lasting_time": "6", "only_adjust_priority_below_sys": "4", "only_adjust_priority_below_user": "4"}}, {"name": "Optimizer", "parameters": {"myself_priority": "3", "disable_logStatus": "1", "disable_optimizer": "0", "terminate_list": "", "lower_list": "", "raise_list": "","exclude_exe_args":"svchost.exe TermService;svchost.exe ProfSvc","exclude_path_list": "\\ProfileUnity,\\ProUX,\\Portability,\\Citrix,\\VMware,\\Teradici,\\Amazon,\\AWS Tools,\\Microsoft RDInfra,\\WindowsAzure", "exclude_process_list": "wininit.exe,dwm.exe,winlogon.exe,smss.exe,csrss.exe,lsass.exe,userinit.exe,vds.exe,vhd.exe,dism.exe,rdpinit.exe,ctxinit.exe,explorer.exe", "new_process_exclude_seconds": "3"}}, {"name": "OnDisconnectUser", "parameters": {"disconnect_priority": "1"}}, {"name": "IdleProcessTrim", "parameters": {"enable_trim_mem": "1", "mem_trim_idletime_min": "5", "mem_trim_only_user_process": "0", "mem_trim_cpu_throttle_thousandth": "250"}}]}' where  definition->>'name' = 'Multiuser: Recommended';
update tnt_config.optimization_profiles set definition = '{"name": "Multi-user: Aggressive Density", "components": [{"name": "CPUMachineWide", "parameters": {"core_protection": "1", "spike_last_time": "1", "cpu_spike_throttle": "70", "smart_rule_core_protection": "1"}}, {"name": "ProcessPerCore", "parameters": {"top_cpus_throttle": "20", "sys_cpu_core_spike": "30", "foreground_priority": "4", "user_cpu_core_spike": "50", "sys_reduced_priority": "1", "user_reduced_priority": "1", "enable_top_cpu_monitor": "1", "ignore_foreground_peer": "0", "process_spike_lower_limit": "5", "priority_reduce_lasting_time": "9", "only_adjust_priority_below_sys": "4", "only_adjust_priority_below_user": "4"}}, {"name": "Optimizer", "parameters": {"myself_priority": "3", "disable_logStatus": "1", "disable_optimizer": "0", "terminate_list": "", "lower_list": "", "raise_list": "","exclude_exe_args":"svchost.exe TermService;svchost.exe ProfSvc","exclude_path_list": "\\ProfileUnity,\\ProUX,\\Portability,\\Citrix,\\VMware,\\Teradici,\\Amazon,\\AWS Tools,\\Microsoft RDInfra,\\WindowsAzure", "exclude_process_list": "wininit.exe,dwm.exe,winlogon.exe,smss.exe,csrss.exe,lsass.exe,userinit.exe,vds.exe,vhd.exe,dism.exe,rdpinit.exe,ctxinit.exe,explorer.exe", "new_process_exclude_seconds": "3"}}, {"name": "OnDisconnectUser", "parameters": {"disconnect_priority": "1"}}, {"name": "IdleProcessTrim", "parameters": {"enable_trim_mem": "1", "mem_trim_idletime_min": "5", "mem_trim_only_user_process": "0", "mem_trim_cpu_throttle_thousandth": "500"}}]}' where  definition->>'name' = 'Multiuser: Density';
update tnt_config.optimization_profiles set definition = '{"name": "Single User: Recommended", "components": [{"name": "CPUMachineWide", "parameters": {"core_protection": "1", "spike_last_time": "1", "cpu_spike_throttle": "80", "smart_rule_core_protection": "0"}}, {"name": "ProcessPerCore", "parameters": {"top_cpus_throttle": "25", "sys_cpu_core_spike": "50", "foreground_priority": "4", "user_cpu_core_spike": "80", "sys_reduced_priority": "1", "user_reduced_priority": "1", "enable_top_cpu_monitor": "1", "ignore_foreground_peer": "1", "process_spike_lower_limit": "10", "priority_reduce_lasting_time": "4", "only_adjust_priority_below_sys": "4", "only_adjust_priority_below_user": "4"}}, {"name": "Optimizer", "parameters": {"myself_priority": "3", "disable_logStatus": "1", "disable_optimizer": "0", "terminate_list": "", "lower_list": "", "raise_list": "","exclude_exe_args":"svchost.exe TermService;svchost.exe ProfSvc","exclude_path_list": "\\ProfileUnity,\\ProUX,\\Portability,\\Citrix,\\VMware,\\Teradici,\\Amazon,\\AWS Tools,\\Microsoft RDInfra,\\WindowsAzure", "exclude_process_list": "wininit.exe,dwm.exe,winlogon.exe,smss.exe,csrss.exe,lsass.exe,userinit.exe,vds.exe,vhd.exe,dism.exe,rdpinit.exe,ctxinit.exe,explorer.exe", "new_process_exclude_seconds": "5"}}, {"name": "OnDisconnectUser", "parameters": {"disconnect_priority": "0"}}, {"name": "IdleProcessTrim", "parameters": {"enable_trim_mem": "1", "mem_trim_idletime_min": "15", "mem_trim_only_user_process": "0", "mem_trim_cpu_throttle_thousandth": "250"}}], "defaultChoice": true}' where  definition->>'name' = 'Single User: Recommended';
